FlagCreatorWindow = class( Turbine.UI.Lotro.Window );

function FlagCreatorWindow:Constructor(mapData, x, y)
	Turbine.UI.Lotro.Window.Constructor( self );
	
	for i, fla in ipairs(Preferences.custFlag or {}) do
		if(fla~=nil and fla.coorx==x and fla.coory==y) then
			self.duplicatedCoord = true;
			break;
		end
	end
	
	self:SetSize( 560, 340 );
	self:SetVisible(false);
	self:SetText( TRAD("Ajouter un drapeau sur la carte", "Add a flag on the map") );
	
	local width, height = Turbine.UI.Display.GetSize();	
	self:SetPosition((width-400)/2, (height-500)/2);
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end
	local contentLabel = Turbine.UI.Label();
	contentLabel:SetParent( self );
	contentLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);	
	contentLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	contentLabel:SetPosition( 5, 40 );
	contentLabel:SetSize(550, 30);
	local lbcoords = "";
	if(y<0) then lbcoords=""..(0-y).."N, "; else lbcoords=""..y.."S, "; end
	if(x<0) then lbcoords=lbcoords..(0-x).."W"; else lbcoords=lbcoords..x.."E"; end
	contentLabel:SetText( TRAD("Carte : "..mapData.name.."\nCoordonn\195\169es : "..lbcoords, "Map : "..mapData.name.."\nCoordinates : "..lbcoords));
	local borderBot = Turbine.UI.Label();
	borderBot:SetParent( self );
	borderBot:SetPosition(2, 74);
	borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBot:SetSize(self:GetWidth()-4, 3);
	borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");	
	local libelleLabel = Turbine.UI.Label();
	libelleLabel:SetParent( self );
	libelleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	libelleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	libelleLabel:SetPosition( 10, 235 );
	libelleLabel:SetSize(550, 44);
	libelleLabel:SetText( TRAD("Drapeau :", "Flag:"));
	
	self.libelleTextBox = self:BuildTextBoxArea(20, 105, 520, 24);
	self.libelleTextBox.TextChanged = function(sender, args)
		self:ValidateForm();
	end

	local flagLabel = Turbine.UI.Label();
	flagLabel:SetParent( self );
	flagLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	flagLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	flagLabel:SetPosition( 10, 85 );
	flagLabel:SetSize(550, 44);
	flagLabel:SetText( TRAD("Choix du drapeau :", "Flag name:"));
	
	local descriptionLabel = Turbine.UI.Label();
	descriptionLabel:SetParent( self );
	descriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	descriptionLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	descriptionLabel:SetPosition( 10, 150 );
	descriptionLabel:SetSize(550, 44);
	descriptionLabel:SetText( TRAD("Description : (optionnelle)", "Description: (optional)"));	
	self.descriptionTextBox = self:BuildTextBoxArea(20, 170, 520, 48);
	self.descriptionTextBox:SetMultiline(true);
	self.descriptionTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
	local descricrollBar = Turbine.UI.Lotro.ScrollBar();
    descricrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    descricrollBar:SetParent( self );
    descricrollBar:SetPosition( self.descriptionTextBox:GetLeft()+self.descriptionTextBox:GetWidth()+2, self.descriptionTextBox:GetTop() );
    descricrollBar:SetSize( 10, self.descriptionTextBox:GetHeight() );
	self.descriptionTextBox:SetVerticalScrollBar( descricrollBar );	
	self.descriptionTextBox:SetText(nil);
	
	self.validatebtn = Turbine.UI.Lotro.Button();
    self.validatebtn:SetParent( self );
    self.validatebtn:SetPosition( (self:GetWidth()-90)/2, self:GetHeight()-35);
    self.validatebtn:SetSize( 120, 18 );
    self.validatebtn:SetText(TRAD("Sauvegarder", "Save"));
	self.validatebtn:SetMouseVisible(true);
	self.validatebtn.Click = function( sender, args )
		Preferences.custFlagCnt = (Preferences.custFlagCnt or 0) + 1 ;
		local newFlag = {
			id="CUSTOMFLAG_"..Preferences.custFlagCnt;
			name=self.libelleTextBox:GetText();
			flagId = self.selectedIco.icoId;
			coorx=x;
			coory=y;
			mapId=mapData.map;
			description=self.descriptionTextBox:GetText();
		};
		if(Preferences.custFlag==nil) then Preferences.custFlag={}; end
		table.insert(Preferences.custFlag, newFlag);
		SavePreferences();
		minimap:AddCustomFlag(newFlag, true);
		warbandsDialog.warbandPane:AddCustomFlag(newFlag);
		self:SetVisible(false);
	end	
	
	self.errorLabel = Turbine.UI.Label();
	self.errorLabel:SetParent( self );
	self.errorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.errorLabel:SetForeColor(Turbine.UI.Color( 1, 0, 0));	
	self.errorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	self.errorLabel:SetPosition( 0, self:GetHeight()-35 );
	self.errorLabel:SetSize(self:GetWidth(), 28);
	
	self:ValidateForm();
	
	local seplen=6;
	local totlen = 10*32 + 9*seplen;
	local totleft = (self:GetWidth()-totlen)/2;
	for i = 1, 10 do
		local ico = Turbine.UI.Label();
		ico:SetParent( self );
		ico:SetPosition(totleft+(seplen+32)*(i-1), 260);
		ico:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		ico:SetSize(32, 32);
		ico.icoId = i;
		ico:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/cust_flag"..i.."_large.tga");
		ico.MouseClick = function( sender, args )
			self.counter = 0;
			self.lasttimer = nil;
			self.lastUpdate = nil;
			self.selectedIco = ico;
			self:SetWantsUpdates(true);
		end
		if(i==1) then self.selectedIco = ico; end
	end
	self.flagSelectIco = Turbine.UI.Label();
	self.flagSelectIco:SetParent( self );
	self.flagSelectIco:SetPosition(totleft-2, 260-2);
	self.flagSelectIco:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.flagSelectIco:SetSize(34, 34);
	self.flagSelectIco:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/flagselector.tga");
end

function FlagCreatorWindow:ValidateForm()
	local validation = true;
	if(self.duplicatedCoord == true) then
		validation = false;
		self.errorLabel:SetText(TRAD("Erreur: Un drapeau existe d\195\169j\195\160 \195\160 ces coordonn\195\169es.", "Error: A flag already exists at these coordinates."));
	elseif(self.libelleTextBox:GetText()==nil or string.len(self.libelleTextBox:GetText())<3) then
		validation = false;
		self.errorLabel:SetText(TRAD("Le nom du drapeau doit avoir au moins 3 caractères !", "The flag name must have at least 3 characters!"));
	end
	self.errorLabel:SetVisible(not validation);
	self.validatebtn:SetVisible(validation);
end

function FlagCreatorWindow:BuildTextBoxArea(x, y, weidth, height)
	local background = Turbine.UI.Label();
	background:SetParent( self );	
	background:SetSize(weidth, height);
	background:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	background:SetPosition( x, y );
	background:SetMouseVisible(false);	
	local textArea =  Turbine.UI.TextBox();
	textArea:SetParent( self );
	textArea:SetPosition( x+2, y+2 );
	textArea:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	textArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	textArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	textArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	textArea:SetSize(weidth-4, height-4);
	textArea:SetMultiline(false);
	textArea:SetZOrder(background:GetZOrder()+1);
	return textArea;
end

function FlagCreatorWindow:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();
	if ( self.lastUpdate~=nil and self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE  - delta=".. delta .." - value="..  math.floor(self.blinker:GetValue()) .."/".. 

	self.lastUpdate = currentTime;
	self.counter = self.counter + delta;
	local timer = math.floor(self.counter*100);
	nbPixels = (timer - (self.lasttimer or 0))*2;
	
	local dec = (self.flagSelectIco:GetLeft()-1)-self.selectedIco:GetLeft();
	
	if(dec==0 or (dec>0 and dec<nbPixels) or (dec<0 and 0-dec<nbPixels)) then
		self.flagSelectIco:SetLeft(self.selectedIco:GetLeft()-1);
		self:SetWantsUpdates(false);
	elseif(dec>0) then
		self.flagSelectIco:SetLeft(self.flagSelectIco:GetLeft()-nbPixels);
	elseif(dec<0) then
		self.flagSelectIco:SetLeft(self.flagSelectIco:GetLeft()+nbPixels);
	end
	self.lasttimer = timer;
end