MapNode = class( Turbine.UI.TreeNode );

function MapNode:Constructor(mapData, region)
	self.mapData = mapData;
	self.region = region;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );

	self.labelValue = Turbine.UI.Label();
	self.labelValue:SetParent( self );
	self.labelValue:SetSize( 260, 26 );
	self.labelValue:SetPosition( 51, 4 );
	self.labelValue:SetZOrder(100);
	self.labelValue:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelValue:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	self.labelValue:SetMouseVisible( false );
	self.labelValue:SetText(value);

	self.tagIcone = Turbine.UI.Control();
	self.tagIcone:SetParent( self );
	self.tagIcone:SetSize( 32, 32 );
	self.tagIcone:SetPosition( 2, 0 );
	self.tagIcone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.tagIcone:SetMouseVisible( false );	

	self.hightlight_middle = Turbine.UI.Label();
	self.hightlight_middle:SetParent( self );
	self.hightlight_middle:SetSize( self:GetWidth()-16, self:GetHeight() );
	self.hightlight_middle:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_middle:SetPosition( 8, 0 );
	self.hightlight_middle:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_middle.tga" );
	self.hightlight_middle:SetMouseVisible( false );
	self.hightlight_middle:SetVisible( false );
	self.hightlight_left = Turbine.UI.Label();
	self.hightlight_left:SetParent( self );
	self.hightlight_left:SetSize( 8, 36 );
	self.hightlight_left:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_left:SetPosition( 0, 0 );
	self.hightlight_left:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_left.tga" );
	self.hightlight_left:SetMouseVisible( false );	
	self.hightlight_left:SetVisible( false );	
	self.hightlight_right = Turbine.UI.Label();
	self.hightlight_right:SetParent( self );
	self.hightlight_right:SetSize( 8, 36 );
	self.hightlight_right:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_right:SetPosition( self:GetWidth()-8, 0 );
	self.hightlight_right:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_right.tga" );
	self.hightlight_right:SetMouseVisible( false );	
	self.hightlight_right:SetVisible( false );	

	self.SelectedChanged = function (o, e)
		self.hightlight_middle:SetVisible(self:IsSelected());
		self.hightlight_left:SetVisible(self:IsSelected());
		self.hightlight_right:SetVisible(self:IsSelected());
	end
	
	self:CreateIconeLabel();	
end

function MapNode:CreateIconeLabel()	
	local playerlvl = Filters.playerLevel or Turbine.Gameplay.LocalPlayer.GetInstance():GetLevel();
	playerlvl = tonumber(playerlvl);
	if(playerlvl>=self.mapData.lvl.min and playerlvl<=self.mapData.lvl.max) then
		self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/white.tga");
	elseif(playerlvl<self.mapData.lvl.min) then
		self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/purple.tga");	
		self.labelValue:SetForeColor( Turbine.UI.Color(150/255, 0, 0.5) );	
	elseif(playerlvl>self.mapData.lvl.max) then
		self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/grey.tga");
		self.labelValue:SetForeColor( Turbine.UI.Color(0.5, 0.5, 0.5) );	
	end
	local levels = "["..self.mapData.lvl.min.."-"..self.mapData.lvl.max.."]";
	if(self.mapData.lvl.min==self.mapData.lvl.max) then levels="["..self.mapData.lvl.max.."]"; end
	self.labelValue:SetText(self.mapData.name.."\n"..levels);
	if(self.mapData.p~=nil) then self.labelValue:SetText(self.labelValue:GetText().." "..self.mapData.p); end
end

function MapNode:UpdateWBNodeStatus(wbid, warbandLastKillDate, cdUp, alwaysOn, warbandsCooldown)
	--
end

function MapNode:AppliFilters(filters)
	local shouldshow = 1;
	if(filters.tab~=1 and filters.tab~=nil) then
		self:SetSize(312, 0);
		return 0;
	end
	local foundInName = (string.find(string.lower(self.mapData.name), filters.search)~=nil);
	local foundInPlace = false; if(self.mapData.p~=nil) then  foundInPlace=(string.find(string.lower(self.mapData.p), filters.search)~=nil); end
	local foundInFlagTitle = false; 
	local foundInFlagName = false; 
	if(self.mapData.flags~=nil) then
		for i, flags in pairs(self.mapData.flags) do
			if(foundInFlagTitle~=true) then foundInFlagTitle=(string.find(string.lower(flags.name or ""), filters.search)~=nil); end
			for j, flag in pairs(flags.flags or {}) do
				if(foundInFlagName~=true) then foundInFlagName=(string.find(string.lower(flag.l), filters.search)~=nil); end
			end
		end
	end
	if(filters.tab~=nil and filters.tab~=1) then
		shouldshow = 0;
	elseif(filters.lvlp5==true and Filters.playerLevel~=nil and (Filters.playerLevel<self.mapData.lvl.min-5 or Filters.playerLevel>self.mapData.lvl.max+5)) then
		shouldshow = 0;
	elseif(not foundInName and not foundInPlace and not foundInFlagTitle and not foundInFlagName) then
		shouldshow = 0;
	elseif(filters.targetEriador==false and self.mapData.region==1)then
		shouldshow = 0;
	elseif(filters.targetRhovanion==false and self.mapData.region==2)then
		shouldshow = 0;
	elseif(filters.targetGondor==false and self.mapData.region==3)then
		shouldshow = 0;
	elseif(filters.filtre_fanorien==false and self.mapData.region==4)then
		shouldshow = 0;		
	end
	if(shouldshow==0 and self.mapData.craft~=nil) then
		if(type(self.mapData.craft)=='number')then
			if(string.find(string.lower(craftLevels[self.mapData.craft].name), filters.search)~=nil) then
				shouldshow = 1;
			end
		else
			for i,fac in ipairs( self.mapData.craft) do
				if(string.find(string.lower(craftLevels[fac].name), filters.search)~=nil) then
					shouldshow = 1;
				end
			end
		end	
	end
	if(shouldshow==0 and self.mapData.faction~=nil) then
		if(type(self.mapData.faction)=='string')then
			if(string.find(string.lower(self.mapData.faction), filters.search)~=nil) then
				shouldshow = 1;
			end
		else
			for i,fac in ipairs(self.mapData.faction) do 
				if(string.find(string.lower(fac), filters.search)~=nil) then
					shouldshow = 1;
				end			
			end
		end		
	end
	if(shouldshow==0 and self.mapData.epic~=nil) then
		for i,epic in ipairs(self.mapData.epic) do 
			if(string.find(string.lower(epic[1]), filters.search)~=nil)then
				shouldshow = 1;
			else
				for j,eq in ipairs(epic[2]) do
					if(string.find(string.lower(eq), filters.search)~=nil)then
						shouldshow = 1;
					end
				end
			end
		end
	end		
	if(shouldshow==1) then
		self:SetSize(312, 35);
	else
		self:SetSize(312, 0);
	end
	self:CreateIconeLabel();
	return shouldshow;
end

function MapNode:ExpandAll()
	self:SetExpanded(true);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):ExpandAll();
	end
end

function MapNode:CollapseAll()
	self:SetExpanded(false);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):CollapseAll();
	end	
end