

import "WalmPlugins.WarbandsSlayer.src.QuickSlotGenericButton";
import "WalmPlugins.WarbandsSlayer.src.FlagCreatorWindow";

MiniMapViewer = class( Turbine.UI.Label );

function MiniMapViewer:Constructor(parent, canBeFocused, pos, dec)
	self.nativeW = 304;
	self.nativeH = 228;
	self.canBeFocused = canBeFocused;
	Turbine.UI.Label.Constructor( self );
	pos = pos or 1;
	dec = dec or 0;
	self:SetParent( parent );
	self.parent = parent;
	self:SetSize( self.nativeW, self.nativeH );
	self:SetPosition( 0, (self:GetHeight()+5)*(pos-1)+dec );
	self:SetZOrder(-99);
	self:SetMouseVisible( false );
	
	self.map = Turbine.UI.Label(); 
	self.map:SetParent( self );
	self.map:SetSize(300, 200);
	self.map:SetPosition(2, self.nativeH-200-2);
	self.map.MouseClick = function(parent, args)
		if(self.lastAreaData==nil) then return; end
		local zoomfactor = 1; if(not canBeFocused) then zoomfactor=0.5*(1+Preferences.mmap_zoom); end
		local x=self.lastAreaData.c.w + (self.lastAreaData.CoordsByPixelsX*args.X/zoomfactor); x = math.floor(x*10)/10;
		local y=self.lastAreaData.c.n + (self.lastAreaData.CoordsByPixelsY*args.Y/zoomfactor); y = math.floor(y*10)/10;
		local flagcreator = FlagCreatorWindow(self.lastAreaData, x, y);
		flagcreator:SetVisible(true);
		
	end
	self.localisationArray = {};

	self:BuildGUI(self.nativeW, self.nativeH, canBeFocused);

	self.switchPointsVisibility = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/filterButton.tga", "WalmPlugins/WarbandsSlayer/resources/minimap/filterButton2.tga");
	self.switchPointsVisibility:SetParent( self.filtersPane );
	self.switchPointsVisibility:SetPosition(10+self.filtersPane.ButtonDec+(0*(22+self.filtersPane.ButtonDec)), 2);
	self.switchPointsVisibility:SetMouseVisible( true );
	self.switchPointsVisibility.tooltip = GenericTooltip(self.switchPointsVisibility, TRAD("Filtrer les Repères découverts", "Filter the discovered landmarks"), TRAD("Permet d'afficher ou de masquer toutes les repères ou seulement ceux pas découvertes.", "Allows you to display or hide all landmarks or only those not discovered."));
	self.switchPointsVisibility.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.switchPointsVisibility.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end

	self.validateAllPoints = Turbine.UI.Label();
	self.validateAllPoints:SetParent( self.headerBack );
	self.validateAllPoints:SetPosition(8, 2);
	self.validateAllPoints:SetSize(16, 16);
	self.validateAllPoints:SetMouseVisible( true );
	self.validateAllPoints:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/validatepoi.jpg");
	self.validateAllPoints.tooltip = GenericTooltip(self.validateAllPoints, TRAD("Valider tous les repères", "Validate all landmarks"), TRAD("Permet de valider d'un coup tous les repères de la carte.", "Allows you to validate all the landmarks on the map at once."));
	self.validateAllPoints:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateAllPoints.MouseClick = function(sender, args)
		validateFunction = function(sender, args)
			if(PoiProgress==nil) then PoiProgress = {}; end;
			--if(PoiProgress[self.warband.id]==nil) then PoiProgress[self.warband.id]={}; end;
			local wbList = {};
			for i=1, table.getn(self.localisationArray), 1 do			
				local array = self.localisationArray[i];
				if(array.wbid~=nil and array.mData~=nil and array.mData.id~=nil) then
					if(PoiProgress[array.wbid]==nil) then PoiProgress[array.wbid]={}; end;
					PoiProgress[array.wbid][array.mData.id] = true;
					array:SetPushed(true);
					if(not ListContainsString(wbList, array.warband)) then
						table.insert(wbList, array.warband);
					end
				end
			end	
			for i,v in ipairs(wbList) do 
				warbandsDialog:AddCooldown(v, v.name, true, true); 
			end
			SavePOI(false);			
		end
		self.diag = CustomDialog("Confirmation", TRAD("Cette action va valider automatiquement tous les repères de la carte.\nEtes-vous certain de vouloir indiquer que tous les repères ont été accomplis ?", "This action will automatically validate all the landmarks on the map.\nAre you sure you want to indicate that all landmarks have been accomplished?"), TRAD("Oui", "Yes"), validateFunction, true, "CONFIRM_MAP_VALID");

	end

	self.validateQuest = Turbine.UI.Label();
	self.validateQuest:SetParent( self.headerBack );
	self.validateQuest:SetPosition(8, 2);
	self.validateQuest:SetSize(16, 16);
	self.validateQuest:SetMouseVisible( true );
	self.validateQuest:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/validatepoi.jpg");
	self.validateQuest.tooltip = GenericTooltip(self.validateQuest, TRAD("Indiquer la qu\195\170te comme faite", "Set the quest as done"), TRAD("Permet d'enregistrer la qu\195\170te comme faite, sans utiliser le detecteur auto.", "Allows you to set the quest as done, without using the auto detector."));
	self.validateQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateQuest.MouseClick = function(sender, args)
		warbandsDialog:AddCooldown(nil, self.warband.name, true, true);
	end

	self.locatePlayerQs = QuickSlotGenericButton(self.headerBack, 16, 16, 28, 2, TRAD("/e essaye de se localiser autour de ;loc", "/e tries to locate himself around ;loc"), "WalmPlugins/WarbandsSlayer/resources/minimap/playerposQuestion.tga");
	self.locatePlayerQs.tooltip = GenericTooltip(self.locatePlayerQs, TRAD("Voir la position du joueur", "See player position"), TRAD("Permet d'ajouter une marque sur la position du joueur.", "Add a mark on the position of the player."));

	self.addFlagQs = QuickSlotGenericButton(self.headerBack, 16, 16, 48, 2, TRAD("/e veut rajouter la position ;loc sur sa carte", "/e wants to add the position ;loc on his map"), "WalmPlugins/WarbandsSlayer/resources/minimap/addFlagBtn.tga");
	self.addFlagQs.tooltip = GenericTooltip(self.addFlagQs, TRAD("Ajouter un drapeau sur la carte", "Add a flag on the map"), TRAD("Permet d'ajouter un drapeau personnalisé sur la carte.", "Allows you to add a custom flag on the map."));

	self.playerMark = Turbine.UI.Label(); 
	self.playerMark:SetParent( self.map );
	self.playerMark:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.playerMark:SetSize(16, 16);
	self.playerMark:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/playerpos.tga");	
	self.playerMark:SetPosition(150, 100);
	self.playerMark.tooltip = GenericTooltip(self.playerMark, TRAD("Votre position", "Your position"));
	self.playerMark:SetZOrder(10000);
	self.playerMark:SetVisible(false);
	
	if(canBeFocused) then
		self.selfView = Turbine.UI.Label();
		self.selfView:SetParent( self.headerBack );
		self.selfView:SetPosition( self:GetWidth()-28, 3 );
		self.selfView:SetSize(16, 16);	
		self.selfView:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/enlarge.jpg");
		self.selfView:SetMouseVisible( true );
		self.selfView.tooltip = GenericTooltip(self.selfView, TRAD("Isoler la mini-map", "Isolate the minimap"), TRAD("Permet de n'afficher que la mini-map.", "Show the minimap on the seperate window."));
		self.selfView.MouseClick = function(sender, args)
			if(minimap:UpdateMap(self.warband, self.pos)~=nil) then
				warbandsDialog:SetVisible(false);
				minimap:SetVisible(true);
			end
		end
		self.allMarks = Turbine.UI.Label();
		self.allMarks:SetParent( self.headerBack );
		self.allMarks:SetPosition( self:GetWidth()-48, 3 );
		self.allMarks:SetSize(16, 16);	
		self.allMarks:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/layers.jpg");
		self.allMarks:SetMouseVisible( true );
		self.allMarks.tooltip = GenericTooltip(self.allMarks, TRAD("Montrer toutes les marques", "Show all landmarks"), TRAD("Permet d'afficher l'intégralité des marques de cette carte.", "Allows you to display all the landmarks of this map."));
		self.allMarks.MouseClick = function(sender, args)
			minimap:UpdateMap(self.warband, self.pos);	
			minimap:ShowAllMarks(self.warband, self.pos);
			warbandsDialog:SetVisible(false);
			minimap:SetVisible(true);		
		end
	else
		self.allMarks = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/layers.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/back.jpg");
		self.allMarks:SetParent( self.headerBack );
		self.allMarks:SetPosition(self:GetWidth()-48, 3 );
		self.allMarks:SetMouseVisible( true );
		self.allMarks.tooltip = GenericTooltip(self.allMarks, TRAD("Montrer toutes les marques", "Show all landmarks"), TRAD("Permet d'afficher l'intégralité des marques de cette carte.", "Allows you to display all the landmarks of this map."));
		self.allMarks.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		self.allMarks.Toggled = function(parent, pushed)
			if(pushed) then
				--local pos = self.pos;
				self.allMarks.wData = self.warband;
				self.allMarks.l = self.pos;
				self.allMarks.areaData = self.areaData;
				local map = self:ShowAllMarks(self.warband, self.pos);
				--if(map~=nil) then
					if(self.parent.nameLabel~=nil) then
						local areaData = GetMapData(self.warband.map, self.pos);
						if(self.warband.multipoi~=nil and self.pos~=nil) then
							areaData = GetMapData(self.warband.multipoi[self.pos].map, self.pos);
						end
						if(areaData~=nil) then
							self.parent.nameLabel:SetText(areaData.name );
						else
							self.parent.nameLabel:SetText(TRAD("Carte globale", "Global Map"));
						end
					end
					--self.pos = pos;
					self.allMarks:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/back.jpg");
				--end
			else
				self:UpdateMap(self.allMarks.wData, self.allMarks.l, nil, true);
				self.allMarks.wData = nil;
				self.allMarks.l = nil;			
			end
		end
	end
	self.filterChest = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/chest.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/chestX.jpg");
	self.filterChest:SetParent( self.filtersPane );
	self.filterChest:SetPosition(10+self.filtersPane.ButtonDec+1*(22+self.filtersPane.ButtonDec), 2);
	self.filterChest:SetMouseVisible( true );
	self.filterChest.tooltip = GenericTooltip(self.filterChest, TRAD("Filtrer les collectibles", "Filter collectibles"), TRAD("Permet d'afficher ou de masquer les repères des collectibles.", "Allows you to display or hide the collectibles landmarks."));
	self.filterChest.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.filterChest.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end		
	self.filterMob = SwitchLabel(13, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga", "WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flagX.tga");
	self.filterMob:SetParent( self.filtersPane );
	self.filterMob:SetPosition(10+self.filtersPane.ButtonDec+2*(22+self.filtersPane.ButtonDec), 2);
	self.filterMob:SetMouseVisible( true );
	self.filterMob.tooltip = GenericTooltip(self.filterMob, TRAD("Filtrer les Ennemis", "Filter Enemies"), TRAD("Permet d'afficher ou de masquer les marques des Menaces itinérantes et des Troupes de guerre.", "Allows you to show or hide the landmarks of Roving Threats and Warbands."));
	self.filterMob.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.filterMob.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end				

	self.filterCustFlag = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/cust_flag.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/cust_flagX.jpg");
	self.filterCustFlag:SetParent( self.filtersPane );
	self.filterCustFlag:SetPosition(10+self.filtersPane.ButtonDec+3*(22+self.filtersPane.ButtonDec), 2);
	self.filterCustFlag:SetMouseVisible( true );
	self.filterCustFlag.tooltip = GenericTooltip(self.filterCustFlag, TRAD("Filtrer les drapeaux personnalis\195\169s", "Filter customed flags"), TRAD("Permet d'afficher ou de masquer les drapeaux que vous avez cr\195\169\195\169s.", "Allows you to display or hide the flags created by you."));
	self.filterCustFlag.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.filterCustFlag.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end			
	self.filterFlag = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/flag.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/flagX.jpg");
	self.filterFlag:SetParent( self.filtersPane );
	self.filterFlag:SetPosition(10+self.filtersPane.ButtonDec+4*(22+self.filtersPane.ButtonDec), 2);
	self.filterFlag:SetMouseVisible( true );
	self.filterFlag.tooltip = GenericTooltip(self.filterFlag, TRAD("Filtrer les points d'Intérêt", "Filter points of interest"), TRAD("Permet d'afficher ou de masquer les repères des Points d'Intérêt.", "Allows you to display or hide the Points of Interest landmarks."));
	self.filterFlag.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.filterFlag.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end			
	-- self.filterGotomap = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/goto_map.tga", "WalmPlugins/WarbandsSlayer/resources/minimap/goto_mapX.tga");
	-- self.filterGotomap:SetParent( self.filtersPane );
	-- self.filterGotomap:SetPosition(10+self.filtersPane.ButtonDec+5*(22+self.filtersPane.ButtonDec), 2);
	-- self.filterGotomap:SetMouseVisible( true );
	-- self.filterGotomap.tooltip = GenericTooltip(self.filterGotomap, TRAD("Filtrer les liens", "Filter links"), TRAD("Permet d'afficher ou de masquer les repères vers d'autres cartes.", "Allows you to display or hide the links to others maps."));
	-- self.filterGotomap.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	-- self.filterGotomap.Toggled = function(parent, pushed)
		-- self:UpdateMarksVisibility();
	-- end		
	self.contextMenu = Turbine.UI.ContextMenu();
	menuItems = self.contextMenu:GetItems();
	local openMenuItem = Turbine.UI.MenuItem( TRAD("Supprimer le drapeau", "Remove the flag") );
    menuItems:Add( openMenuItem );
	openMenuItem.Click = function(sender, args)
		if(self.contextMenu.lastFlagClicked==nil) then return; end
		minimap:RemoveCustomFlag(self.contextMenu.lastFlagClicked.flagData);
		warbandsDialog.warbandPane:RemoveCustomFlag(self.contextMenu.lastFlagClicked.flagData);
	end
	self:Repack(self.nativeW, self.nativeH);
end

function MiniMapViewer:SetMapSize(mapLevel)
	if(mapLevel==nil) then mapLevel=1; end
	self.mapLevel = mapLevel;
	if(mapLevel<1 or mapLevel>3) then return nil; end
	local dir = "maps/"; self.map:SetSize(300, 200);
	if(mapLevel==2) then dir = "maps450/"; self.map:SetSize(450, 300);
	elseif(mapLevel==3) then dir = "maps600/"; self.map:SetSize(600, 400);
	end
	if(self.warband==nil) then return false; end
	local mapPath = "WalmPlugins/WarbandsSlayer/resources/";
	if(self.warband.map~=nil) then
		mapPath = mapPath..dir..self.warband.map;
	elseif(self.warband.multipoi~=nil) then
		mapPath = mapPath..dir..self.warband.multipoi[self.pos].map;
	end
	self.map:SetBackground(mapPath);
	local counter = 0;
	-- TODO recompute les markers
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		if(array.prefx~=nil and array.prefy~=nil) then
			array:SetPosition(array.prefx*0.5*(mapLevel+1), array.prefy*0.5*(mapLevel+1));
			counter = counter + 1;
		end
		-- local coords = self:ComputeDynCoords(array.flag, self.areaData, 7, mapLevel);
		-- if(coords~=nil) then
			-- array:SetPosition(coords.x,coords.y);
		-- end
	end
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE MAP : "..mapPath.."["..counter.."/"..table.getn(self.localisationArray).."]");
	return true;
end

function MiniMapViewer:UpdateMarksVisibility()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		--array:SetVisible(pushed==false or array.IsPushed==nil or not array:IsPushed());
		local showme = self.switchPointsVisibility:IsPushed()==false or array.IsPushed==nil or not array:IsPushed();
		if((array.enemyType==1 or array.enemyType==2) and self.filterMob~=nil and self.filterMob:IsPushed()) then 
			showme = false;
		end
		if(array.flag==true and self.filterFlag~=nil and self.filterFlag:IsPushed()) then 
			showme = false;
		end
		if(array.enemyType==3 and self.filterChest~=nil and self.filterChest:IsPushed()) then 
			showme = false;
		end
		if(array.enemyType=="GOTOMAP" and self.filterGotomap~=nil and self.filterGotomap:IsPushed()) then 
			showme = false;
		end
		if((array.enemyType=="CUSTOMFLAG" or array.enemyType==-2)and self.filterCustFlag~=nil and self.filterCustFlag:IsPushed()) then 
			showme = false;
		end
		array:SetVisible(showme);
	end	
end

function MiniMapViewer:BuildGUI(width, height, canBeFocused)
	self.headerBack = Turbine.UI.Label();
	self.headerBack:SetParent( self );
	self.headerBack:SetPosition(2, 2);
	--headerBack:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.headerBack:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) );
	--headerBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/header.jpg");
	
	self.filtersPane = Turbine.UI.Label();
	self.filtersPane:SetParent( self.headerBack );
	self.filtersPane:SetPosition(0, 0);
	self.filtersPane:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.filtersPane:SetSize(170, 24);
	local filtersPaneLeft = Turbine.UI.Label();
	filtersPaneLeft:SetParent( self.filtersPane );
	filtersPaneLeft:SetPosition(0, 0);
	filtersPaneLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	filtersPaneLeft:SetSize(6, 24);
	filtersPaneLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/FiltersTabLeft.jpg");	
	filtersPaneCenter = Turbine.UI.Label();
	filtersPaneCenter:SetParent( self.filtersPane );
	filtersPaneCenter:SetPosition(6, 0);
	filtersPaneCenter:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	filtersPaneCenter:SetSize(self.filtersPane:GetWidth()-6-6, 24);
	filtersPaneCenter:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/FiltersTabCenter.jpg");
	filtersPaneRight = Turbine.UI.Label();
	filtersPaneRight:SetParent( self.filtersPane );
	filtersPaneRight:SetPosition(self.filtersPane:GetWidth()-6, 0);
	filtersPaneRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	filtersPaneRight:SetSize(6, 24);
	filtersPaneRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/FiltersTabRight.jpg");	
	self.filtersPane.ButtonDec=(filtersPaneCenter:GetWidth()-5*22)/6;
	
	local borderTopLeft = Turbine.UI.Label();
	borderTopLeft:SetParent( self );
	borderTopLeft:SetPosition(0, 0);
	borderTopLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopLeft:SetSize(12, 12);
	borderTopLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_left.tga");	
	self.borderBotLeft = Turbine.UI.Label();
	self.borderBotLeft:SetParent( self );
	self.borderBotLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderBotLeft:SetSize(12, 12);
	self.borderBotLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_left.tga");
	
	self.borderTopRight = Turbine.UI.Label();
	self.borderTopRight:SetParent( self );
	self.borderTopRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderTopRight:SetSize(12, 12);
	self.borderTopRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_right.tga");
	self.borderTopRight:SetVisible(canBeFocused);
	
	self.borderBotRight = Turbine.UI.Label();
	self.borderBotRight:SetParent( self );
	self.borderBotRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderBotRight:SetSize(12, 12);
	self.borderBotRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_right.tga");
	self.borderSep = Turbine.UI.Label();
	self.borderSep:SetParent( self );
	self.borderSep:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderSep:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");		
	self.borderTop = Turbine.UI.Label();
	self.borderTop:SetParent( self );
	self.borderTop:SetPosition(12, 0);
	self.borderTop:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderTop:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");	
	self.borderBot = Turbine.UI.Label();
	self.borderBot:SetParent( self );
	self.borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");
	self.borderLeft = Turbine.UI.Label();
	self.borderLeft:SetParent( self );
	self.borderLeft:SetPosition(0, 12);
	self.borderLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_left.tga");		
	self.borderRight = Turbine.UI.Label();
	self.borderRight:SetParent( self );
	self.borderRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_right.tga");
end

function MiniMapViewer:Repack(width, height, modeWindow)
	self:SetSize(width, height);
	if(self.allMarks~=nil) then self.allMarks:SetLeft(self:GetWidth()-50); end
	self.filtersPane:SetLeft((self:GetWidth()-self.filtersPane:GetWidth())/2);
	self.headerBack:SetSize(width-4, self.nativeH-200-2-2-2);
	self.borderBotLeft:SetPosition(0, height-12);
	self.borderTopRight:SetPosition(width-12, 0);
	self.borderBotRight:SetPosition(width-12, height-12);
	self.borderSep:SetPosition(2, self.nativeH-200-2-2);
	self.borderSep:SetSize(width-4, 3);
	self.borderTop:SetSize(width-24, 3);
	self.borderBot:SetSize(width-24, 3);
	self.borderBot:SetPosition(12, height-3);
	if(modeWindow) then
		local zoomdec = 12;
		self.borderRight:SetSize(3, height-24-zoomdec);
		self.borderRight:SetPosition(width-3, 12+zoomdec);	
	else
		self.borderRight:SetPosition(width-3, 12);
		self.borderRight:SetSize(3, height-24);		
	end
	self.borderLeft:SetSize(3, height-24);
	self.borderLeft:SetPosition(0, 12);

end

function MiniMapViewer:ShowAllMarks(warband, pos)
	if(warband==nil) then return nil; end
	local wbfound=0;
	local wmap = warband.map;
	if(warband.multipoi~=nil and warband.multipoi[pos]~=nil) then wmap=warband.multipoi[pos].map; end
	local areaData = GetMapData(wmap, pos);
	for i, rData in pairs(wadData) do
		for j, aData in pairs(rData.areas) do
			for k, wData in pairs(aData.wads) do
				if(wData~=nil) then
					local wbMap = rData.map;
					if(aData.map~=nil) then wbMap=aData.map; end
					if(wData.map~=nil) then wbMap=wData.map; end
					if(wData.multipoi~=nil) then
						for l=1, table.getn(wData.multipoi), 1 do
							if(wData.multipoi[l].map==wmap) then
								self:UpdateMap(wData, l, areaData, false, wbfound>0, true);
								wbfound = wbfound + 1;
							end
						end
					elseif(wbMap~=nil and wbMap==wmap) then
						self:UpdateMap(wData, 1, nil, false, wbfound>0, true);
						wbfound = wbfound + 1;
					end
				end
			end
		end
	end
	if(wbfound==0) then
		self:UpdateMap(warband, 1, nil, false, false, true);
	end
	self:UpdateMarksVisibility();
	return wmap;
end

function MiniMapViewer:UpdateMap(warband, pos, areaData, showWbName, bypassClearMarks, layers)
	if(warband==nil) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>ERROR UpdateComponents gets nil warband</rgb>");
		return false;
	end
	local canEnlargeMap = true;
	if(areaData==nil) then
		if(warband.multipoi~=nil) then
			areaData = GetMapData(warband.multipoi[pos].map);
			self.lastAreaData = areaData;
			canEnlargeMap = warband.multipoi[pos].canEnlargeMap;
		else
			areaData = GetMapData(warband.map);
			self.lastAreaData = areaData;
			canEnlargeMap = warband.canEnlargeMap;
		end
	end
	if(self.selfView~=nil) then self.selfView:SetVisible(canEnlargeMap~=false); end
	self.allMarks:SetVisible(canEnlargeMap~=false);
	if(bypassClearMarks~=true) then
		self.warband = warband;
		self.pos = pos;
		if(self.localisationArray ~= nil) then
			while(table.getn(self.localisationArray) > 0) do
				local lab = table.remove(self.localisationArray);
				lab:SetPosition(0,0);
				lab:SetParent(nil);
				lab.tooltip = nil;
				lab = nil;
			end
		end
		if(areaData~=nil and areaData.flags~=nil) then
			for i, flags in ipairs(areaData.flags) do
				for j, flag in ipairs(flags.flags) do
					local coords = self:ComputeDynCoords(flag, areaData, 7);
					if(coords~=nil) then
						local mFlag = Turbine.UI.Label();
						mFlag.flag=true;
						mFlag:SetParent( self.map );
						mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
						mFlag:SetSize(20, 20);
						mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/flag.tga");	
						mFlag:SetPosition(coords.x,coords.y);
						mFlag.prefx=coords.x;
						mFlag.prefy=coords.y;
						table.insert(self.localisationArray, mFlag);
						mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..flag.c, flag.l);
						mFlag.tooltip:AddLayer(TRAD("Prouesse : ", "Deed : ")..flags.name, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
						mFlag.canflash = true;
						mFlag.name = flag.l;
						mFlag.description = flags.name;
						mFlag.Update = function(args)
							local delta = 0;
							local currentTime = Turbine.Engine.GetGameTime();
							if ( mFlag.lastUpdate~=nil and mFlag.lastUpdate > 0 ) then
								delta = currentTime - mFlag.lastUpdate;
							end
							mFlag.lastUpdate = currentTime;
							mFlag.counter = delta + mFlag.counter;
							local inc = mFlag.counter - math.floor(mFlag.counter);
							mFlag:SetVisible(inc<0.5);
							if(mFlag.counter>=5) then
								--mFlag:SetVisible(true);
								mFlag:SetVisible(not (mFlag.isOver==true and self.switchPointsVisibility:IsPushed()));
								mFlag:SetWantsUpdates(false);
							end					
						end
					end					
				end
			end
			for i, custFlag in ipairs(Preferences.custFlag or {}) do
				self:AddCustomFlag(custFlag);
			end
		end
	end
	if(self.localisationArray == nil) then self.localisationArray = {}; end
	
	if(warband.multipoi~=nil) then
		self.map:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.multipoi[pos].map);
	elseif(warband.map ~= nil) then
		self.map:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.map);
	end
	if(showWbName) then
		if(self.parent~=nil and self.parent.nameLabel~=nil) then 
			self.parent.nameLabel:SetText( warband.name );
		end
	end
	local size = 16;
	if(warband.enemyType == 2) then
		self.switchPointsVisibility:SetVisible(layer~=false);
		self.validateQuest:SetVisible(true);
		self.validateAllPoints:SetVisible(false);
		if(warband.rovingThreatData~=nil and warband.rovingThreatData.loc~=nil) then
			for id=1, table.getn(warband.rovingThreatData.loc), 1 do
				local mData = warband.rovingThreatData.loc[id];
				-- k.m  k.c  k.l
				local coords = self:ComputeDynCoords(mData, areaData, 7);
				if(coords~=nil) then
					local mFlag = nil;
					if(layers==true) then mFlag=self:GetFlagFromArray(coords.x, coords.y); end
					if(mFlag==nil) then
						mFlag = Turbine.UI.Label(); 
						mFlag:SetParent( self.map );
						mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
						mFlag:SetSize(13, 16);
						mFlag.flag = mData;
						mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga");	
						mFlag:SetPosition(coords.x,coords.y);
						mFlag.prefx=coords.x;
						mFlag.prefy=coords.y;
						table.insert(self.localisationArray, mFlag);
						mFlag.enemyType = 2;
						mFlag.wbid = warband.id;
						mFlag.warband = warband;
						mFlag.name=warband.name;
						mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..mData.c, mData.l or nil);
						mFlag.tooltip:AddLayer(TRAD("Point de spawn aléatoire de :", "Random spawn point of :"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
						mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
					else
						mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
					end
				end
			end
		else
			Turbine.Shell.WriteLine("<rgb=#FF0000>FORMAT ERROR : wb="..warband.id.." => warband.rovingThreatData.loc not found");
		end
	elseif((warband.poi~=nil or warband.multipoi~=nil)) then
		self.switchPointsVisibility:SetVisible(true);
		self.validateAllPoints:SetVisible(true);
		self.validateQuest:SetVisible(false);
		local backgroundOn = "WalmPlugins/WarbandsSlayer/resources/minimap/chest.jpg";
		local backgroundOff = "WalmPlugins/WarbandsSlayer/resources/minimap/chestFound.jpg";
		
		if(warband.ico~=nil) then
			backgroundOn = "WalmPlugins/WarbandsSlayer/resources/minimap/"..warband.ico;
			backgroundOff = "WalmPlugins/WarbandsSlayer/resources/minimap/poiok.jpg";
			size = 12;
		end	
		local poiarray = warband.poi;
		if(warband.multipoi~=nil) then
			poiarray = warband.multipoi[pos].poi;
			if(warband.multipoi[pos].map~=nil) then 
				areaData = GetMapData(warband.multipoi[pos].map); 
			end
			self.map:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.multipoi[pos].map);
		end
		for id=1, table.getn(poiarray), 1 do
			local mData = poiarray[id];
			local coords = self:ComputeDynCoords(mData, areaData, size);
			if(coords~=nil) then
				local mFlag = SwitchLabel(size, size, backgroundOn, backgroundOff); 
				mFlag:SetParent( self.map );
				table.insert(self.localisationArray, mFlag);
				mFlag:SetPosition(coords.x,coords.y);
				mFlag.prefx=coords.x;
				mFlag.prefy=coords.y;
				mFlag.mData = mData;
				mFlag.wbid = warband.id;
				mFlag.canflash = true;
				mFlag.warband = warband;
				mFlag.enemyType = warband.enemyType;
				mFlag.Toggled = function(parent, pushed)
					if(PoiProgress==nil) then PoiProgress = {}; end;
					if(PoiProgress[warband.id]==nil) then PoiProgress[warband.id]={}; end;
					PoiProgress[warband.id][mData.id] = pushed;
					SavePOI(false);
					local completed = CheckPOICompletion(warband);
					warbandsDialog:AddCooldown(warband, warband.name, completed, completed);
					mFlag.lastUpdate = nil;
					mFlag.counter = 0;
					mFlag:SetWantsUpdates(mFlag.pushed==true and self.switchPointsVisibility:IsPushed()==true);
					warbandsDialog:FocusOnWarband(warband, mData);
				end
				local alreadyFound = false;
				if(PoiProgress~=nil and PoiProgress[warband.id]~=nil and PoiProgress[warband.id][mData.id]~=nil)then
					alreadyFound = PoiProgress[warband.id][mData.id];
				end
				mFlag.name=warband.name;
				mFlag:SetPushed(alreadyFound);				
				mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..mData.c, mData.l);
				mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
				if(alreadyFound)then
					mFlag.tooltip:AddLayer(TRAD("Déjà trouvé !", "Already found"), Turbine.UI.Color(0, 1, 0), nil, Turbine.UI.Lotro.Font.Verdana14);
				end
				mFlag.Update = function(args)
					local delta = 0;
					local currentTime = Turbine.Engine.GetGameTime();
					if ( mFlag.lastUpdate~=nil and mFlag.lastUpdate > 0 ) then
						delta = currentTime - mFlag.lastUpdate;
					end

					mFlag.lastUpdate = currentTime;
					mFlag.counter = delta + mFlag.counter;
					local inc = mFlag.counter - math.floor(mFlag.counter);
					mFlag:SetVisible(inc<0.5);
					if(mFlag.counter>=5) then
						mFlag:SetVisible(true);
						mFlag:SetWantsUpdates(false);
					end					
				end
			end
		end
	elseif(warband.mapPos~=nil or warband.loc~=nil) then
		local mFlag = nil;
		local coords = nil;
		if(warband.mapPos~=nil) then
			coords = self:ComputeDynCoords(warband.mapPos, nil, size);
		elseif(warband.loc~=nil) then
			coords = self:ComputeDynCoords(warband, areaData, size);			
		end		
		if(layers==true and coords~=nil) then mFlag=self:GetFlagFromArray(coords.x, coords.y); end
		if(mFlag==nil) then
			local mFlag = Turbine.UI.Label(); 
			mFlag:SetParent( self.map );
			mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			mFlag:SetSize(13, 16);
			mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga");
			mFlag.wbid = warband.id;
			mFlag.enemyType = warband.enemyType;
			mFlag.warband = warband;			
			table.insert(self.localisationArray, mFlag);
			mFlag.name=warband.name;
			mFlag:SetPosition(coords.x, coords.y);
			mFlag.prefx=coords.x;
			mFlag.prefy=coords.y;
			mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..(warband.c or warband.loc), warband.l or nil);
			mFlag.tooltip:AddLayer(TRAD("Point de spawn de :", "Spawn point of :"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
			mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		else
			mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		end
		self.switchPointsVisibility:SetVisible(layer~=false);
		self.validateAllPoints:SetVisible(false);
		self.validateQuest:SetVisible(true);
	end
	if(bypassClearMarks~=true) then
		self.locatePlayerQs:SetVisible(areaData~=nil and areaData.c~=nil);
		self.locatePlayerQs.mask:SetVisible(areaData~=nil and areaData.c~=nil);	
	end
	if(not self.canBeFocused) then
		self:SetMapSize(Preferences.mmap_zoom);
	end
	return true;
end

function MiniMapViewer:OnPOIUpdated(wad, poi)
	--if(self.warband==nil or wad.id ~= self.warband.id) then return; end
	if(wad==nil or poi==nil) then return; end
	for i,flag in ipairs(self.localisationArray) do
		--Turbine.Shell.WriteLine("<rgb=#FF5CCD>CMP "..wb.id.."=="..flag.wbid.."  AND "..poi.id.."="..flag.mData.id..")</rgb>");
		if(flag.wbid==wad.id and flag.mData~=nil and flag.mData.id==poi.id) then
			flag:SetPushed(PoiProgress~=nil and PoiProgress[flag.wbid]~=nil and PoiProgress[flag.wbid][flag.mData.id]==true);
			if(flag.canflash==true) then
				flag.lastUpdate = nil;
				flag.counter = 0;
				flag.isOver = true;
				flag:SetWantsUpdates(flag.pushed==true and self.switchPointsVisibility:IsPushed()==true);
			end
		end
	end
end

function MiniMapViewer:OnSearch(search)
	search = string.lower(search);
	if(search==nil or string.len(search)<4) then return; end
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>SEARCHING : "..search);
	for i,flag in ipairs(self.localisationArray) do
		--Turbine.Shell.WriteLine("<rgb=#FFFFFF>with : "..(flag.name or "???"));
		if((flag.name~=nil and string.find(string.lower(flag.name), search)) or (flag.description~=nil and string.find(string.lower(flag.description), search))) then
			--Turbine.Shell.WriteLine("<rgb=#FF5CCD>FOUND : "..flag.name);
			if(flag.canflash==true) then
				flag.lastUpdate = nil;
				flag.counter = 0;
				flag:SetWantsUpdates(true);
			end
		end
	end
end

function MiniMapViewer:ComputeDynCoords(mData, areaData, border, zoom)
	local maxWidth = 300;
	local maxHeight = 200;
	local zoomFactor = 1;
	if(zoom==2) then maxWidth=450; maxHeight=300; zoomFactor=1.5;
	elseif(zoom==3) then maxWidth=600; maxHeight=400; zoomFactor=2.0; end

	-- if(mData.x~=nil and mData.y~=nil) then
		-- return {x=mData.x-6, y=mData.y-8};
	-- elseif(mData.m~=nil) then
		-- return {x=mData.m.x-6, y=mData.m.y-8};
	-- elseif((mData.c~=nil or mData.loc) and areaData~=nil) then
	if((mData.c~=nil or mData.loc) and areaData~=nil) then
		local parsingCoord = (mData.c or mData.loc);
		local a, b, y1, y2, dir_y, x1, x2, dir_x = string.find(parsingCoord, "(%d*)%.(%d)([NnSs]), (%d*)%.(%d)([OoWwEe])");
		if(x1==nil or x2==nil or dir_x==nil or y1==nil or y2==nil or dir_y==nil) then
			if(Preferences.debug==true) then 
				Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords parsing ERROR : WB="..(self.warband.id or "UNKNOWN").." id="..(mData.id or "??"));
			end
			return nil;
		end
		local cx = tonumber(x1)+tonumber(x2)/10;
		local cy = tonumber(y1)+tonumber(y2)/10;
		if(dir_y=="N" or dir_y=="n") then cy=0-cy; end		
		if(dir_x~="E" and dir_x~="e") then cx=0-cx; end
		local result = {x=math.floor((cx-areaData.c.w)/(areaData.CoordsByPixelsX*zoomFactor))-6, y=math.floor((cy-areaData.c.n)/(areaData.CoordsByPixelsY*zoomFactor))-8};
		if(result.x<0) then result.x=-2 end
		if(result.x>maxWidth-border) then result.x=maxWidth-border-2 end
		if(result.y<0) then result.y=-2 end
		if(result.y>maxHeight-border) then result.y=maxHeight-border-2 end
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..mData.c.." ["..areaData.w..":"..areaData.n.."] ["..areaData.e..":"..areaData.s.."]");
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>areaData.CoordsByPixelsX="..areaData.CoordsByPixelsX.."    areaData.CoordsByPixelsY="..areaData.CoordsByPixelsY);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>Point = "..cx..":"..cy.." => "..(cx-areaData.w)..":"..(cy-areaData.n).." => "..result.x..":"..result.y);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>=> "..result.x..":"..result.y);
		return result;
	-- Décallé en priorité basse
	elseif(mData.x~=nil and mData.y~=nil) then
		return {x=mData.x-6, y=mData.y-8};
	elseif(mData.m~=nil) then
		return {x=mData.m.x-6, y=mData.m.y-8};
	elseif(Preferences.debug==true) then 
		Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords global ERROR : WB="..(self.warband.id or "??").." id="..(mData.id or "??"));
	end
end

function MiniMapViewer:GetFlagFromArray(x, y)
	if(self.localisationArray==nil) then 
		return nil; 
	end
	for i,flag in ipairs(self.localisationArray) do
		if(flag:GetLeft()==x and flag:GetTop()==y) then return flag; end
	end
	return nil;
end

function MiniMapViewer:AddCustomFlag(newFlag, newBorn)
	if(newFlag==nil or self.lastAreaData==nil or self.lastAreaData.map~=newFlag.mapId) then return; end
	local coords = {};
	--local aData = GetMapData(map);
	local aData = self.lastAreaData;
	if(aData==nil or aData.c==nil) then return; end
	local zoomFactor = 1; if(not self.canBeFocused and newBorn) then zoomFactor=0.5*(1+Preferences.mmap_zoom); end
	if(newFlag.coorx<aData.c.w) then coords.x=-10; 
	elseif(newFlag.coorx>aData.c.e) then coords.x = self.map:GetWidth()-10; 
	else coords.x = (newFlag.coorx-aData.c.w)/aData.CoordsByPixelsX*zoomFactor-10; end
	if(newFlag.coory<aData.c.n) then coords.y = -10; 
	elseif(newFlag.coory>aData.c.s) then coords.y=self.map:GetHeight()-10; 
	else coords.y=(newFlag.coory-aData.c.n)/aData.CoordsByPixelsY*zoomFactor-10; end
	
	local mFlag = Turbine.UI.Label(); 
	mFlag:SetParent( self.map );
	mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	mFlag:SetSize(20, 20);
	mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/cust_flag"..newFlag.flagId..".tga");
	mFlag.enemyType = "CUSTOMFLAG";
	mFlag.flagData = newFlag;
	mFlag.canflash = true;
	mFlag.name=newFlag.name;
	table.insert(self.localisationArray, mFlag);
	mFlag.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Right) then
			self.contextMenu.lastFlagClicked = mFlag;
			self.contextMenu:ShowMenu();
		end
	end	
	mFlag.Update = function(args)
		local delta = 0;
		local currentTime = Turbine.Engine.GetGameTime();
		if ( mFlag.lastUpdate~=nil and mFlag.lastUpdate > 0 ) then
			delta = currentTime - mFlag.lastUpdate;
		end

		mFlag.lastUpdate = currentTime;
		mFlag.counter = delta + mFlag.counter;
		local inc = mFlag.counter - math.floor(mFlag.counter);
		mFlag:SetVisible(inc<0.5);
		if(mFlag.counter>=5) then
			mFlag:SetVisible(not (mFlag.isOver==true and self.switchPointsVisibility:IsPushed()));
			mFlag:SetWantsUpdates(false);
		end					
	end
	mFlag:SetPosition(coords.x, coords.y);
	mFlag.prefx=coords.x;
	mFlag.prefy=coords.y;	
	mFlag.tooltip = GenericTooltip(mFlag, newFlag.name, newFlag.description);
	local rebCoo = ""; if(newFlag.coory<0) then rebCoo=""..(0-newFlag.coory).."N, "; else rebCoo=""..(newFlag.coory).."S, "; end
	if(newFlag.coorx<0) then rebCoo=rebCoo..(0-newFlag.coorx)..TRAD("O","W"); else rebCoo=rebCoo..(newFlag.coorx).."E"; end
	mFlag.tooltip:AddLayer(TRAD("Coordonn\195\169es : ", "Coordinates : ")..rebCoo, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
	mFlag.tooltip:AddLayer(TRAD("Clic droit pour supprimer", "right click to remove"), Turbine.UI.Color(0.80,0.80,0.80), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
end

function MiniMapViewer:RemoveCustomFlag(flag)
	for i, fla in ipairs(Preferences.custFlag) do
		if(fla~=nil and fla.coorx==flag.coorx and fla.coory==flag.coory) then
			table.remove(Preferences.custFlag, i);
			SavePreferences();
			break;
		end
	end
	
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		if(self.contextMenu.lastFlagClicked==nil) then return; end
		if(array.flagData~=nil and array.flagData.coorx==flag.coorx and array.flagData.coory==flag.coory) then
			local lab = table.remove(self.localisationArray, i);
			lab:SetPosition(0,0);
			lab:SetParent(nil);
			lab.tooltip = nil;
			lab = nil;
			break;
		end
	end
end

function MiniMapViewer:UpdatePlayerPosition(x, y)
	if(self.warband==nil) then return; end 
	local map = self.warband.map;
	if(self.warband.multipoi~=nil and self.pos~=nil) then
		map = self.warband.multipoi[self.pos].map;
	end
	
	local aData = GetMapData(map);
	if(aData~=nil and aData.c~=nil) then
		if(x<aData.c.w) then self.playerMark:SetLeft(-8); 
		elseif(x>aData.c.e) then self.playerMark:SetLeft(self.map:GetWidth()-8); 
		else self.playerMark:SetLeft((x-aData.c.w)/aData.CoordsByPixelsX*(0.5*((self.mapLevel or 1)+1))-8); end
		if(y<aData.c.n) then self.playerMark:SetLeft(-8); 
		elseif(y>aData.c.s) then self.playerMark:SetTop(self.map:GetHeight()-8); 
		else self.playerMark:SetTop((y-aData.c.n)/aData.CoordsByPixelsY*(0.5*((self.mapLevel or 1)+1))-8); end
		self.lastUpdate = nil;
		self.counter = 0;
		self:SetWantsUpdates(true);
	end
	self.playerMark:SetVisible(aData~=nil);
end

function MiniMapViewer:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();
	if ( self.lastUpdate~=nil and self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;
	self.counter = delta + self.counter;
	local inc = self.counter - math.floor(self.counter);
	self.playerMark:SetVisible(inc<0.5);
	if(self.counter>=5) then
		self.playerMark:SetVisible(false);
		self:SetWantsUpdates(false);
	end
end

function MiniMapViewer:Unload()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		array.tooltip:Free();
		array.tooltip = nil;
		array = nil;
	end
end