
import "WalmPlugins.WarbandsSlayer.src.MiniMapZoomer";

MiniMapWindow = class( Turbine.UI.Window );

function MiniMapWindow:Constructor(parent)
	Turbine.UI.Window.Constructor( self );
	
	self:SetVisible(false);
	self:SetText( "Minimap :)" );
	
	if(Preferences.minimap_x==nil or Preferences.minimap_y==nil) then
		Preferences.minimap_x = Preferences.main_x;
		Preferences.minimap_y = Preferences.main_y;
	end
	
	self:SetPosition(Preferences.minimap_x, Preferences.minimap_y);
	
	self.parent = parent;
	
	self.PositionChanged = function(sender, args)
		Preferences.minimap_x, Preferences.minimap_y = self:GetPosition();
		SavePreferences();
	end	
	
	local listenerResizer = function(mapLevel)
		if(self.map:SetMapSize(mapLevel)) then
			if(self.map.map:GetWidth()<self.mapContainer:GetWidth()) then
				self:SetWidth(self.map.map:GetWidth()+38);
				Preferences.mmapwindow_width = self.map.map:GetWidth()+38;
			end
			if(self.map.map:GetHeight()<self.mapContainer:GetHeight()) then
				self:SetHeight(self.map.map:GetHeight()+58);
				Preferences.mmapwindow_height = self.map.map:GetHeight()+58;
			end
			self:UpdateResponsive();
			SavePreferences();
		end
	end
	self.zoomer = MiniMapZoomer(listenerResizer);
	self.zoomer:SetParent( self );
	
	self.resizer = Turbine.UI.Label();
	self.resizer:SetParent( self );
	self.resizer:SetSize(30, 30);
	self.resizer:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.resizer:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/panel_resize_icon.tga");
	self.resizer:SetZOrder(self:GetZOrder()+10);
	self.resizer.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
		end
	end
	self.resizer.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				sender.dragging = false;
			end
			Preferences.mmapwindow_height = self:GetHeight();
			Preferences.mmapwindow_width = self:GetWidth();
			SavePreferences();
		end
	end
	self.resizer.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local height = self:GetHeight() + args.Y - sender.dragStartY;
			local width = self:GetWidth() + args.X - sender.dragStartX;
			if(height<200+58) then height=200+58; end
			if(height>58+200*(0.5*(self.zoomer:GetZoomLevel() + 1))) then 
				height = 58+200*(0.5*(self.zoomer:GetZoomLevel() + 1));
			end
			self:SetHeight(height);
			if(width<300+38) then width=300+38; end
			if(width>38+300*(0.5*(self.zoomer:GetZoomLevel() + 1))) then 
				width = 38+300*(0.5*(self.zoomer:GetZoomLevel() + 1));
			end
			self:SetWidth(width);
			self:UpdateResponsive();
		end
	end		
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end
	self.map = MiniMapViewer(self, false);
	self.map:SetParent(nil);
	self.map.headerBack:SetParent(self);
	self.map.headerBack:SetPosition( 2, 34 );
	if(Preferences~=nil and Preferences.mmapwindow_width~=nil and Preferences.mmapwindow_height~=nil) then
		self:SetSize(Preferences.mmapwindow_width, Preferences.mmapwindow_height);
	else
		self:SetSize(338, 258);
	end
	
	self.mapContainer = Turbine.UI.Label();
	self.mapContainer:SetParent( self );
	self.mapContainer:SetPosition(2, 32+self.map.headerBack:GetHeight()+2);
	self.mapContainer:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.map.map:SetParent(self.mapContainer);
	self.map.map:SetPosition(0, 0);
	self.vscrollBar = Turbine.UI.Lotro.ScrollBar();
    self.vscrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    self.vscrollBar:SetParent( self.mapContainer );
	self.vscrollBar.ValueChanged = function()
		self.map.map:SetTop(self.vscrollBar:GetValue()/100*(self.mapContainer:GetHeight()-self.map.map:GetHeight()));
	end
	self.hscrollBar = Turbine.UI.Lotro.ScrollBar();
    self.hscrollBar:SetOrientation( Turbine.UI.Orientation.Horizontal );
    self.hscrollBar:SetParent( self.mapContainer );
	self.hscrollBar.ValueChanged = function()
		self.map.map:SetLeft(self.hscrollBar:GetValue()/100*(self.mapContainer:GetWidth()-self.map.map:GetWidth()));
	end
	
	self.borderTop = Turbine.UI.Label();
	self.borderTop:SetParent( self );
	self.borderTop:SetPosition(12, 32);
	self.borderTop:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderTop:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");
	local borderTopLeft = Turbine.UI.Label();
	borderTopLeft:SetParent( self );
	borderTopLeft:SetPosition(0, 32);
	borderTopLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopLeft:SetSize(12, 12);
	borderTopLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_left.tga");
	self.borderSep = Turbine.UI.Label();
	self.borderSep:SetParent( self );
	self.borderSep:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderSep:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");	
	self.borderSep:SetPosition(2, 36+self.map.headerBack:GetHeight());
	self.borderLeft = Turbine.UI.Label();
	self.borderLeft:SetParent( self );
	self.borderLeft:SetPosition(0, 32+12);
	self.borderLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_left.tga");	
	self.borderBotLeft = Turbine.UI.Label();
	self.borderBotLeft:SetParent( self );
	self.borderBotLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderBotLeft:SetSize(12, 12);
	self.borderBotLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_left.tga");
	self.borderBot = Turbine.UI.Label();
	self.borderBot:SetParent( self );
	self.borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");
	self.borderRight = Turbine.UI.Label();
	self.borderRight:SetParent( self );
	self.borderRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.borderRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_right.tga");		
	
	self.titleLeft = Turbine.UI.Label();
	self.titleLeft:SetParent( self );
	self.titleLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.titleLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/base_box_titlebar_left.tga");
	self.titleRight = Turbine.UI.Label();
	self.titleRight:SetParent( self );
	self.titleRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.titleRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/base_box_titlebar_right.tga");	
	self.titleCenter = Turbine.UI.Label();
	self.titleCenter:SetParent( self );
	self.titleCenter:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.titleCenter:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/base_box_titlebar_center.tga");
	self.nameLabel = Turbine.UI.Label();
	self.nameLabel:SetParent( self );
	self.nameLabel:SetFont( Turbine.UI.Lotro.Font.TrajanPro13 );		
	self.nameLabel:SetForeColor( Turbine.UI.Color(0.9, 0.9, 0.2) );
	self.nameLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.nameLabel:SetMouseVisible(false);
	
	self.closeBtn = Turbine.UI.Label();
	self.closeBtn:SetParent( self );
	self.closeBtn:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble/close.jpg" );
	self.closeBtn:SetSize(16, 16);
	self.closeBtn.MouseClick = function( sender, args )
		self:Close();
		if(parent~=nil) then
			--self.parent:UpdateMap(self.warband);
			parent.treeView:SelectedNodeChanged();
			parent:SetVisible(true);
		end
	end	
	self.titleCenter.MouseDown = function( sender, args )
		if(args.Button == Turbine.UI.MouseButton.Left) then
			sender.dragStartX = args.X;
			sender.dragStartY = args.Y;
			sender.dragging = true;
			sender.dragged = false;
		end
	end
	self.titleCenter.MouseUp = function( sender, args )
		if (args.Button == Turbine.UI.MouseButton.Left) then			
			if (sender.dragging) then
				Preferences.minimap_x, Preferences.minimap_y = self:GetPosition();
				SavePreferences();			
				sender.dragging = false;
			end
		end
	end
	self.titleCenter.MouseMove = function(sender,args)
		if ( sender.dragging ) then
			local left, top = self:GetPosition();
			self:SetPosition( left + ( args.X - sender.dragStartX ), top + args.Y - sender.dragStartY );
			sender.dragged = true;
			if (self:GetLeft() > Turbine.UI.Display.GetWidth() - 35) then
				self:SetLeft(Turbine.UI.Display.GetWidth() - 35);				
			end
			if (self:GetLeft() < 0) then
				self:SetLeft(0);				
			end			
			if (self:GetTop() > Turbine.UI.Display.GetHeight() - 35) then
				self:SetTop(Turbine.UI.Display.GetHeight() - 35);				
			end
			if (self:GetTop() < 0) then
				self:SetTop(0);				
			end			
		end
	end	
	if(Preferences.mmap_zoom~=nil and Preferences.mmap_zoom>1) then
		self.zoomer:SetZoomLevel(Preferences.mmap_zoom);
	end
	self:UpdateResponsive();
	self.titleLeft.MouseDown = self.titleCenter.MouseDown;
	self.titleRight.MouseDown = self.titleCenter.MouseDown;
	self.titleLeft.MouseUp = self.titleCenter.MouseUp;
	self.titleRight.MouseUp = self.titleCenter.MouseUp;
	self.titleLeft.MouseMove = self.titleCenter.MouseMove;
	self.titleRight.MouseMove = self.titleCenter.MouseMove;
end

function MiniMapWindow:UpdateResponsive()
	self.borderTop:SetSize(self:GetWidth()-24, 2);
	local zoomerDec = self.zoomer:GetWidth()-0;
	self.zoomer:SetPosition(self:GetWidth()-zoomerDec-3, 33);
	self.resizer:SetPosition(self:GetWidth()-30-zoomerDec, self:GetHeight()-28);
	self.titleLeft:SetPosition(0, 0);
	self.titleLeft:SetSize(35, 42);
	self.closeBtn:SetPosition( self:GetWidth()-27, 38);
	self.nameLabel:SetSize(self:GetWidth()-35-35-zoomerDec, 24);
	self.nameLabel:SetPosition(35, 12);
	self.titleCenter:SetPosition(35, 0);
	self.titleCenter:SetSize(self:GetWidth()-35-35-zoomerDec, 42);
	self.titleRight:SetPosition(self:GetWidth()-35-zoomerDec, 0);
	self.titleRight:SetSize(35, 42);
	
	self.borderSep:SetSize(self.map.headerBack:GetWidth(), 2);
	self.borderLeft:SetSize(2, self:GetHeight()-32-24);
	self.borderBotLeft:SetPosition(0, self:GetHeight()-12);
	self.borderBot:SetSize(self:GetWidth()-24-self.zoomer:GetWidth(),2);
	self.borderBot:SetPosition(12, self:GetHeight()-3);
	self.borderRight:SetPosition(self.zoomer:GetLeft()-2, self.borderSep:GetTop()+2);
	self.borderRight:SetSize(2, self:GetHeight()-self.borderSep:GetHeight()-self.resizer:GetHeight());
	self.mapContainer:SetSize(self:GetWidth()-6-self.zoomer:GetWidth(), self:GetHeight()-self.borderSep:GetTop());
    self.vscrollBar:SetPosition( self.mapContainer:GetWidth()-10, 0);
    self.vscrollBar:SetSize( 10, self.mapContainer:GetHeight()-self.resizer:GetHeight()+10);
    self.hscrollBar:SetPosition(0,  self.mapContainer:GetHeight()-10);
    self.hscrollBar:SetSize(self.mapContainer:GetWidth()-self.resizer:GetWidth()+10, 10);
	self.map:Repack(self:GetWidth()-1-zoomerDec, self:GetHeight()-32, true);
	self.vscrollBar:SetVisible(self.map.map:GetHeight()>self.mapContainer:GetHeight());
	if(self.vscrollBar:IsVisible()) then self.vscrollBar:ValueChanged();
	else self.vscrollBar:SetValue(0); end
	self.hscrollBar:SetVisible(self.map.map:GetWidth()>self.mapContainer:GetWidth());
	if(self.hscrollBar:IsVisible()) then self.hscrollBar:ValueChanged();
	else self.hscrollBar:SetValue(0); end
	
	--self:SetBackColor(Turbine.UI.Color(0, 1, 0));
end

function MiniMapWindow:ShowAllMarks(warband, pos)
	self.map.allMarks.wData = warband;
	self.map.allMarks.l = pos;
	self.map.allMarks:SetPushed(true);
	self.map.allMarks:Toggled(self, true);
	--local result = self.map:ShowAllMarks(warband, pos, area, true);
	-- if result then
	--self.nameLabel:SetText( area.name );
	-- end
	-- return result;
end

function MiniMapWindow:UpdatePlayerPosition(x, y)
	self.map:UpdatePlayerPosition(x, y);
end

function MiniMapWindow:AddCustomFlag(newFlag, newBorn)
	self.map:AddCustomFlag(newFlag, newBorn);
end

function MiniMapWindow:RemoveCustomFlag(flag)
	self.map:RemoveCustomFlag(flag);
end

function MiniMapWindow:OnSearch(str)
	self.map:OnSearch(str);
end

function MiniMapWindow:UpdateMap(warband, pos)
	local result = self.map:UpdateMap(warband, pos, nil, true);
	-- if result then
		-- self.nameLabel:SetText( warband.name );
	-- end
	return result;
end

function MiniMapWindow:OnPOIUpdated(wad, poi)
	if(self.map ~= nil) then  self.map:OnPOIUpdated(wad, poi); end
end

function MiniMapWindow:IsRunning()
	return ( self ~= nil );
end

function MiniMapWindow:Stop()
	self = nil;
end