MiniMapZoomer = class( Turbine.UI.Label );

function MiniMapZoomer:Constructor(listenerResizer)	  	
	Turbine.UI.Label.Constructor( self );
	self:SetSize( 32, 110 );
	self.mapLevel = 1;
	self.maxLevel = 3;
	self.listenerResizer = listenerResizer;

	local backPane = Turbine.UI.Label();
	backPane:SetParent( self );
	backPane:SetBackColor(Turbine.UI.Color(0, 0, 0));
	backPane:SetSize(self:GetWidth()-2, self:GetHeight()-4);
	backPane:SetPosition(0, 2);

	local borderTopRight = Turbine.UI.Label();
	borderTopRight:SetParent( self );
	borderTopRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopRight:SetSize(12, 12);
	borderTopRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_right.tga");	
	borderTopRight:SetPosition(self:GetWidth()-12, 0);
	
	local borderBot = Turbine.UI.Label();
	borderBot:SetParent( self );
	borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");	
	borderBot:SetPosition(0, self:GetHeight()-2);
	borderBot:SetSize(self:GetWidth()-2, 2);
	
	local borderLeft = Turbine.UI.Label();
	borderLeft:SetParent( self );
	borderLeft:SetPosition(self:GetWidth()-2, 12);
	borderLeft:SetSize(2, self:GetHeight()-2-12);
	borderLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_left.tga");
	
	
	self.BtnZoomPlus = Turbine.UI.Label();
	self.BtnZoomPlus:SetParent( self );
	self.BtnZoomPlus:SetPosition(4, 32);
	self.BtnZoomPlus:SetSize(22, 22);
	self.BtnZoomPlus:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/BtnZoomPlus.jpg");
	self.BtnZoomPlus.MouseClick = function( sender, args )
		if(listenerResizer~=nil) then
			self:SetZoomLevel(self.mapLevel+1);
		end
	end
	
	self.BtnZoomMoins = Turbine.UI.Label();
	self.BtnZoomMoins:SetParent( self );
	self.BtnZoomMoins:SetPosition(4, 79);
	self.BtnZoomMoins:SetSize(22, 22);
	self.BtnZoomMoins:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/BtnZoomMoins.jpg");
	self.BtnZoomMoins.MouseClick = function( sender, args )			
		if(listenerResizer~=nil) then
			self:SetZoomLevel(self.mapLevel-1);
		end		
	end
	
	self.zoomLabel = Turbine.UI.Label();
	self.zoomLabel:SetParent( self );
	self.zoomLabel:SetPosition(0, 60);
	self.zoomLabel:SetSize(30, 16);
	self.zoomLabel:SetText("1.0");
	self.zoomLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
end

function MiniMapZoomer:GetZoomLevel()
	return self.mapLevel;
end

function MiniMapZoomer:SetZoomLevel(zoomlevel)
	if(zoomlevel~=nil and zoomlevel>=1 and zoomlevel<=self.maxLevel) then
		self.mapLevel = zoomlevel;
		self.listenerResizer(self.mapLevel);
		Preferences.mmap_zoom = zoomlevel;
		SavePreferences();
		self.zoomLabel:SetText(string.format("%.1f", 0.5*(1+self.mapLevel)));
		self.BtnZoomMoins:SetVisible(self.mapLevel>1);
		self.BtnZoomPlus:SetVisible(self.mapLevel<self.maxLevel);
	end
end