
Difficulty = {
	FAIBLE={
		name="Weak";
	},
	NORMAL={
		name="Normal";
	},
	SIGNATURE={
		name="Signature";
	},
	ELITE={
		name="Elite";
	},
	GRAND_ELITE={
		name="Great Elite";
	},
	NEMESIS={
		name="Nemesis";
	},
	NEMESIS_SUPREME={
		name="Supreme Nemesis";
	},
	TBD={
		name="TBD";
	},
	CANICHE={
		name="Poodle";
	};
};

craftLevels = {
	{name="Apprentice"},
	{name="Journeyman"},
	{name="Expert"},
	{name="Artisan"},
	{name="Master"},
	{name="Supreme"},
	{name="Westfold"},
	{name="Eastemnet"},
	{name="Westemnet"},
	{name="Anorien"},
	{name="Doomfold"},
	{name="Ironfold"},
	{name="Minas Ithil"},
	{name="Gundabad"}
};

-- Format: {id, "wb_name", area_id, "quest_name", Coordinate{x,"S/N", y, "W/E"}, size[1,3,4,12], lvl, moral, "race", Adds{Qty, "name", lvl}, "comment", <Rewards{qty, id}>, priority, "frame_name" }

wadData = {
	{name="Repetables added", insertCustoms=true, region=0, areas={
		{name="Repetables added", showme=false, insertCustoms=true, wads={
			-- Made by player
		}}
	}},
	{name="Craft", region=0, areas={
		{name="Craft", showme=false, wads={
			{id=5009, name="Craft for Embers", enemyType=5, size=1, questname="craftforembers", subname="craftforembers", rewards={{Rewards.BRAISES, 1000}},quest={pnj="Mozhek", loc="Skarald (34.7N, 45.4W)"}, how="Craft 7 [Ember-worthy crafts]", repeatable=1, tag="tag_braises.tga"},
			{id=5012, name="Craft for Motes", enemyType=5, size=1, questname="craftformotes", subname="craftformotes", rewards={{Rewards.GRAINS, 250}},quest={pnj="Motes and Ember Craft Traider", loc="Bree Market Square (30.3S, 51.2W)"}, how="Craft 7 [Motes-worthy crafts]", repeatable=1, tag="tag_grains.tga"}
		}}
	}},
	{name="Worldwide", insertCustoms=true, region=0, areas={
		{name="Worldwide", showme=false, wads={
			{id=5061, name="The Adventures of Floid and Dewitt", target={"Dewitt the Explorer","Floid"}, ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=25, multipoi={
				{map="78.jpg", poi={{ id=1, c="84.7S, 28.1W", l="Floid and Dewitt in Dunland\nIn a secluded passage in the wall near the entrance, just inside the Pristine Glade" }}},
				{map="65.jpg", poi={{ id=2, c="68.6S, 8.4W", l="Floid and Dewitt in Enedwaith\nIn Thror's Coomb south of the entrance to Draigoch's Lair overlooking the first Giant's hut." }}},
				{map="12.jpg", poi={{ id=3, c="14.2S, 73.5W", l="Floid and Dewitt in Evendim\nOn a small island southwest of Tyl Ruinen" }}},
				{map="66.jpg", poi={{ id=4, c="31.3S, 36.6W", l="Floid and Dewitt in the Lone-lands\nAtop Weathertop overlooking the eastern slope" }}},
				{map="77.jpg", poi={{ id=5, c="14.4S, 74.8W", l="Floid and Dewitt  in Lothlorien\nOn the north bank of the Celebrant near a waterfall" }}},
				{map="11.jpg", poi={{ id=6, c="17.5S, 46.2W", l="Floid and Dewitt in Mirkwood\nOverlooking a cliff in the Ashenslades" }}},
				{map="82.jpg", poi={{ id=7, c="2.6S, 105.9W", l="Floid and Dewitt in Moria\nOn your right as you gaze at the Endless Stair." }}}
			}, rewards={{Rewards.TITLE, "The Wanderer"}}, tag="tag_deed.tga"},	
			{id=5062, name="The Adventures of Floid and Dewitt: Part Deux", target={"Dewitt the Explorer","Floid"}, ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=25, multipoi={
				{map="72.jpg", poi={{ id=1, c="49.5S, 47.2W", l="Floid and Dewitt in East Rohan\nOn a rock overhanging the river behind the wall on the far side of the orc camp." }}},
				{map="64.jpg", poi={{ id=2, c="46.5S, 3.8W", l="Floid and Dewitt in Eregion\nOn a cliff at the top of the path along the northern edge of the Red Horn Pass." }}},
				{map="10.jpg", poi={{ id=3, c="13.9N, 82.1W", l="Floid and Dewitt in Forochel\nOn top of a rocky outcropping that can be climbed from the north." }}},
				{map="68.jpg", poi={{ id=4, c="23.0S, 65.3W", l="Floid and Dewitt in The Great River\nOn a cliff along the southern face of Aster Hill." }}},
				{map="8.jpg", poi={{ id=5, c="21.1S, 5.7E", l="Floid and Dewitt in the Misty Mountains\nHalfway up the path to the Black Crack on a circular platform." }}},
				{map="67.jpg", poi={{ id=6, c="33.1S, 10.1W", l="Floid and Dewitt in Trollshaws\nIn a nook between boulders near the top of the winding rough, grassy path above the Ford of Bruinen." }}},
				{map="2.jpg", poi={{ id=7, c="33.0S, 64.2W", l="Floid and Dewitt in Wildermore\nAbove a frozen waterfall at the north shore of the Isingmere." }}}
			}, rewards={{Rewards.TITLE, "The Vagabond"}}, tag="tag_deed.tga"},	
		}}
	}},	
	{name="Gundabad", map="44.jpg", region=2, areas={
		{map="50.jpg", name="Mount Gundabad", wads={
			{id=2370, name="Vistas of Welkin-lofts", target="Dwarfmarker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=135, poi={{id=1, c="43.9N, 74.2W"},{id=2, c="44.5N, 74.7W"},{id=3, c="47.1N, 76.5W"},{id=4, c="42.2N, 71.4W"},{id=5, c="44.8N, 73.9W"},{id=6, c="49.4N, 73.9W"},{id=7, c="47.3N, 71.1W"},{id=8, c="40.8N, 73.9W"},{id=9, c="49.2N, 76.0W"},{id=10, c="46.1N, 78.2W"}}, rewards={{Rewards.VERTUES, 1000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Peak Scaler"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}} , tag="tag_flag.tga"},
			{id=2385, name="Rare Gundabad Chests of Welkin-lofts", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="40.7N, 73.7W"},{id=2, c="44.5N, 73.8W"},{id=3, c="48.3N, 74.6W"},{id=4, c="46.3N, 77.1W", l="inside Thyrstath"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga"},
			{id=2371, name="Treasure of Welkin-lofts", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={ {id=1, c="44.8N, 75.0W"},{id=2, c="47.0N, 70.9W"},{id=3, c="49.7N, 75.3W"},{id=4, c="50.3N, 74.2W"},{id=5, c="42.1N, 71.5W"},{id=6, c="49.5N, 76.0W"},{id=7, c="48.4N, 75.3W"},{id=8, c="47.8N, 77.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure seeker of Welkin-lofts"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga"},
			{id=2383, name="Rare Gundabad Chests of C\195\162r Bronach", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="54.3N, 72.9W"},{id=2, c="52.7N, 69.1W"},{id=3, c="49.2N, 63.1W"},{id=4, c="48.2N, 70.3W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="51.jpg"},
			{id=2372, name="Treasure of C\195\162r Bronach", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={ {id=1, c="54.1N, 70.6W"},{id=2, c="53.1N, 74.2W"},{id=3, c="48.6N, 67.6W"},{id=4, c="52.0N, 60.3W"},{id=5, c="51.0N, 59.3W"},{id=6, c="56.1N, 72.3W"},{id=7, c="52.2N, 69.1W"},{id=8, c="48.2N, 71.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure seeker of C\195\162r Bronach"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="51.jpg"},
			{id=117, name="Khanakarg", questname="Khanakarg", size=1, level=140, difficulty=Difficulty.SIGNATURE, moral="1,753,200", race="Warg", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="47.8N, 77.1W"},{c="49.1N, 75.6W"}}}, enemyType=2, note="Respawn every hour", map="50.jpg"},
			{id=116, name="Skerla", questname="Skerla", size=1, level=136, difficulty=Difficulty.SIGNATURE, moral="TBD", race="lathbear", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="48.5N, 68.7W"},{c="50.4N, 61.6W"}}}, enemyType=2, note="Respawn every hour", map="51.jpg"}
		}},
		{map="50.jpg", name="Delvings of Gundabad", wads={
			{id=2410, name="The Hiddenhoard of Abnank\195\162ra\n[Raid discovery]", questname="DiscoveryTheHiddenhoardofAbnankra", subname="DiscoveryTheHiddenhoardofAbnankra", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=140, poi={ { id=1, c="33.8S, 125.1W", l="Entry of the instance : The Hiddenhoard of Abnank\195\162ra." }}, tag="tag_instance.tga", map="52.jpg"},
			{id=2398, name="Adkh\195\162t-zahhar, the Houses of Rest\n[Instance discovery]", questname="DiscoveryAdkhtzahhartheHousesofRest", subname="DiscoveryAdkhtzahhartheHousesofRest", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=140, poi={ { id=1, c="38.7S, 115.0W", l="Entry of the instance : Adkh\195\162t-zahhar, the Houses of Rest." }}, tag="tag_instance.tga",map="54.jpg"},
			{id=2402, name="Dh\195\189rstrok\n[Instance discovery]", questname="DiscoveryDhrstrok", subname="DiscoveryDhrstrok", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="49.0S, 117.6W", l="Entry of the instance : Dh\195\189rstrok." }}, tag="tag_instance.tga", map="55.jpg"},
			{id=2401, name="Den of Pughlak\n[Instance discovery]", questname="DiscoveryDenofPughlak", subname="DiscoveryDenofPughlak", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="45.9S, 118.9W", l="Entry of the instance : Den of Pughlak." }}, tag="tag_instance.tga", map="53.jpg", rewards={{Rewards.VERTUES, 150}}},
			{id=5057, name="Silver Coins of Gundabad for Embers", enemyType=5, size=1, level=140, questname="Silver Coins of Gundabad for Embers", subname="Silver Coins of Gundabad for Embers", rewards={{Rewards.BRAISES, 500}}, quest={pnj="Quartermaster of Gundabad", loc="Zidir-nesad"}, how="Exchange [100 Silver Coins of Gundabad] for 500 Embers.", repeatable=1, tag="tag_braises.tga"},
			{id=2382, name="Rare Gundabad Chests of Clovengap", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="34.9S, 121.4W"},{id=2, c="36.9S, 124.1W"},{id=3, c="38.5S, 123.0W"},{id=4, c="39.7S, 122.7W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="52.jpg"},
			{id=2381, name="Treasure of Clovengap", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="34.5S, 123.6W"},{id=2, c="35.7S, 121.3W"},{id=3, c="35.7S, 123.8W"},{id=4, c="39.0S, 122.2W"},{id=5, c="40.8S, 122.3W"},{id=6, c="42.2S, 120.5W"},{id=7, c="39.1S, 120.2W"},{id=8, c="37.4S, 121.9W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Clovengap"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="52.jpg"},
			{id=2380, name="Rare Gundabad Chests of Gloomingtarn", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="48.7S, 120.2W", l="inside Ormgren"},{id=2, c="45.5S, 124.0W"},{id=3, c="49.6S, 122.4W", l="inside Glittengrof"},{id=4, c="46.3S, 123.9W", l="in Min Lorg"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="53.jpg"},
			{id=2379, name="Treasure of Gloomingtarn", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="49.0S, 120.5W]"},{id=2, c="45.9S, 119.1W"},{id=3, c="48.2S, 121.8W"},{id=4, c="42.9S, 121.6W"},{id=5, c="44.0S, 122.3W"},{id=6, c="45.4S, 122.6W"},{id=7, c="46.0S, 120.5W"},{id=8, c="48.7S, 121.8W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Gloomingtarn"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="53.jpg"},
			{id=2384, name="Crystal Hunter", target="SUB", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="42.3S, 112.9W",t="Red Crystal"},{id=2, c="39.7S, 112.8W",t="Violet Crystal"},{id=3, c="39.9S, 111.8W",t="Yellow Crystal"},{id=4, c="39.5S, 110.2W",t="Blue Crystal"},{id=5, c="40.8S, 115.2W",t="Orange Crystal"},{id=6, c="43.5S, 109.6W",t="Indigo Crystal"},{id=7, c="39.6S, 113.4W",t="Green Crystal"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},
			{id=2378, name="Rare Gundabad Chests of Stonejaws", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="43.8S, 109.9W"},{id=2, c="39.3S, 110.0W"},{id=3, c="39.7S, 113.7W"},{id=4, c="40.2S, 113.3W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},
			{id=2374, name="Treasure of Stonejaws", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="40.0S, 113.4W"},{id=2, c="39.4S, 109.8W"},{id=3, c="38.8S, 114.6W"},{id=4, c="43.4S, 109.8W"},{id=5, c="42.8S, 111.8W"},{id=6, c="40.5S, 114.6W"},{id=7, c="41.0S, 116.5W"},{id=8, c="40.0S, 116.1W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Stonejaws"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},		
			{id=2377, name="Rare Gundabad Chests of Deepscrave", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="49.1S, 118.2W", l="in Durshulot, middle level"},{id=2, c="50.0S, 118.5W", l="ground level"},{id=3, c="48.7S, 115.8W", l="middle level"},{id=4, c="51.0S, 115.9W", l="upper level"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="55.jpg"},
			{id=2376, name="Treasure of Deepscrave", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="51.5S, 117.2W", l="upper level : take stairs at 48.9S,115.6W, then go south and follow the way"},{id=2, c="52.2S, 119.4W", l="ground level"},{id=3, c="47.2S, 117.4W", l="medium level"},{id=4, c="49.4S, 116.2W", l="ground level"},{id=5, c="51.2S, 115.3W", l="upper level"},{id=6, c="48.5S, 117.6W", l="ground level"},{id=7, c="49.5S, 117.6W", l="ground level"},{id=8, c="50.3S, 117.8W", l="ground level"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Deepscrave"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="55.jpg"},
			{id=2373, name="Rare Gundabad Chests of Mattugard", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="47.0S, 110.7W"},{id=2, c="44.8S, 113.3W"},{id=3, c="48.2S, 114.7W"},{id=4, c="51.3S, 112.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="56.jpg"},
			{id=2375, name="Treasure of Mattugard", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ {id=1, c="45.8S, 112.6W"},{id=2, c="46.5S, 114.6W"},{id=3, c="47.9S, 115.5W"},{id=4, c="47.9S, 115.0W"},{id=5, c="47.4S, 111.2W"},{id=6, c="44.7S, 113.5W"},{id=7, c="45.6S, 114.0W"},{id=8, c="46.5S, 114.8W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Mattugard"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="56.jpg"},
			{id=118, name="Kurzkub", questname="Kurzkub", size=1, level=139, difficulty=Difficulty.SIGNATURE, moral="1,717,650", race="Grim", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="35.8S, 122.5W"},{c="35.2S, 124.0W"}}}, enemyType=2, note="Respawn every hour",map="52.jpg"},
			{id=119, name="Gullush", questname="Gullush", size=1, level=138, difficulty=Difficulty.SIGNATURE, moral="1,661,198", race="Frog", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="47.9S, 120.1W"},{c="47.2S, 121.8W"}}}, enemyType=2, note="Respawn every hour", map="53.jpg"},
			{id=120, name="Skrizug", questname="Skrizug", size=1, level=136, difficulty=Difficulty.SIGNATURE, moral="TBD", race="TBD", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="42.2S, 113.0W"},{c="38.3S, 111.9W"}}}, enemyType=2, note="Respawn every hour", map="54.jpg"},
			{id=122, name="Gurlazg", questname="Gurlazg", size=1, level=134, difficulty=Difficulty.SIGNATURE, moral="1,437,750", race="Insect", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="49.5S, 117.7W"},{c="51.3S, 118.4W"}}}, enemyType=2, note="Respawn every hour", map="55.jpg"},
			{id=121, name="Forsting", questname="Forsting", size=1, level=133, difficulty=Difficulty.SIGNATURE, moral="1,387,350", race="Dragon", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="49.6S, 113.5W"},{c="47.2S, 112.3W"}}}, enemyType=2, note="Respawn every hour", map="56.jpg"} 
		}},
		{name="Instances and repeatable", wads={
			{id=5058, name="Challenges of Gundabad (Weekly)", enemyType=5, size=1, questname="ChallengesofGundabadWeekly", subname="ChallengesofGundabadWeekly", rewards={{Rewards.REPUTATION, "Allegiance: Zhelruka Clan", 2000},{Rewards.TRACERIES_RUNES, 6, 131},{Rewards.VERTUES, 2000},{Rewards.BRAISES, 500}}, how="Complete 4 instances of Gundabad", quest={given="automatically by launching an instance"},  repeatable=5, tag="tag_vault.tga"},	
			{id=5059, name="Reclaiming of the Mountain-hold (Weekly)", enemyType=5, size=1, questname="ReclaimingoftheMountainholdWeekly", subname="ReclaimingoftheMountainholdWeekly", rewards={{Rewards.REPUTATION, "Allegiance: Zhelruka Clan", 2000},{Rewards.TRACERIES_RUNES, 6, 131},{Rewards.VERTUES, 2000},{Rewards.BRAISES, 500}}, how="Complete 20 Gundabad challenges", quest={pnj="Zova", loc="Great Hall of Vernozal"},  repeatable=5, tag="tag_vault.tga"},			
			{id=5055, name="Missions of Gundabad (Weekly)", enemyType=5, size=1, questname="MissionsofGundabadWeekly", subname="MissionsofGundabadWeekly", rewards={{Rewards.REPUTATION, "Allegiance : Zhelruka Clan", 10000}}, how="Complete 20 Gundabad missions", quest={pnj="Zova", loc="Vernozal"},  repeatable=5, tag="tag_braises.tga"},	
			{id=5056, name="Missions of Gundabad (Daily)", enemyType=5, size=1, questname="MissionsofGundabadDaily", subname="MissionsofGundabadDaily", rewards={{Rewards.REPUTATION, "Allegiance : Zhelruka Clan", 2000}}, quest={pnj="Zova", loc="Vernozal"}, how="Complete 20 Gundabad missions", tag="tag_braises.tga"},	
			{id=5050, name="Clovengap: Terror in the Trees", enemyType=5, size=1, level=140, questname="ClovengapTerrorintheTrees", subname="ClovengapTerrorintheTrees", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to collect wood.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5051, name="Stonejaws: Leader of the Frost", enemyType=5, size=1, level=140, questname="StonejawsLeaderoftheFrost", subname="StonejawsLeaderoftheFrost", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to collect Scholar chests.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5052, name="Gloomingtarn: Dr\195\180k-and-Kharb", enemyType=5, size=1, level=140, questname="gloomingtarndrkandkharb", subname="gloomingtarndrkandkharb", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to pick up skarn.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5053, name="Battle of Welkin-lofts", enemyType=5, size=6, level=140, questname="BattleofWelkinlofts", subname="BattleofWelkinlofts", rewards={{Rewards.TRACERIES_RUNES, 5, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 1500}}, quest={pnj="Agatur the Boastful", loc="Zidir-nesad, the Steepset"}, how="Instance with 5 quests each giving 1 box of Enhancement Runes 131 and 300 of reputation.", tag="tag_bag.tga"}, 
			{id=5054, name="Battle at the forge", enemyType=5, size=6, level=140, questname="Battleattheforge", subname="Battleattheforge", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Agatur the Boastful", loc="Zidir-nesad, the Steepset"}, how="Instance with 5 quests each giving 1 box of Enhancement Runes 131 and 300 of reputation.", tag="tag_bag.tga"}, 			
		}},	
		{map="44.jpg", name="Elderslade", showme=false, wads={
			{id=2408, name="Shakalush, the Stair Battle\n[Instance discovery]", questname="DiscoveryAmdnDammultheBloodyThreshold", subname="DiscoveryAmdnDammultheBloodyThreshold", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="39.7N, 66.4W", l="Entry of the instance : Shakalush, the Stair Battle." }}, rewards={{Rewards.VERTUES, 2000}}, tag="tag_instance.tga"},
			{id=2399, map="22.jpg", name="Amd\195\162n Dammul, the Bloody Threshold\n[Instance discovery]", questname="DiscoveryAmdnDammultheBloodyThreshold", subname="DiscoveryAmdnDammultheBloodyThreshold", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="95.2S, 21.6W",m={x=98, y=112}, l="Entry of the instance : Amd\195\162n Dammul, the Bloody Threshold." }}, tag="tag_instance.tga"},
			{id=5005, map="44.jpg", name="Copper Coins of Gundabad for Motes", enemyType=5, size=1, level=130, questname="CopperCoinsofGundabadforMotes", subname="CopperCoinsofGundabadforMotes", rewards={{Rewards.GRAINS, 500}, {Rewards.REPUTATION, "Protectors of Wilderland", 300}}, quest={pnj="Quartermaster (March on Gundabad)", loc="second floor of Annak-khurfu"}, how="Exchange 30 [Copper Coins of Gundabad] against 500 motes.", repeatable=1, tag="tag_grains.tga"},	
			{id=5008, name="On a Mission (Weekly)", enemyType=5, size=1, questname="OnaMissionWeekly", subname="OnaMissionWeekly", rewards={{Rewards.GRAINS, 500},{Rewards.VERTUES, 1000},{Rewards.TRACERIES_RUNES}}, how="Complete 15 missions", quest={given="automatically when completing a mission"}, repeatable=5, tag="tag_grains.tga"},	
			{id=5021, name="On a Continuing Mission (Weekly)", enemyType=5, size=1, questname="OnaContinuingMissionWeekly", subname="enmissioncontinuehebdomadaire", rewards={{Rewards.GRAINS, 500},{Rewards.VERTUES, 1000},{Rewards.TRACERIES_RUNES}}, quest={given="automatically when completing a mission"}, how="Complete 45 missions", repeatable=5, tag="tag_grains.tga"},	
			{id=5006, name="The War Effort: Missions for the Cause (Weekly)", enemyType=5, size=1, level=130, questname="TheWarEffortMissionsfortheCauseWeekly", subname="TheWarEffortMissionsfortheCauseWeekly", rewards={{Rewards.GRAINS, 400}},quest={pnj="Elof", loc="second floor of Annak-khurfu"}, how="Complete 4 times \"March on Gundabad: Missions for the Cause\"", repeatable=5, tag="tag_grains.tga"}, 
			{id=5020, name="The War Effort: A Great Leap (Weekly)", enemyType=5, size=1, level=130, questname="TheWarEffortAGreatLeapWeekly", subname="TheWarEffortAGreatLeapWeekly", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete 4 times \"March on Gundabad: Additional Steps\"", tag="tag_bag.tga"},	
			{id=5007, name="March on Gundabad: Missions for the Cause", enemyType=5, size=1, level=130, questname="MarchonGundabadMissionsfortheCause", subname="MarchonGundabadMissionsfortheCause", rewards={{Rewards.GRAINS, 42}}, quest={pnj="Elof", loc="second floor of Annak-khurfu"}, how="Complete 3 Gabil'akka Missions", tag="tag_grains.tga"},	
			{id=5023, name="March on Gundabad: Assisting the War Effort (Daily)", enemyType=5, size=1, level=130, questname="MarchonGundabadAssistingtheWarEffortDaily", subname="MarchonGundabadAssistingtheWarEffortDaily", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete 3 Gabil'akka Missions", tag="tag_bag.tga"},	
			{id=5022, name="March on Gundabad: Shakalush, the Stair Battle (Daily)", enemyType=5, size=1, level=130, questname="MarchonGundabadShakalushtheStairBattleDaily", subname="MarchonGundabadShakalushtheStairBattleDaily", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete \"Shakalush, the stair Battle\"", tag="tag_bag.tga"},			
			{id=2360, name="Dwarf-surveys in Elderslade", target="Dwarf surveys", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=130, poi={ { id=1, c="32.9N, 58.2W", l="Sud-Ouest de Rushgate" }, { id=2, c="33.7N, 57.7W", l="West of Rushgate"}, { id=3, c="33.1N, 57.3W", l="Southwest of Rushgate"}, { id=4,c="33.4N, 61.2W", l="North of de Ann\195\162k-khurfu" }, { id=5,c="33.7N, 60.5W", l="Northeast of Ann\195\162k-khurfu" }, { id=6, c="33.6N, 63.9W", l="Nord-Ouest de Zarkul-sul\195\187n" }, { id=7, c="33.7N, 62.3W", l="Northeast of Zarkul-sul\195\187n" }, { id=8,c="39.3N, 67.1W", l="Northeast of the Gates of Gundabad" }, { id=9,c="37.1N, 67.9W", l="in front of the Gates, on the south" }, { id=10, c="39.5N, 64.7W", l="Near a waterfall, Northeast of the Gates" }, { id=11,c="38.0N, 65.8W", l="Near a waterfall" }, { id=12, c="34.1N, 62.4W", l="West of Shakal-atr\195\162d" } }, rewards={{Rewards.VERTUES, 2000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Surveyor of Elderslade"}, {Rewards.REPUTATION, "March on Gundabad", 700}} , tag="tag_flag.tga"},	
			{id=2361, name="Treasure-seeker of Elderslade", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="33.9N, 57.6W", l="Northeast of Klorgren" }, { id=2, c="34.3N, 61.9W", l="Down the stairs of Shakal-atrad"}, { id=3, c="32.6N, 58.7W", l=""}, { id=4, c="40.7N, 62.9W", l="" }, { id=5, c="37.1N, 66.0W", l="" }, { id=6, c="36.0N, 62.2W", l="Howlers' Notch interior North"}, { id=7, c="32.4N, 62.6W", l="" }, { id=8, c="35.1N, 66.6W", l="" }, { id=9,c="39.3N, 67.5W", l="In Kulug-mokh, passing through the bridge north of the Gundabad gates" }, { id=10,c="37.3N, 68.5W", l="" }, { id=11, c="36.4N, 68.5W", l="" }, { id=12, c="33.0N, 57.1W", l="" }, { id=13, c="36.2N, 60.6W", l="" }, { id=14, c="33.0N, 63.6W", l="" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Chercheur de Treasure of du Val-D'A\195\175eul"}, {Rewards.REPUTATION, "March on Gundabad", 700}}, tag="tag_vault.tga"}
		}}
	}},
	{name="Azanulbizar - Blood of Azog", map="49.jpg", region=2, areas={
		{map="49.jpg", name="Azanulbizar", showme=false, wads={	
			{id=2409, name="The Fall of Khazad-d\195\187m\n[Instance discovery]", questname="DiscoveryTheFallofKhazaddm", subname="DiscoveryTheFallofKhazaddm", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="67.6N, 137.4W", l="Entry of the instance : The Fall of Khazad-d\195\187m." }}, tag="tag_instance.tga"},
			{id=2364, name="Treasure of Azanulbizar", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="63.3N, 133.9W", l="Near Amdam" }, { id=2, c="65.0N, 135.4W", l="Gash Ujaf"}, { id=3, c="65.0N, 134.6W", l="Hill north of Amdam"}, { id=4, c="66.2N, 136.2W", l="" }, { id=5, c="68.4N, 138.0W", l="NE Rung-shakam" }, { id=6, c="67.0N, 138.2W", l="NW of Zirakazhar"}, { id=7, c="66.4N, 132.5W", l="" }, { id=8, c="70.2N, 136.9W", l="" }, { id=9,c="66.3N, 132.2W", l="North of the road to Atrad-zarakh" }, { id=10,c="69.9N, 135.4W", l="Tar-kutoz" }, { id=11, c="67.2N, 137.0W", l="" }, { id=12, c="65.3N, 132.6W", l="" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Azanulbizar"}, {Rewards.REPUTATION, "The Haban'akka of Thrain", 700}}, tag="tag_vault.tga"},		
			{id=111, name="Kr\195\185mpug", hideStats=true, closedPOI="Zaghuth", size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="783,724", race="Goblin", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="70.2N, 137.1W"},{c="70.2N, 136.6W"},{c="71.3N, 137.2W"}}}, enemyType=2, note="Respawn every hour"},
			{id=112, name="Muzbuk", hideStats=true, loc="69.0N, 134.6W",size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="2,233,612", race="Bat", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="69.0N, 134.6W"},{c="69.9N, 134.0W"},{c="69.3N, 134.1W"}}}, enemyType=2, note="Respawn every hour"},
			{id=113, name="Bagnaz Rot-sting", hideStats=true, loc="65.7N, 135.7W",size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="783,724", race="Orc", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="65.7N, 135.7W"},{c="64.8N, 134.7W"},{c="65.1N, 134.8W"}}}, enemyType=2, note="Respawn every hour"},
			{id=114, name="Skegghorn", hideStats=true, loc="66.7N, 132.0W",size=3, level=130, difficulty=Difficulty.SIGNATURE, moral="6,649,777", race="Auroch", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="66.7N, 132.0W"},{c="66.4N, 132.4W"},{c="66.8N, 133.2W"}}}, enemyType=2, note="Respawn every hour"},
			{id=115, name="Zaugnakh", hideStats=true, loc="67.3N, 138.4W",size=3, level=130, difficulty=Difficulty.SIGNATURE, moral="2,374,920", race="Warg", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="67.3N, 138.4W"},{c="67.8N, 138.3W"},{c="68.2N, 138.2W"}}}, enemyType=2, note="Respawn every hour"}
		}}
	}},	
	{name="Wells of Langflood", map="43.jpg", region=2, areas={
		{map="43.jpg", name="Wells of Langflood", showme=false, wads={
			{id=5004, name="Protectors of Wilderland: Bounties", enemyType=5, size=1, level=130, questname="ProtectorsofWilderlandBounties", subname="ProtectorsofWilderlandBounties", rewards={{Rewards.GRAINS, 300}, {Rewards.TRACERIES_RUNES, 2, 121}, {Rewards.REPUTATION, "Protectors of Wilderland", 300}},quest={pnj="automatically by taking a bounty from the Bounty Board", loc="Limlok at 20.9N, 55.9W"}, how="Accomplish 5 bounties at Limlok", repeatable=5, tag="tag_bag.tga"},		
			{id=2350, name="Dwarf-surveys in the Wells of Langflood", target="Dwarf markers", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=130, poi={ { id=1,c="24.2N, 58.9W", l="South of Thokvist" }, { id=2, c="21.0N, 57.5W", l=""}, { id=3, c="20.1N, 57.5W", l=""}, { id=4, c="21.1N, 62.7W", l="Near the bridge to Sundergrot" }, { id=5, c="21.0N, 60.7W", l="Egvarth" }, { id=6, c="20.1N, 59.5W", l="Between Egvarth and Stramvarth" }, { id=7, c="25.2N, 60.0W", l="" }, { id=8, c="25.2N, 58.9W", l="West of Dunabrygg" }, { id=9, c="30.4N, 58.7W", l="" }, { id=10, c="31.8N, 59.6W", l="" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Surveyor of the Langflood"}, {Rewards.REPUTATION, "Protectors of Wilderland", 700}}, tag="tag_flag.tga"},			
			{id=2352, name="Treasure-seeker of the Wells of Langflood", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="21.8N, 52.1W", l="" }, { id=2, c="21.5N, 50.3W", l=""}, { id=3,c="23.4N, 56.6W", l=""}, { id=4, c="20.6N, 57.1W", l="" }, { id=5, c="In Sundergrot (22.0N, 63.0W)", l="" }, { id=6, c="In Scraper's Clough 19.9N, 62.4W", l=""}, { id=7, c="21.1N, 60.2W", l="" }, { id=8, c="25.9N, 55.8W", l="" }, { id=9,c="30.2N, 58.3W", l="" }, { id=10, c="In Framsburg (27.6N, 60.6W)", l="" }, { id=11,c="32.0N, 61.0W", l="" }, { id=12, c="In Tithroz 17.6N, 54.3W", l="At the second tunnel to the left" }}, rewards={{Rewards.TURBINE, 5},{Rewards.TITLE, "Treasure Seeker of the Langflood"}, {Rewards.REPUTATION, "Protectors of Wilderland", 700}}, tag="tag_vault.tga"},
			{id=2351, name="Natural Formations in the Wells of Langflood", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="Tithroz 17.6N, 54.3W", l="" }, { id=2, c="32.1N, 60.1W", l="Reikfoss of Greylin: Jump into the waterfall from the top of the cliff" }, { id=3, c="31.4N, 62.7W", l="Capedouble" }, { id=4, c="30.5N, 58.3W", l="Veithhol" }, { id=5,c="19.9N, 62.4W", l="Scraper's Clough" }, { id=6, c="25.9N, 62.5W", l="Caleb Rhimdath" }}, rewards={{Rewards.REPUTATION, "Protectors of Wilderland", 700}, {Rewards.TITLE, "Natural Wanderer"}}, tag="tag_flag.tga"}		
		}}
	}},	
	{name="Morgul Vale", map="25.jpg", region=4, areas={
		{map="39.jpg", name="Minas Morgul", wads={
			{id=2405, name="Ghashan-k\195\186tot - the Hall of Black Lore\n[Instance discovery]", questname="DiscoveryGhashanktottheHallofBlackLore", subname="DiscoveryGhashanktottheHallofBlackLore", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=125, poi={ { id=1, c="68.0S, 0.6E", l="Entry of the instance : Ghashan-k\195\186tot - the Hall of Black Lore." }}, tag="tag_instance.tga"},
			{id=2404, name="Gath Daeroval, the Shadow-roost\n[Instance discovery]", questname="DiscoveryGathDaerovaltheShadowroost", subname="DiscoveryGathDaerovaltheShadowroost", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=125, poi={ { id=1, c="67.8S, 2.5E", l="Entry of the instance : Gath Daeroval, the Shadow-roost." }}, tag="tag_instance.tga"},
			{id=2341, name="Rare Chests of Minas Morgul", target="Rare treasure chest", enemyType=3, frame="treasure.tga", size=1, level=127, poi={ { id=1, c="68.8S, 0.4E", l="Cercle 1" }, { id=2, c="67.2S, 3.5E", l="Cercle 1"}, { id=3,c="67.3S, 3.1E", l="Cercle 2, in the House of Songs"}, { id=4, c="66.2S, 0.9E", l="In Burzangh, the Dark Forge, upstairs behind the boss" }, { id=5, c="68.5S, 0.6E", l="In Dar Grazadh, Hall of Rot, in the south corner" }, { id=6, c="67.3S, 2.7E", l="Cercle 3"}, { id=7, c="67.2S, 0.7E", l="Cercle 3" }, { id=8, c="68.2S, 0.7E", l="Cercle 3" }, { id=9, c="66.9S, 1.5E", l="Cercle 4" }, { id=10, c="66.9S, 2.2E", l="Cercle 4" }, { id=11, c="67.3S, 2.4E", l="Cercle 5" }, { id=12,c="67.6S, 1.7E", l="Cercle 6" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}} , note="12 chests are hidden in Minas Morgul, but only 6 are required for the deed.", tag="tag_vault.tga"},			
			{id=2342, name="Lost Lore of the Morgul Vale: Minas Morgul", target="Glowing Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=127, multipoi={{map="41.jpg", poi={{ id=1, c="64.3S, 2.0W", l="Page 1" }, { id=2, c="64.6S, 0.9W", l="Page 2" }, { id=3, c="64.3S, 2.7W", l="Page 3" }, { id=4, c="64.8S, 0.9E", l="Page 4" }, { id=5, c="64.0S, 5.6E", l="Page 5" },  { id=16, c="63.8S, 2.3E", l="Page 16" }, { id=17, m={x=18, y=91}, c="64.3S, 2.4W", l="Page 17" }}},{map="39.jpg", poi={{id=6, c="67.0S, 1.3E", l="Page 6" }, {id=7, c="67.6S, 2.2E", l="Page 7" }, {id=8, c="65.8S, 2.0E", l="Page 8" }, {id=9, c="67.2S, 3.2E", l="Page 9" }, {id=10,c="68.5S, 0.6E", l="Page 10: In Dar Grazadh, south-west" }, {id=11, c="67.4S, 1.6E", l="Page 11" }, {id=12,c="66.7S, 2.4E", l="Page 12" }, {id=13, c="67.8S, 1.7E", l="Page 13" }, {id=14, c="67.8S, 1.2E", l="Page 14" },{id=15, c="67.3S, 0.2W", l="Page 15" }, {id=18, c="67.0S, 2.3E", l="Page 18" }, {id=19, c="67.1S, 1.8E", l="Page 19" }}}}, rewards={{Rewards.REPUTATION, "The Great Alliance", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Minas Morgul"}}, tag="tag_page.tga"},			
		}},
		{map="25.jpg", name="Imlad Morgul", wads={
			{id=2407, name="Remmorchant - the Net of Darkness\n[Instance discovery]", questname="DiscoveryRemmorchanttheNetofDarkness", subname="DiscoveryRemmorchanttheNetofDarkness", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="34.6N, 14.0E", l="Entry of the instance : Remmorchant - the Net of Darkness." }}, tag="tag_instance.tga", map="38.jpg"},
			{id=2406, name="Gorthad N\195\187r, the Deep-barrow\n[Instance discovery]", questname="DiscoveryGorthadNrtheDeepbarrow", subname="DiscoveryGorthadNrtheDeepbarrow", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=125, poi={ { id=1, c="68.8S, 3.5E", l="Entry of the instance : Gorthad N\195\187r, the Deep-barrow." }}, tag="tag_instance.tga", map="41.jpg"},
			{id=2403, name="Eithel Gwaur, the Filth-well\n[Instance discovery]", questname="DiscoveryEithelGwaurtheFilthwell", subname="DiscoveryEithelGwaurtheFilthwell", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=125, poi={ { id=1, c="66.9S, 7.5E", l="Entry of the instance : Eithel Gwaur, the Filth-well." }}, tag="tag_instance.tga", map="41.jpg"},
			{id=2400, name="B\195\162r N\195\173rnaeth, the Houses of Lamentation\n[Instance discovery]", questname="DiscoveryBrNrnaeththeHousesofLamentation", subname="DiscoveryBrNrnaeththeHousesofLamentation", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=121, poi={ { id=1, c="73.1S, 7.7E", l="Entry of the instance : B\195\162r N\195\173rnaeth, the Houses of Lamentation." }}, tag="tag_instance.tga", map="42.jpg"},
			{id=5000, name="Sigils of Imlad Ithil for Motes", enemyType=5, size=1, level=130, questname="SigilsofImladIthilforMotes", subname="SigilsofImladIthilforMotes", rewards={{Rewards.GRAINS, 500}},quest={pnj="Quartermaster of the White Compagny", loc="Estolad L\195\162n at 64.6S, 2.0W"}, how="Exchange [100 Sigils of Imlad Ithil] for [500 Motes of Enchantment].", repeatable=1, tag="tag_virtues.tga"},
			{id=5002, name="Imlad Morgul: The Reclamation", enemyType=5, size=1, level=130, questname="ImladMorgulTheReclamation", subname="ImladMorgulTheReclamation", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 1, 121}},quest={pnj="automatically by taking an Instance Quest of Imlad Morgul from Ereblen", loc="Estolad Uial at 65.1S, 4.1E"}, how="Complete 10 Instance Quests of Imlad Ithil given by Ereblen or Tordoron.", repeatable=5, tag="tag_grains.tga"},	
			{id=5003, name="Imlad Morgul: Vale of Sorcery", enemyType=5, size=1, level=130, questname="ImladMorgulValeofSorcery", subname="ImladMorgulValeofSorcery", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="automatically when entering one of the instances of Minas Morgul", loc="Estolad Uial at 65.1S, 4.1E"}, how="Complete 4 instances of Minas Morgul", repeatable=5, tag="tag_grains.tga"},			
			{id=2344, name="Rare Chests of Thuringwath", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=130, multipoi={{map="42.jpg", poi={ { id=1, c="69.6S, 10.2E", l="" }, { id=2, c="70.4S, 10.7E", l=""}, { id=3,c="71.9S, 7.3E", l=""}, { id=4, c="71.7S, 7.7E", l="" }, { id=5, c="71.9S, 8.0E", l="" }, { id=6, c="73.7S, 7.5E", l=""}}}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}}, tag="tag_vault.tga"},			
			{id=2345, name="Lost Lore of the Morgul Vale: Thuringwath", target="RuneinscribedPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=130, multipoi={{map="42.jpg", poi={ { id=1,c="69.8S, 7.4E", l="Page 1" }, { id=2,c="71.6S, 7.7E", l="Page 2" }, { id=3,c="68.2S, 6.1E", l="Page 3" }, { id=4, c="70.4S, 10.7E", l="Page 4" }, { id=5, c="69.4S, 8.5E", l="Page 5" }, { id=6, c="72.2S, 7.7E", l="Page 6" }, { id=7, c="72.7S, 7.7E", l="Page 7" }, { id=8, c="71.2S, 7.7E", l="Page 8" }, { id=9, c="69.6S, 10.2E", l="Page 9" }, { id=10, c="73.7S, 7.7E", l="Page 10" }, { id=11, c="69.1S, 7.0E", l="Page 11" }, { id=12, c="70.9S, 8.8E", l="Page 12" }, { id=13, c="70.3S, 8.0E", l="Page 13" }, { id=14, c="70.7S, 7.6E", l="Page 14" }, { id=15, c="73.5S, 7.9E", l="Page 15" }, { id=16, c="73.4S, 7.5E", l="Page 16" }, { id=17, c="71.3S, 8.0E", l="Page 17" }, { id=18, c="71.3S, 7.3E", l="Page 18" }}}}, rewards={{Rewards.REPUTATION, "The White Company", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Thuringwath"}}, tag="tag_page.tga"},		
			{id=2343, name="Rare Chests of Rath D\195\186ath", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=127, multipoi={{map="41.jpg", poi={ { id=1, c="66.3S, 0.1W", l="" }, { id=2, c="63.4S, 1.7E", l=""}, { id=3, c="66.9S, 7.8E", l="At the top passing by Shakam Moz"}, { id=4, c="63.7S, 4.6E", l="" }, { id=5, c="68.8S, 3.3E", l="Up through Daru Lagurz" }, { id=6, c="65.3S, 3.4E", l=""}}}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}}, tag="tag_vault.tga"},			
			{id=2339, name="Rare Chests of Cirith Ungol", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=125, multipoi={{map="40.jpg", poi={{ id=1,c="59.3S, 1.2W", l="" },{ id=2, c="59.6S, 3.6E", l="" },{ id=3, c="61.9S, 2.2E", l="" },{ id=4, c="61.0S, 3.9E", l="" }}},{map="38.jpg", poi={{id=5, c="31.6N, 14.7E", l=""},{id=6, c="34.0N, 13.9E", l=""}}}}, rewards={{Rewards.REPUTATION, "The White Company", 700}, {Rewards.VERTUES, 2000}}, tag="tag_vault.tga"},			
			{id=2340, name="Lost Lore of the Morgul Vale: Cirith Ungol", target="Ancient page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=125, multipoi={{map="40.jpg", poi={{ id=1, c="60.4S, 1.5W", l="Page 1" },{ id=2, c="63.4S, 0.7W", l="Page 2" },{ id=3, c="59.9S, 3.0E", l="Page 3" },{ id=4, c="62.6S, 1.3E", l="Page 4" },{ id=5, c="62.4S, 0.8E", l="Page 5" },{ id=6, c="60.4S, 3.1E", l="Page 6" },{ id=7,c="59.7S, 3.8E", l="Page 7" },{ id=8, c="61.5S, 3.5E", l="Page 8" },{ id=9,c="61.3S, 4.2E", l="Page 9" },{ id=11, c="61.8S, 2.1E", l="Page 11" },{ id=12,c="61.0S, 2.6E", l="Page 12" },{id=19, c="61.9S, 0.6W", l="Page 19"}}},{map="38.jpg", poi={{ id=10, c="32.0N, 11.9E", l="Page 10" },{ id=13,c="32.7N, 14.9E", l="Page 13" },{id=14, c="32.2N, 13.4E", l="Page 14"},{id=15, c="32.5N, 12.4E", l="Page 15"},{id=16, c="33.7N, 13.7E", l="Page 16"},{id=17, c="31.8N, 13.6E", l="Page 17"},{id=18, c="34.6N, 14.1E", l="Page 18"}}}}, rewards={{Rewards.REPUTATION, "The White Company", 700}, {Rewards.VERTUES, 2000}}, tag="tag_page.tga"},			
		}},		
		{map="37.jpg", name="Mordor Besieged", wads={
			{id=5011, name="Imlad Morgul: Continued Threats", enemyType=5, size=1, level=120, questname="ImladMorgulContinuedThreats", subname="ImladMorgulContinuedThreats", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="automatically when approaching a Roving threat.\nThis quest is unlocked at level 130, after completing the Minas Morgul quests.", loc="Mordor Besieged"}, how="Kill 8 of 9 Roving Threats of the Mordor Besieged.", repeatable=5, tag="tag_grains.tga"},
			{id=101, name="The Witch-king, Lord of the Nazg\195\187l, Scourge of Mordor", subname="TheWitchking", questname="TheWitchkingLordoftheNazglScourgeofMordor", loc="97.5S, 118.1W", closedPOI="Dol Naeg", size=6, level=130, difficulty=Difficulty.NEMESIS, moral="10,555,201", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=102, name="The Grim Southron, Scourge of Mordor", subname="The Grim Southron", questname="TheGrimSouthronScourgeofMordor", loc="100.1S, 130.9W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=103, name="The Woe of Khand, Scourge of Mordor", questname="TheWoeofKhandScourgeofMordor", loc="98.1S, 128.9W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=104, name="The Cursed Rider, Scourge of Mordor", subname="The Cursed Rider", questname="TheCursedRiderScourgeofMordor", loc="94.5S, 124.5W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=105, name="The Bane of Rh\195\187n, Scourge of Mordor", subname="BaneofRhn", questname="TheBaneofRhnScourgeofMordor", loc="94.1S, 121.9W", closedPOI="Lughash", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=106, name="The Black Blade of Lebennin, Scourge of Mordor", subname="The Black Blade of Lebennin", questname="TheBlackBladeofLebenninScourgeofMordor", loc="94.1S, 120.9W", closedPOI="Barthost", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=107, name="The Gloom of Nurn, Scourge of Mordor", subname="The Gloom of Nurn", questname="TheGloomofNurnScourgeofMordor", loc="96.1S, 119.9W", closedPOI="Dol Naeg", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=108, name="The High Sorcerer of Harad, Scourge of Mordor", subname="The High Sorcerer of Harad", questname="TheHighSorcererofHaradScourgeofMordor", loc="94.9S, 116.3W", closedPOI="Matum Graz", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=109, name="The Forsaken Reaver, Scourge of Mordor", subname="The Forsaken Reaver", questname="TheForsakenReaverScourgeofMordor", loc="97.1S, 114.9W", closedPOI="Sous le pont de Barad-dur", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=2337, name="Rare Chests of Mordor Besieged", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=125, poi={ { id=1, c="102.2S, 129.5W", l="Mokh Shapat" }, { id=2, c="93.9S, 124.0W", l="Amon Fuin"}, { id=3, c="Entrance: 93.5S, 123.8W", l="In Amon Fuin, straight ahead"}, { id=4,c="96.8S, 118.5W", l="Dol Naeg" }, { id=5, c="99.0S, 115.4W", l="Emyn Duir" }, { id=6, c="96.5S, 115.1W", l=""}, { id=7, c="95.1S, 115.9W", l="Matum Graz" }, { id=8, c="95.5S, 114.2W", l="Angathrai" }, { id=9, c="93.9S, 119.1W", l="Urshulagar" }, { id=10, c="95.7S, 124.0W", l="Mokh Darga" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The Great Alliance", 700}}, tag="tag_vault.tga"},
			{id=2338, name="Lost Lore of the Great Alliance", target="StarkwhitePage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=125, poi={ { id=1, m={x=90, y=142}, c="99.1S, 125.8W", l="Page 1" }, { id=2, m={x=9, y=106}, c="96.6S, 131.7W", l="Page 2" }, { id=3, m={x=14, y=113}, c="96.8S, 131.6W", l="Page 3" }, { id=4, c="96.6S, 115.2W", l="Page 4" }, { id=5, c="98.7S, 115.3W", l="Page 5" }, { id=6, c="94.5S, 117.6W", l="Page 6" }, { id=7,c="95.3S, 119.9W", l="Page 7" }, { id=8, m={x=20, y=118}, c="97.1S, 131.4W", l="Page 8" }, { id=9, m={x=100, y=142}, c="99.1S, 125.8W", l="Page 9" }, { id=10, m={x=110, y=142}, c="99.1S, 125.8W", l="Page 10" }, { id=11, m={x=218, y=120}, c="97.0S, 118.5W", l="Page 11" }, { id=12, c="94.6S, 122.9W", l="Page 12" }, { id=13, c="97.1S, 125.7W", l="Page 13" }, { id=14, c="97.0S, 118.3W", l="Page 14" }, { id=15, c="93.5S, 124.2W", l="Page 15" }, { id=16, c="93.5S, 123.6W", l="Page 16" }, { id=17, c="94.9S, 121.7W", l="Page 17" }, { id=18, c="93.0S, 116.7W", l="Page 18" }, { id=19, c="95.2S, 121.0W", l="Page 19" }, { id=20, c="96.1S, 117.4W", l="Page 20" }, { id=21, c="97.8S, 115.8W", l="Page 21" }, { id=22,m={x=255, y=103}, c="96.5S, 115.5W", l="Page 22" }, { id=23, c="95.5S, 114.3W", l="Page 23" }, { id=24, c="95.0S, 115.8W", l="Page 24" }, { id=25, c="98.2S, 126.0W", l="Page 25" }, { id=26, m={x=78, y=94}, c="95.9S, 127.7W", l="Page 26" }, { id=27, c="96.0S, 127.9W", l="Page 27" }}, rewards={{Rewards.REPUTATION, "The Great Alliance", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Mordor Besieged"}}, tag="tag_page.tga"},
		}}	
	}},	
	{name="Vales of Anduin",  map="24.jpg", region=2, areas={
		{map="24.jpg", name="Vales of Anduin", showme=false, wads={
			{id=5017, name="Gulmarks for Motes", enemyType=5, size=1, level=120, questname="glmarksformotes", subname="glmarksformotes", rewards={{Rewards.GRAINS, 200}},quest={pnj="Ragnild", loc="Hultvis (5.0N, 54.9W)"}, how="Exchange against 55 Gulmarks", repeatable=1, tag="tag_grains.tga"},
			{id=5013, name="Protecting the Beornings", enemyType=5, size=1, level=120, questname="ProtectingtheBeornings", subname="ProtectingtheBeornings", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Ragnild", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Shathur-munzu\"", repeatable=9, tag="tag_grains.tga"},	
			{id=5015, name="Protecting the Elves", enemyType=5, size=1, level=120, questname="ProtectingtheElves", subname="ProtectingtheElves", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Hithril", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Kidzul-kalah\"", repeatable=9, tag="tag_grains.tga"},	
			{id=5016, name="Protecting the Woodmen", enemyType=5, size=1, level=120, questname="ProtectingtheWoodmen", subname="ProtectingtheWoodmen", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Audvak", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Avabarg\"", repeatable=9, tag="tag_grains.tga"},	
			{id=2332, name="Jumped At the Chance\n[Hidden deed]", questname="JumpedAttheChance", subname="JumpedAttheChance", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=120, poi={ { id=1, c="8.6N, 56.6W", l="Jump from either end of the Hadhodiant down onto the higher part of the central broken pillar." }}, rewards={{Rewards.TITLE, "Jumped at the Chance"}}, tag="tag_flag.tga"},						
			{id=2333, name="A Chronicle of the Company", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=120, poi={ { id=1, c="12.0N, 63.4W", l="Where Bilbo lost his buttons" }, { id=2, c="10.9N, 61.3W", l="Where Bilbo reunites with the Company"}, { id=3, c="10.9N, 59.8W", l="	Where the Company encountered Wargs"}, { id=4, c="14.7N, 61.0W", l="	Where the Eagles took the Company to safety" }, { id=5, c="13.1N, 58.4W", l="Where the Eagles set down the Company" }, { id=6, c="13.4N, 57.8W", l="Where the Company gathered at the Carrock"}, { id=7, m={x=212, y=34}, c="12.9N, 54.4W", l="Where the Company walked through Beorn's bee-pastures" }, { id=8, m={x=217, y=27}, c="13.6N, 53.3W", l="Where the Company came upon Beorn's house" }, { id=9, m={x=226, y=27}, c="13.5N, 53.3W", l="	Where Beorn meets the Company" }, { id=10, m={x=220, y=38}, c="In Beorn's house", l="Where the Company had supper with Beorn" }, { id=11, c="15.7N, 51.2W", l="Where the Company enters the Mirkwood" }, { id=12, c="9.8N, 64.8W", l="Where Bilbo returns home" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Chronicler of Thorin and Company"}, {Rewards.REPUTATION, "Wilderfolk", 700}}, tag="tag_flag.tga"},			
			{id=2334, name="Treasure-seeker of the Vales",  target="Hidden Cache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="0.7S, 59.5W", l="" }, { id=2, c="0.8S, 61.6W", l=""}, { id=3, c="1.2S, 51.4W", l=""}, { id=4, c="1.6N, 51.8W", l="" }, { id=5, c="1.7N, 53.6W", l="" }, { id=6, c="5.7N, 57.1W", l=""}, { id=7, c="7.1N, 56.0W", l="" }, { id=8, c="16.7N, 54.3W", l="" }, { id=9, c="11.0N, 52.5W", l="" }, { id=10, c="16.7N, 57.0W", l="" }, { id=11, c="11.8N, 59.4W", l="" }, { id=12, c="8.5N, 62.8W", l="" }, { id=13, c="9.4N, 60.1W", l="" }, { id=14, c="2.4N, 57.8W", l="" }, { id=15, c="3.0N, 56.5W", l="" }, { id=16, c="10.1S, 59.7W", l="" }, { id=17, c="5.1S, 59.1W", l="" }, { id=18, c="11.0S, 62.2W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure Seeker of the Anduin"}, {Rewards.REPUTATION, "Wilderfolk", 700}}, tag="tag_vault.tga"},			
			{id=2335, name="Lost Lore of the Vales: Tauralindal\195\171",  target="OldelvenParchment", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="2.9S, 53.6W", l="Page 1" }, { id=2, c="0.7N, 53.1W", l="Page 2" }, { id=3, c="1.2S, 56.4W", l="Page 3" }, { id=4, c="5.3N, 57.2W", l="Page 4" }, { id=5, c="10.9N, 56.3W", l="Page 5" }, { id=6, c="8.1N, 55.4W", l="Page 6" }, { id=7, c="4.1N, 54.7W", l="Page 7" }, { id=8, c="8.6N, 56.7W", l="Page 8" }, { id=9, c="3.6S, 58.3W", l="Page 9" }}, rewards={{Rewards.REPUTATION, "Wilderfolk", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Tauralindal\195\171"}}, tag="tag_page.tga"},		
			{id=2336, name="Lost Lore of the Vales: Old Mad Ubb",  target="BirchbarkPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="0.7N, 60.6W", l="Page 1" }, { id=2, c="1.7S, 60.5W", l="Page 2: room to the north, in the burrow" }, { id=3, c="12.0N, 63.4W", l="Page 3" }, { id=4, c="7.1N, 55.9W", l="Page 4: In the well of sorrows, room east" }, { id=5, c="8.0N, 56.7W", l="Page 5" }, { id=6, c="1.4S, 55.5W", l="Page 6" }, { id=7, c="4.8N, 54.6W", l="Page 7" }, { id=8, c="4.8N, 54.1W", l="Page 8" }, { id=9, c="5.3N, 57.1W", l="Page 9: in Avabarg, south-eastern room" }, { id=10, c="1.1S, 61.1W", l="Page 10" }}, rewards={{Rewards.REPUTATION, "Wilderfolk", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Old Mad Ubb"}}, tag="tag_page.tga"}	
		}}	
	}},	
	{name="Grey Mountains Expedition", region=2, areas={
		{map="21.jpg", name="Grey Mountains Expedition", showme=false, wads={
			{id=2326, name="Survey Markers of the Dwarf-holds",  target="Dwarf-marker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=120, multipoi={{map="23.jpg", poi={{ id=1, c="26.1N, 12.0W", l="" },{ id=2, c="25.5N, 11.7W", l="" },{ id=3, c="22.7N, 9.5W", l="" },{ id=4, c="22.8N, 16.8W", l="" },{ id=5, c="20.5N, 16.3W", l="" },{ id=6, c="21.5N, 13.1W", l="" }}},{map="21.jpg", poi={{id=7, c="33.8N, 51.8W", l=""},{id=8, c="34.6N, 52.2W", l=""},{id=9, c="32.9N, 47.6W", l=""},{id=10, c="34.0N, 42.2W", l=""},{id=11, c="35.0N, 43.3W", l=""},{id=12, c="35.1N, 39.4W", l=""}}}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Surveyor of Mountains"}, {Rewards.REPUTATION, "Grey Mountains Expedition", 700},{Rewards.TRACERIES_RUNES, 2, 116}}, tag="tag_flag.tga"},			
		}},			
		{map="21.jpg", name="Ered Mithrin", wads={
			{id=5001, name="Longbeard Marks for Motes", enemyType=5, size=1, level=120, questname="longbeardmarksformotes", subname="longbeardmarksformotes", rewards={{Rewards.GRAINS, 200}},quest={pnj="Quartermaster", loc="Skarald at 34.7N, 45.4W"}, how="Exchange [15 Longbeard Marks] against [200 Motes of Enchantment].", repeatable=1, tag="tag_grains.tga"},
			{id=5010, name="Reclaiming the Grey", enemyType=5, size=1, level=120, questname="ReclaimingtheGrey", subname="ReclaimingtheGrey", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="This quest is automatically bestowed upon acceptance of any of the four 'Resource Instance Daily quests' from Strahek the Stout", loc="Skarald at 34.7N, 45.4W"}, how="Complete 10 Gray Mountains instance quests given by Strahek", repeatable=5, tag="tag_grains.tga"},
			{id=2327, name="Treasure-seeker of Ered Mithrin", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="30.1N, 32.3W", l="" }, { id=2, c="31.4N, 35.3W", l=""}, { id=3, c="30.2N, 49.7W", l=""}, { id=4, c="33.1N, 56.1W", l="" }, { id=5, c="36.2N, 53.6W", l="" }, { id=6, c="39.2N, 54.0W", l=""}, { id=7, c="36.5N, 44.0W", l="" }, { id=8, c="31.9N, 49.0W", l="" }, { id=9, c="33.4N, 42.1W", l="" }, { id=10, c="35.2N, 40.0W", l="" }, { id=11, c="43.5N, 34.6W", l="" }, { id=12, c="34.1N, 50.1W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure Seeker of the Grey Mountains"}, {Rewards.REPUTATION, "Grey Mountains Expedition", 700}}, tag="tag_vault.tga"},			
			{id=2329, name="Lost Lore of the Dwarf-holds: Ered Mithrin", target="Frozen Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="40.2N, 37.7W", l="Page 1" }, { id=2, c="35.7N, 52.7W", l="Page 2" }, { id=3, c="36.8N, 43.7W", l="Page 3" }, { id=4, c="38.5N, 47.7W", l="Page 4" }, { id=5, c="36.3N, 46.5W", l="Page 5" }, { id=6, c="35.8N, 46.4W", l="Page 6" }, { id=7, c="38.1N, 53.9W", l="Page 7" }, { id=8, c="30.6N, 48.9W", l="Page 8" }}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Ered Mithrin"}}, tag="tag_page.tga"},		
			{id=2330, name="Lost Lore of the Dwarf-holds: Thikil-gundu", target="Rust-stained Writing", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="21.jpg", poi={{ id=1, c="33.0N, 39.5W", l="Page 1" },{ id=2, c="33.8N, 41.8W", l="Page 2" },{ id=3, c="35.5N, 42.0W", l="Page 3" },{ id=4, c="37.7N, 53.4W", l="Page 4" },{ id=5, c="37.8N, 54.2W", l="Page 5" }}},{map="34.jpg", canEnlargeMap=false, poi={{id=6, m={x=156, y=163}, c="Page 6 - 22.9N, 136.0W", l="Instance Thikil-gundu: entrance"},{id=7, m={x=155, y=90}, c="Page 7 - 24.2N, 136.0W", l="Instance Thikil-gundu: banquet hall"},{id=8, m={x=199, y=126}, c="Page 8 - 23.6N, 135.5W", l="Instance Thikil-gundu: Against the north wall of the forges of Kall-Khebab"},{id=9, m={x=154, y=137}, c="Page 9 - 23.4N, 136.0W", l="Instance Thikil-gundu: In the center of Duruz-mazal"},{id=10, m={x=94, y=151}, c="Page 10 - 23.1N, 136.8W", l="Thikil-gundu Crafting Instance: in Bekar-mazal, near Zanmog"},{id=11, m={x=214, y=103}, c="Page 11 - 24.0N, 135.4W", l="Instance Thikil-gundu: In the library of Thikil Gundu"},{id=12, m={x=166, y=109}, c="Page 12 - 23.8N, 136.0W", l="Instance Thikil-gundu: In the feast room"},{id=13, m={x=90, y=97}, c="Page 13 - 24.2N, 137.2W", l="Instance Thikil-gundu: Near Karazgar's chest"},{id=14, m={x=158, y=60}, c="Page 14 - 24.9N, 136.0W", l="Instance Thikil-gundu - In the throne room of Thikil-Gundu"}}}}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Thikil-gundu"}}, tag="tag_page.tga"},			
			{id=2331, name="Lost Lore of the Dwarf-holds: Smaug", target="Claw-mark Writing", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="21.jpg", poi={{ id=2, c="39.2N, 43.8W", l="Page 2: In front of the Stormwall entrance" },{ id=10, c="39.2N, 47.5W", l="Page 10: Before entering Glimmerdeep" }}},{map="35.jpg",canEnlargeMap=false, poi={{id=1, m={x=143, y=156}, c="Page 1 - 30.2N, 136.9W", l="Instance Glimmerdeep: entrance"},{id=3, m={x=143, y=121}, c="Page 3 - 30.8N, 136.9W", l="Instance Glimmerdeep: straight from the entrance"},{id=4, m={x=239, y=19}, c="Page 4 - 32.1N, 135.9W", l="Instance Glimmerdeep: on the platform of the second boss"},{id=5, m={x=150, y=35}, c="Page 5 - 32.0N, 136.8W", l="Glimmerdeep Crafting Instance: after the left bridge which is broken in the normal instance"},{id=8, m={x=232, y=133}, c="Page 8 - 30.5N, 135.9W", l="Instance Glimmerdeep"},{id=9, m={x=241, y=51}, c="Page 9 - 31.6N, 135.9W", l="Instance Glimmerdeep: after the first boss"}}},{map="36.jpg",canEnlargeMap=false, poi={{ id=6, m={x=100, y=136}, c="Before Askurth Hall", l="Page 6: Instance Caverns of Thrumfall" },{ id=7, m={x=24, y=26}, c="Etterfang room", l="Page 7: Instances Caverns of Thrumfall" },{ id=11, m={x=280, y=79}, c="First room", l="Page 11: Instance Caverns of Thrumfall" }}}}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Smaug"}}, tag="tag_page.tga"},			
		}},		
		{map="23.jpg", name="Iron Hills", wads={
			{id=2324, name="Seeking Iron Veins", target="Rich Iron Vein", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=120, poi={ { id=1, c="25.6N, 17.4W", l="" }, { id=2, c="28.7N, 15.9W", l=""}, { id=3, c="23.5N, 8.9W", l=""}, { id=4, c="25.7N, 7.6W", l="" }, { id=5, c="24.6N, 5.7W", l="" }, { id=6, c="23.5N, 18.4W", l="" }, { id=7, c="20.5N, 17.5W", l="" }, { id=8, c="23.8N, 12.0W", l="" }, { id=9, c="22.6N, 14.0W", l="" }, { id=10, c="23.1N, 15.4W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Iron"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_flag.tga"},		
			{id=2325, name="Treasure-seeker of the Ironfold", target="Mining Cache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="27.5N, 17.3W", l="" }, { id=2, c="27.8N, 12.7W", l=""}, { id=3, c="22.0N, 11.6W", l=""}, { id=4, c="24.2N, 9.5W", l="" }, { id=5, c="22.9N, 8.8W", l="" }, { id=6, c="29.0N, 6.8W", l=""}, { id=7, c="25.0N, 5.3W", l="" }, { id=8, c="26.4N, 4.6W", l="" }, { id=9, c="27.9N, 4.7W", l="" }, { id=10, c="28.6N, 5.0W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Dwarf Mines"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_vault.tga"},
			{id=2328, name="Lost Lore of the Dwarf-holds: Ironfold", target="Rusted Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="23.jpg", poi={{ id=1, c="28.6N, 4.0W", l="Page 1" },{ id=2, c="26.1N, 8.1W", l="Page 2" },{ id=3, c="29.9N, 12.0W", l="Page 3" },{ id=5, c="30.7N, 12.3W", l="Page 5" },{ id=6, c="20.4N, 14.5W", l="Page 6" },{ id=8, c="28.8N, 15.6W", l="Page 8" },{ id=9, c="21.0N, 15.6W", l="Page 9" }}},{map="33.jpg", canEnlargeMap=false, poi={{id=4, m={x=111, y=169}, c="Page 4 - Inside Jarnfast", l="Near supervisor Brumbur"},{id=7, m={x=164, y=43}, c="Inside Jarnfast", l="Page 7 - Behind the throne of Nain"},{id=10, m={x=176, y=45}, c="Page 10 - Inside Jarnfast", l="Down the stairs behind Nain"}}}}, rewards={{Rewards.REPUTATION, "Dwarves of Erebor", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Iron Hills"}}, tag="tag_page.tga"}
		}}
	}},	
	{name="Eryn Lasgalen and the Dale-lands", map="32.jpg", region=2, areas={
		{map="32.jpg", name="Eryn Lasgalen and the Dale-lands", showme=false, wads={
			{id=5014, name="Restoring the Three Kingdoms", enemyType=5, size=1, level=115, questname="Restoring the Three Kingdoms", subname="Restoring the Three Kingdoms", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 106}},quest={pnj="King Thorin III", loc="Hall Under the Mountain"}, how="Complete 8 repeatable quests in Dale, Erebor and Felegoth.", repeatable=1, tag="tag_parcgrain.tga"},			
			{id=1120, name="Urd\195\162r, Scourge of the Dale-lands", subname="urdr", questname="urdrscourgeofthedalelands", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Hill-man", adds={{6, "cats 427k", Difficulty.ELITE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="23.5N, 27.7W", l=""},{c="20.7N, 24.7W", l=""},{c="17.5N, 23.5W", l=""},{c="15.2W, 22.8W", l=""}}}},
			{id=1121, name="Kalabraz\195\162n, Scourge of the Dale-lands", subname="kalabrazn", questname="kalabraznscourgeofthedalelands", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Angmarim", adds={{6, "men 427k", Difficulty.ELITE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="22.8N, 27.4W", l=""},{c="20.7N, 24.7W", l=""},{c="17.5N, 32.5W", l=""},{c="15.2W, 22.8W", l=""}}}},
			{id=1122, name="Gloomthorn, Scourge of Eryn-Lasgalen", subname="Gloomthorn", questname="gloomthornscourgeoferynlasgalen", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Huorn", adds={{10, "Angry bees 142k", Difficulty.SIGNATURE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="20.9N, 43.2W", l=""},{c="16.9N, 47.9W", l=""},{c="15.4N, 43.1W", l=""},{c="16.0W, 36.2W", l=""}}}},
			{id=2318, name="Surveyor of the Dwarf-marker",  target="Dwarf-marker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=115, poi={ { id=1, c="22.8N, 43.5W", l="atop an island in the river in Eryn Lasgalen" }, { id=2, c="26.2N, 28.9W", l=""}, { id=3,m={x=218, y=58}, c="27.3N, 29.2W", l=""}, { id=4, m={x=218, y=50}, c="27.9N, 29.3W", l="On a rocky outcrop" }, { id=5,c="28.0N, 28.8W", l="" }, { id=6,c="28.9N, 27.6W", l="South of the Secret Door leading into Erebor" }, { id=7, c="27.4N, 27.9W", l="" }, { id=8, c="26.4N, 27.1W", l="" }, { id=9, c="28.2N, 26.7W", l="" }, { id=10,c="26.6N, 23.8W", l="" }, { id=11, c="22.8N, 27.7W", l="" }, { id=12, c="23.7N, 28.3W", l="" }, { id=13, c="22.3N, 24.7W", l="" }, { id=14, c="21.6N, 25.6W", l="" }, { id=15, c="20.1N, 23.2W", l="" }, { id=16, c="16.9N, 30.0W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Surveyor of Ores"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_flag.tga"},			
			{id=2319, name="The Path of the Company", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=115, multipoi={{map="32.jpg", poi={ { id=1, c="15.7N, 50.9W", l="Where the Company entered Mirkwood" }, { id=2, c="16.2N, 47.3W", l="Where the Company grew to hate the forest"}, { id=3, c="16.8N, 39.1W", l="Where Bombur fell into the enchanted River"}, { id=4, m={x=152, y=136}, c="16.8N, 36.9W", l="Where Bilbo climbed above the trees\n(clickable branch)" }, { id=5, c="17.3N, 37.0W", l="Where the Company was lured off the path" }, { id=6, c="18.4N, 36.3W", l="Where the Company is ambushed by Spiders"}, { id=7, m={x=168, y=123}, c="18.3N, 35.8W", l="Where Bilbo frees the Company from webs" }, { id=11, c="16.1N, 31.8W", l="Where the barrels came ashore near Loeglond" }, { id=12, c="13.4N, 29.6W", l="Where Bilbo freed the company from their barrels" }, { id=13, c="14.5N, 28.9W", l="Where Thorin declared himself before the Master of Lake-town" }, { id=14, c="18.9N, 27.3W", l="Where the Company landed at the top of the Long Lake" }, { id=15, c="26.9N, 29.1W", l="Where they scouted the slopes of the Mountain" }, { id=16, c="31.8N, 27.8W", l="Where the company found the secret way into Erebor" }}},{map="46.jpg", poi={{ id=8, c="48.1N, 127.2W", l="Where Thorin was brought before the Elvenking\In Felegoth: the bridge in front of the Thranduil throne" }, { id=9, c="47.4N, 125.3W", l="Where the Company was jailed by the Elvenking\nIn Felegoth: the second northernmost prison on the left" }, { id=10, c="48.7N, 124.7W", l="Where the company stuffed themselves into barrels\nIn Felegoth: in the northernmost cave in the boatmen's area" }}}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Follower of Thorin and Company"}, {Rewards.REPUTATION, "Dwarves of Erebor", 900}}, tag="tag_flag.tga"},			
			{id=2320, name="Treasure-seeker of the North", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=115, poi={ { id=1, c="32.1N, 28.8W", l="" }, { id=2, c="27.0N, 29.0W", l=""}, { id=3, c="27.1N, 25.4W", l=""}, { id=4, m={x=292, y=70}, c="25.4N, 22.4W", l="" }, { id=5, m={x=297, y=60}, c="25.6N, 21.4W", l="" }, { id=6, c="23.1N, 27.9W", l=""}, { id=7, c="22.0N, 27.8W", l="" }, { id=8, c="20.2N, 26.4W", l="" }, { id=9, c="17.1N, 23.1W", l="" }, { id=10, c="14.6N, 23.5W", l="" }, { id=11, c="11.7N, 28.4W", l="" }, { id=12, c="20.2N, 31.7W", l="" }, { id=13, c="21.1N, 35.3W", l="" }, { id=14, c="15.5N, 34.8W", l="" }, { id=15, c="12.1N, 37.0W", l="" }, { id=16, c="19.0N, 38.4W", l="" }, { id=17, c="20.5N, 38.1W", l="" }, { id=18, c="23.7N, 43.9W", l="" }, { id=19, c="18.9N, 46.9W", l="" }, { id=20, c="14.0N, 50.1W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Dwarvish Treasures"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_vault.tga"},			
			{id=2321, name="Lost Lore of the North: Elves", target="Bark-paper Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, multipoi={{map="32.jpg", poi={{ id=6, c="20.8N, 36.9W", l="Page 6: near a statue at the entrance of Felegoth" }, { id=7, c="20.6N, 35.3W", l="Page 7: in Tham Aeldes" }, { id=9, c="31.7N, 28.0W", l="Page 9, follow the path to the secret entrance" }, { id=10, c="29.1N, 25.3W", l="Page 10" }, { id=11, c="20.0N, 36.7W", l="Page 11: Near Radagast" }, { id=12, c="16.2N, 32.8W", l="Page 12" }, { id=13, c="29.0N, 25.9W", l="Page 13" }, { id=14, c="27.2N, 26.4W", l="Page 14" }, { id=16, m={x=265, y=60}, c="25.1N, 25.0W", l="Page 16" }, { id=17, c="25.0N, 25.0W", l="Page 17" }}}, {map="46.jpg", mapName="Felegoth - The palace of the king of the elves", poi={{ id=1, c="48.2N, 127.1W", l="Page 1: in Felegoth, near the throne" }, { id=2, c="47.4N, 126.0W", l="Page 2: In Felegoth, in prisons" }, { id=3, c="48.0N, 125.4W", l="Page 3: in Felegoth, in the east prison" }, { id=4, c="48.3N, 125.4W", l="Page 4: in Felegoth, by the stream in the northern prison corridor" }, { id=5, c="47.8N, 126.3W", l="Page 5: in Felegoth, in the west prison" }}}, {map="45.jpg", mapName="Hall Under the Mountain", canEnlargeMap=false, poi={{ id=8, m={x=181, y=48}, c="Hall Under the Mountain", l="Page 8, in the Hall under the Mountain, first floor, on the right, near the bridge" },{ id=15, m={x=116, y=143}, c="Hall Under the Mountain", l="Page 15: in the Hall Under the Mountain, at the top of the left staircase after the Vaults Keeper" }}}}, rewards={{Rewards.REPUTATION, "Elves of Felegoth", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Elves of Felegoth"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
			{id=2322, name="Lost Lore of the North: Men", target="Soggy Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="26.2N, 26.4W", l="Page 1" }, { id=2, m={x=245, y=78}, c="25.2N, 25.7W", l="Page 2" }, { id=3, m={x=255, y=78}, c="24.8N, 25.6W", l="Page 3" }, { id=4, c="26.5N, 25.5W", l="Page 4" }, { id=5, m={x=265, y=78}, c="24.2N, 25.8W", l="Page 5" }, { id=6, c="23.1N, 26.1W", l="Page 6" }, { id=7, c="21.8N, 26.2W", m={x=265, y=100}, l="Page 7" }, { id=8, c="21.7N, 26.3W", l="Page 8" }, { id=9, m={x=249, y=137}, c="17.0N, 27.2W", l="Page 9, in the Lake-town barracks" }, { id=10, m={x=254, y=127}, c="17.2N, 27.0W", l="Page 10" }, { id=11, m={x=264, y=127}, c="17.3N, 26.8W", l="Page 11"}, { id=12, c="14.2N, 28.7W", l="Page 12" }, { id=13, m={x=295, y=78}, c="25.0N, 25.5W", l="Page 13" }, { id=14, m={x=275, y=78}, c="25.3N, 25.2W", l="Page 14" }, { id=15, m={x=285, y=78}, c="24.9N, 25.2W", l="Page 15" }}, rewards={{Rewards.REPUTATION, "Men of Dale", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Men of Dale"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
			{id=2323, name="Lost Lore of the North: Dwarves", target="Dusty Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, multipoi={{map="32.jpg", poi={ { id=1, m={x=265, y=50}, c="28.4N, 25.6W", l="Page 1" }, { id=2, m={x=260, y=30}, c="29.4N, 25.6W", l="Page 2" }, { id=3, m={x=270, y=30}, c="29.4N, 25.5W", l="Page 3" }, { id=4, c="27.9N, 30.2W", l="Page 4" }, { id=5, c="15.7N, 50.9W", l="Page 5" }, { id=6, c="31.0N, 27.8W", l="Page 6" }, { id=12, c="14.2N, 28.5W", l="Page 12" }, { id=13, m={x=260, y=40}, c="29.0N, 25.5W", l="Page 13" }, { id=14, m={x=270, y=40}, c="29.1N, 25.7W", l="Page 14" }, { id=15, m={x=265, y=59}, c="28.1N, 25.7W", l="Page 15" }}},{map="45.jpg", mapName="Hall Under the Mountain", canEnlargeMap=false,poi={{ id=7, m={x=132, y=127}, c="Hall Under the Mountain", l="Page 7: in front of the Vaults Keeper" }, { id=8, m={x=184, y=134}, c="Hall Under the Mountain", l="Page 8, on the right staircase after the Vaults Keeper" }, { id=9, m={x=168, y=160}, c="Hall Under the Mountain", l="Page 9, behind the Vaults Keeper" }, { id=10, m={x=124, y=41}, c="Hall Under the Mountain", l="Page 10: Hall Under the Mountain, first floor, left" }, { id=11, m={x=144, y=21}, c="Hall Under the Mountain", l="Page 11: just before the throne of Thorin III" }, { id=16, m={x=128, y=158}, c="Hall Under the Mountain", l="Page 16: Hall Under the Mountain, the stairs leading down to the stream on the left" }, { id=17, m={x=171, y=23}, c="Hall Under the Mountain", l="Page 17: Hall Under the Mountain, east of the throne, after the great braziers" }}}}, rewards={{Rewards.REPUTATION, "Dwarves of Erebor", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Dwarves of Erebor"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
		}},	
	}},
	{name="The Plateau of Gorgoroth",  map="20.jpg", region=4, areas={
		-- {id=500, mapid=19, name="Master - Gorgoroth", showme=false},	
		{map="26.jpg", name="Ud\195\187n", rovingThreatData={loc={{c="40.9S, 3.9E", l=""},{c="45.6S, 0.7W", l="Between Mornaur and Durthang"},{c="45.6S, 3.7E", l="Udun: path east of Durthang"},{c="42.4S, 8.3E", l=""}}}, wads={		
			{id=1100, name="Thormurg the Slaughterer", subname="thormurgtheslaughterer", questname="thormurgtheslaughterer", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", race="Olog", adds={}, rewards={}, frame="gundash.tga", enemyType=2},
			{id=1101, name="Sharlag Man-breaker", subname="sharlagmanbreaker", questname="sharlagmanbreaker", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="949K", race="Olog", adds={}, rewards={}, frame="gundash.tga", enemyType=2},
			{id=1110, name="Nuzdum, Scourge of Ud\195\187n", subname="nuzdum", questname="nuzdumscourgeudn", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,353,000", power="36,781", race="Warg", adds={{4, "wargs 626K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame="voraut.tga", enemyType=2, rovingThreatData={loc={{c="39.6S, 6.8E", l=""},{c="40.9S, 3.9E", l=""},{c="45.6S, 7.3E", l=""}}}},
			{id=2300, name="Forge-works of Ud\195\187n", enemyType=3, ico="poi.jpg", frame="POI_Udun_Mach.tga", size=1, level=108, poi={ { id=1, c="42.4S, 0.5W", l="Across the poison water south of the road" }, { id=2, c="41.8S, 0.0W", l="" }, { id=3, c="40.8S, 0.1W", l="" }, { id=4, c="42.4S, 1.1E", l="at the top of the building" }, { id=5, c="41.7S, 2.4E", l="in a puddle of acid" }, { id=6, c="40.8S, 3.2E", l="" }, { id=7, c="44.0S, 2.5E", l="" }, { id=8, c="43.9S, 4.0E", l="" }, { id=9, c="43.1S, 7.0E", l="" }, { id=10, c="41.1S, 4.8E", l="" }, { id=11, m={x=173, y=79}, c="41.7S, 4.6E", l="" }, { id=12, m={x=185, y=79}, c="41.7S, 4.9E", l="" }, { id=13, m={x=185, y=85}, c="42.2S, 4.9E", l="" }, { id=14, m={x=173, y=85}, c="42.2S, 4.6E", l="" }, { id=15, m={x=185, y=101}, c="42.8S, 4.9E", l="" }, { id=16, m={x=173, y=101}, c="42.8S, 4.6E", l="" } }, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.TITLE, "Gear-hunter"}}, tag="tag_flag.tga"},	
			{id=2301, name="Forge-fires of Ud\195\187n", enemyType=3, ico="poi.jpg",  frame="POI_forge.tga", size=1, level=108, poi={ { id=1, c="42.5S, 5.2E", l="Inside Maudhul Vor" }, { id=2, c="41.7S, 5.7E", l="Off the road in central Udun that curves northwest" }, { id=3, c="41.9S, 5.2E", l="" }, { id=4, m={x=161, y=74}, c="41.6S, 4.0E", l="" }, { id=5, m={x=157, y=70}, c="41.8S, 4.0E", l="" }, { id=6, c="42.1S, 3.3E", l="At the end of the road" }, { id=7, c="41.9S, 1.4E", l="" }, { id=8, c="41.9S, 3.8E", l="Near the treasure hiding place: jump from the top of the northern cliff" }, { id=9, c="42.1S, 0.1E", l="" }, { id=10, m={x=32, y=142}, c="44.8S, 1.1W", l="At the entrance of Mornaur" }, { id=11, m={x=32, y=138}, c="44.5S, 1.1W", l="Opposite the entrance to Mornaur" }, { id=12, m={x=18, y=138}, c="44.7S, 1.5W", l="West in Mornaur" }, { id=13, m={x=24, y=131}, c="44.3S, 1.4W", l="In Mornaur" }, { id=14, m={x=28, y=127}, c="44.3S, 1.3W", l="In Mornaur" }, { id=15, m={x=31, y=125}, c="44.2S, 1.1W", l="In Mornaur" }, { id=16, m={x=44, y=131}, c="44.2S, 0.7W", l="In Mornaur" } }, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.TITLE, "Hand to the Flame"}}, tag="tag_flag.tga"},	
			{id=2302, name="Treasure of Ud\195\187n", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=108, poi={ { id=1, c="40.8S, 0.2E", l="Atop a tower above the forgeworks. Walk around the forge from the slope to the east of it and climb to the roof from behind." }, { id=2, c="41.3S, 4.0E", l="Down the mountainside from the road to Anglach" }, { id=3, c="41.8S, 3.8E", l="From the Anglach road, jump off the cliff" }, { id=4, c="41.0S, 7.8E", l="Rogkalur, on the road east of Anglach" }, { id=5, c="43.4S, 1.8W", l="" }, { id=6, c="45.8S, 1.3W", l="" }, { id=7, c="44.5S, 0.1W", l="West in Mornaur" }, { id=8, c="43.8S, 2.0E", l="" }, { id=9, c="44.1S, 8.9E", l="behind a Mordor Captain's hut" }, { id=10, c="45.9S, 1.4E", l="North of Durtang promontory" }, { id=11, c="45.6S, 2.5E", l="" }, { id=12, c="45.5S, 6.1E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2303, name="Rare Gorgoroth Chests of Ud\195\187n", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="41.7S, 4.0E", l="In a Forgeworker camp next to an Enforcer of Ugrukhor" }, { id=2, c="43.6S, 8.9E", l="In Maudhul Tar Overlook" }, { id=3, c="43.9S, 0.7E", l="Mornaur, atop the road" }, { id=4, c="44.1S, 0.1E", l="Mornaur, atop the road, after the last point of the camp" }, { id=5, c="47.0S, 3.2E", l="Top of the tower in Durthang" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2304, name="Lost Lore of Gorgoroth: Ud\195\187n", target="Soot-Smudged", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="42.6S, 2.0E", l="Page 1" }, { id=2, c="44.3S, 1.8E", l="Page 2" }, { id=3, c="42.9S, 3.1E", l="Page 3" }, { id=4, c="43.9S, 2.5E", l="Page 4" }, { id=5, c="41.3S, 3.3E", l="Page 5" }, { id=6, m={x=190, y=38}, c="39.4S, 5.7E", l="Page 6: in Anglach" }, { id=7, c="46.5S, 7.9E", l="Page 7" }, { id=8, c="41.8S, 5.8E", l="Page 8" }, { id=9, c="40.2S, 1.1W", l="Page 9" }, { id=10, m={x=94, y=166}, c="46.4S, 1.3E", l="Page 10: in front of the entrance of Durthang" }, { id=11, m={x=77, y=185}, c="46.2S, 1.4E", l="Page 11: in Durthang" }, { id=12, m={x=97, y=185}, c="46.2S, 1.4E", l="Page 12: in Durthang" }, { id=13, m={x=117, y=185}, c="47.0S, 3.2E", l="Page 13: in Durthang, at the top" }, { id=14, c="44.5S, 1.1W", l="Page 14" }, { id=15, m={x=210, y=38}, c="39.4S, 5.7E", l="Page 15: in Anglach" }, { id=16, c="41.0S, 7.6E", l="Page 16" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Ud\195\187n"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},		
		}},
		{map="27.jpg", name="Lhingris", rovingThreatData={loc={{c="51.3S, 4.1E", l="Before the lake"},{c="54.7S, 4.7E", l="In a corner of the road to Kala Murg"},{ c="58.5S, 7.6E", l="Lhingris"},{ c="62.5S, 9.7E", l="Lhingris"}}}, wads={
			{id=1104, name="Irongrasp", subname="irongrasp", questname="irongrasp", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="870K", race="Grodbog", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1105, name="G\195\161ghoth the Taker", subname="gghoththetaker", questname="gghoththetaker", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="564K", race="Uruk", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1113, name="Gristlebite, Scourge of Lhingris", subname="gristlebite", questname="gristlebitescourgeoflhingris", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,567,000", race="Spider", adds={{6, "adds 412K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="49.2S, 3.9E", l=""},{c="51.3S, 4.1E", l=""},{c="60.6S, 10.9E", l=""}}}},		
			{id=2305, name="Treasure of de Lhingris", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="47.3S, 5.6E", l="" }, { id=2, c="49.3S, 1.7E", l=" " }, { id=3, c="49.5S, 4.9E", l=" " }, { id=4, c="51.6S, 5.0E", l=" " }, { id=5, c="52.3S, 4.3E", l="" }, { id=6, c="53.3S, 7.2E", l="" }, { id=7, c="55.9S, 5.6E", l=" " }, { id=8, c="58.7S, 7.6E", l="" }, { id=9, c="65.4S, 12.7E", l="in Dath Nethryn" }, { id=10, c="61.0S, 10.6E", l=" " }, { id=11, c="55.7S, 6.5E", l="" }, { id=12, c="48.9S, 6.5E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2306, name="Rare Gorgoroth Chests of Lhingris", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="55.0S, 7.9E", l="Morgai" }, { id=2, c="58.2S, 4.6E", l="Nelegroth" }, { id=3, c="64.7S, 8.8E", l="Amon Ruth" }, { id=4, m={x=142, y=193}, c="18.7N, 33.5E", l="Inside Kam Lagurz, closest entrance is at [64.2S, 10.7E], then turn left and head a bit east and straight north" }, { id=5, c="56.4S, 6.1E", l="Ceber Duath" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2307, name="Lost Lore of Gorgoroth: Lhingris", target="WebcoveredPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="48.8S, 4.5E", l="Page 1" }, { id=2, m={x=59, y=131}, c="58.0S, 4.6E", l="Page 2" }, { id=3, c="61.9S, 6.5E", l="Page 3" }, { id=4, m={x=106, y=153}, c="60.3S 8.2E", l="Page 4: in Cirith Ungol" }, { id=5, c="65.1S, 11.4E", l="Page 5" }, { id=6, m={x=165, y=190}, c="16.8N, 33.0E", l="Page 6: in Kam Lagurz" }, { id=7, m={x=190, y=173}, c="16.5N, 31.4E", l="Page 7: in Kam Lagurz" }, { id=8, c="56.4S, 5.1E", l="Page 8" }, { id=9, c="64.2S, 7.9E", l="Page 9" }, { id=10, c="61.8S, 11.6E", l="Page 10" }, { id=11, c="61.8S, 6.0E", l="Page 11" }, { id=12, c="53.7S, 7.5E", l="Page 12" }, { id=13, c="53.5S, 7.1E", l="Page 13" }, { id=14, c="53.8S, 5.1E", l="Page 14" }, { id=15, c="58.2S, 4.5E", l="Page 15" }, { id=16, m={x=45, y=153}, c="in Cirith Ungol", l="Page 16" }, { id=17, m={x=60, y=153}, c="in Cirith Ungol", l="Page 17" }, { id=18, m={x=75, y=153}, c="in Cirith Ungol", l="Page 18" }, { id=19, c="48.6S, 2.1E", l="Page 19" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Lhingris"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	

		}},
		{map="28.jpg", name="Dor Amarth", rovingThreatData={loc={{c="47.2S, 20.5E", l="Near the northernmost crevasses"},{c="46.9S, 12.7E", l="Northwest of Blozronk"},{c="50.8S, 9.7E", l="In front of Fushaum Tum"},{c="44.3S, 18.0E", l="East of Lugash"}}}, wads={
			{id=1102, name="Grang\195\161th", subname="grangth",  questname="grangth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="837K", race="Shade", adds={}, rewards={}, frame="dukalon.tga", enemyType=2},
			{id=1103, name="Ulurgroth", subname="ulurgroth", questname="ulurgroth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="854K", race="Wraith", adds={}, rewards={}, frame="thorang.tga", enemyType=2},
			{id=1111, name="Rotwing, Scourge of Dor Amarth", subname="rotwing", questname="rotwingscourgeofdoramarth", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Fell Beast", adds={{4, "adds 712K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="43.9S, 17.3E", l=""},{c="47.4S, 20.0E", l=""},{c="50.9S, 8.8E", l=""},{c="50.9S, 12.6E", l=""}}}},	
			{id=2308, name="Treasure of de Dor Amarth", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="51.6S, 11.7E", l="" }, { id=2, c="45.6S, 13.8E", l=" " }, { id=3, c="43.9S, 23.8E", l=" " }, { id=4, c="46.1S, 24.4E", l=" " }, { id=5, c="46.2S, 23.7E", l="" }, { id=6, c="51.5S, 13.5E", l="" }, { id=7, c="47.9S, 15.9E", l=" " }, { id=8, c="47.7S, 20.8E", l="" }, { id=9, c="50.9S, 8.4E", l="" }, { id=10, c="48.5S, 16.1E", l=" " }, { id=11, c="49.0S, 16.2E", l="" }, { id=12, c="48.3S, 20.1E", l="Across lava bridge at [47.3S, 19.9E] then south along narrow path just above the lava" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2309, name="Rare Gorgoroth Chests of Dor Amarth", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="46.3S, 12.9E", l="north-west of Blozronk" }, { id=2, c="51.3S, 11.5E", l="Fushaum Tum" }, { id=3, c="51.0S, 13.6E", l="" }, { id=4, c="47.4S, 18.9E", l="" }, { id=5, c="52.1S, 17.0E", l="west of Orodruin following the road from 48.3S, 16.4E" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2310, name="Lost Lore of Gorgoroth: Dor Amarth", target="Shadowed Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="48.2S, 17.3E", l="Page 1" }, { id=2, c="50.3S, 17.8E", l="Page 2" }, { id=3, c="49.9S, 20.2E", l="Page 3" }, { id=4, c="44.1S, 16.1E", l="Page 4" }, { id=5, m={x=290, y=135}, c="In Barad-dur", l="Page 5" }, { id=6, m={x=290, y=150}, c="In Barad-dur", l="Page 6" }, { id=7, c="46.8S, 24.1E", l="Page 7" }, { id=8, c="47.2S, 26.0E", l="Page 8: In front of the Barad-Dur gate" }, { id=9, c="46.4S, 12.9E", l="Page 9" }, { id=10, c="43.7S, 18.5E", l="Page 10" }, { id=11, c="43.3S, 20.9E", l="Page 11" }, { id=12, c="43.6S, 23.1E", l="Page 12" }, { id=13, c="52.1S, 10.4E", l="Page 13" }, { id=14, c="48.2S, 7.7E", l="Page 14" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Dor Amarth"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{map="29.jpg", name="Talath \195\154rui", rovingThreatData={loc={{c="58.1S, 15.2E", l="Between Fushaum Bal and Thorzhaf"},{c="61.3S, 25.1E", l="Behind Magh Groth"},{c="58.3S, 17.9E", l="In the outpost, east of Thorzhaf"}}}, wads={
			{id=2411, name="The Dungeons of Naerband\n[Instance discovery]", questname="DiscoveryTheDungeonsofNaerband", subname="DiscoveryTheDungeonsofNaerband", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=75, poi={ { id=1, c="62.0S, 19.7E", l="Entry of the instance : The Dungeons of Naerband." }}, tag="tag_instance.tga"},
			{id=1106, name="Nakhts\195\187m the Scorcher", subname="nakhtsmthescorcher", questname="nakhtsmthescorcher", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="854K", race="Grim", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1107, name="Z\195\161ghar Sh\195\162r, the Raging Blaze ", subname="zgharshrtheragingblaze ", questname="zgharshrtheragingblaze", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", race="Rogmul", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1112, name="Spitpyre, Scourge of Talath \195\154rui", subname="spitpyre", questname="spitpyrescourgeoftalathrui", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Drake", adds={{4, "adds 712K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="52.9S, 14.4E", l=""},{c="57.0S, 15.9E", l=""},{c="62.5S, 25.5E", l=""},{c="60.8S, 26.3E", l=""},{c="61.7S, 15.8E", l=""}}}},		
			{id=1115, name="Uili\195\186r, the Ancient Evil", subname="uilirtheancientevil", questname="uilirtheancientevil", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Caerog", adds={}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="58.6S, 20.7E", l=""}}}, note="the quest will be unlocked only after killing the 5 others Ancient Evil of Gorgoroth"},		
			{id=2311, name="Treasure of de Talath \195\154rui", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="61.8S, 15.5E", l="" }, { id=2, c="64.0S, 21.2E", l=" " }, { id=3, c="58.5S, 23.4E", l=" " }, { id=4, c="55.6S, 16.1E", l=" " }, { id=5, c="58.8S, 20.6E", l="Jump on the islands from 58.3S, 18.8E" }, { id=6, c="61.7S, 22.7E", l="" }, { id=7, c="62.9S, 25.0E", l=" " }, { id=8, c="62.9S, 23.8E", l="" }, { id=9, c="57.7S, 25.2E", l="" }, { id=10, c="57.1S, 19.9E", l="Jump on the islands from 58.3S, 18.8E" }, { id=11, c="57.3S, 19.1E", l="Jump on the islands from 58.3S, 18.8E" }, { id=12, c="54.7S, 15.1E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2312, name="Rare Gorgoroth Chests of Talath \195\154rui", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="58.8S, 18.4E", l="Ghashgurm" }, { id=2, c="58.8S, 25.3E", l="Magh Nul" }, { id=3, c="53.8S, 10.1E", l="Dar Mauzur" }, { id=4, c="64.3S, 19.4E", l="Orodir, at the top of the south tower" }, { id=5, c="58.8S, 24.2E", l="West of Magh Nul" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2313, name="Lost Lore of Gorgoroth: Talath \195\154rui", target="Singed Page", enemyType=3, ico="poi.jpg", frame="page_mordor.tga", size=1, level=115, multipoi={{map="29.jpg", poi={ { id=1, c="58.8S, 12.1E", l="Page 1" }, { id=2, c="63.7S, 21.3E", l="Page 2" }, { id=3, m={x=143, y=171}, c="In Naerband", l="Page 3" }, { id=6, c="61.6S, 21.5E", l="Page 6" }, { id=7, m={x=158, y=171}, c="In Naerband", l="Page 7" }, { id=9, c="58.4S, 23.8E", l="Page 9" }, { id=10, c="63.8S, 18.5E", l="Page 10" }, { id=11, m={x=173, y=171}, c="In Naerband", l="Page 11" }, { id=13, c="61.7S, 21.1E", l="Page 13" }, { id=14, c="61.2S, 25.0E", l="Page 14" }, { id=15, c="58.8S, 25.3E", l="Page 15" }}}, {map="47.jpg", poi={{ id=4, m={x=27, y=106}, c="17.2N 12.5E", l="Page 4" }, { id=5, m={x=60, y=108}, c="17.2N, 13.0E", l="Page 5" }, { id=8, m={x=101, y=110}, c="17.1N, 13.6E", l="Page 8" }, { id=12, m={x=147, y=110}, c="17.1N, 14.3E", l="Page 12" }}}}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Talath \195\154rui"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{map="30.jpg", name="Agarnaith", rovingThreatData={loc={{c="55.2S, 26.9E"},{c="54.4S, 25.4E"},{c="49.1S, 32.7E", l="in front of the entrance to Seregost"}}}, wads={
			{id=2390, name="The Court of Seregost\n[Instance discovery]", questname="DiscoveryTheCourtofSeregost", subname="DiscoveryTheCourtofSeregost", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=105, poi={ { id=1, c="49.1S, 32.9E", l="Entry of the instance : The Court of Seregost." }}, tag="tag_instance.tga"},
			{id=1108, name="Drear-root", subname="drearroot", questname="drearroot", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="863K", power="36,781", race="Huorn", adds={}, rewards={}, frame="coeurnoir.tga", enemyType=2},
			{id=1109, name="Agonakur Dusktooth", subname="agonakurdusktooth", questname="agonakurdusktooth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", power="36,781", race="Morroval", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1114, name="Bolv\195\161g the Cursed, Scourge of Agarnaith", subname="bolvgthecursed", questname="bolvgthecursedscourgeofagarnaith", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,567,000", race="Troll", adds={}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="47.0S, 33.5E", l=""},{c="52.5S, 25.5E", l=""},{c="56.1S, 24.7E", l=""}}}},		
			{id=2314, name="Treasure of Agarnaith", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="49.7S, 28.6E", l="" }, { id=2, c="48.8S, 30.3E", l=" " }, { id=3, c="49.1S, 33.0E", l=" " }, { id=4, c="51.2S, 32.7E", l=" " }, { id=5, c="54.5S, 25.0E", l="" }, { id=6, c="55.3S, 24.4E", l="" }, { id=7, c="48.9S, 31.3E", l="Inside Lair of the gloom-lord, boss room" }, { id=8, c="49.3S, 34.6E", l="" }, { id=9, c="46.5S, 36.7E", l="" }, { id=10, c="45.9S, 33.5E", l="" }, { id=11, c="47.4S, 33.4E", l="" }, { id=12, c="48.2S, 32.2E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2315, name="Rare Gorgoroth Chests of Agarnaith", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="53.8S, 25.1E", l="" }, { id=2, c="46.4S, 34.1E", l="Mokal Rukh" }, { id=3, c="48.3S, 32.9E", l="Seregost - Western courtyard" }, { id=4, c="48.3S, 34.1E", l="Seregost - Terrasse of Mokal Rukh" }, { id=5, c="49.0S, 33.0E", l="Seregost - Upper terrace" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2316, name="Lost Lore of Gorgoroth: Agarnaith", target="BloodstainedPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, m={x=235, y=88}, c="49.0S, 33.0E", l="Page 1: In Seregost" }, { id=2, c="51.3S, 26.5E", l="Page 2" }, { id=3, c="49.4S, 31.7E", l="Page 3" }, { id=4, m={x=250, y=88}, c="48.3S, 34.1E", l="Page 4: In Seregost" }, { id=5, m={x=265, y=88}, c="48.5S, 34.3E", l="Page 5: In Seregost" }, { id=6, c="52.4S, 26.9E", l="Page 6" }, { id=7, m={x=280, y=88}, c="48.5S 33.6E", l="Page 7: In Seregost" }, { id=8, m={x=211, y=81}, c="48.9S, 31.3E", l="Page 8: Inside Lair of the gloom-lord" }, { id=9, m={x=115, y=190}, c="56.5S, 26.8E", l="Page 9" }, { id=10, m={x=130, y=190}, c="56.5S, 27.0E", l="Page 10" }, { id=11, m={x=145, y=190}, c="56.4S, 27.0E", l="Page 11" }, { id=12, c="50.3S, 25.9E", l="Page 12" }, { id=13, c="50.6S, 26.2E", l="Page 13" }, { id=14, m={x=242, y=103}, c="49.2S, 33.9E", l="Page 14: In Seregost" }, { id=15, m={x=257, y=103}, c="49.9S, 33.4E", l="Page 15: In Seregost" }, { id=16, m={x=272, y=103}, c="48.5S, 33.4E", l="Page 16: In Seregost" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Agarnaith"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{id=55, map="31.jpg", name="Abyss of Mordath", wads={
			{ id=2317, name="Lost Lore: Abyss of Mordath", ico="poi.jpg", target="Forgotten page", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, m={x=224, y=37}, c="After the rope of Murpraush", l="Page 1" }, { id=2, m={x=58, y=66}, c="At the entrance", l="Page 2" }, { id=3, m={x=12, y=85}, c="Near Lithannon", l="Page 3" }, { id=4, m={x=146, y=84}, c="Near Durshnul", l="Page 4" }, { id=5, m={x=159, y=101}, c="Space on the left", l="Page 5" }, { id=6, m={x=202, y=32}, c="Before the rope of Tol Shikug", l="Page 6" }, { id=7, m={x=241, y=81}, c="Near Sagrog", l="Page 7" }, { id=8, m={x=186, y=117}, c="In the path near Sagrog", l="Page 8" }, { id=9, m={x=227, y=83}, c="Near Glurakul", l="Page 9" }, { id=10, m={x=262, y=161}, c="Near Glurnakh", l="Page 10" }, { id=11, m={x=275, y=181}, c="Near the chest of Fingar", l="Page 11" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Agarnaith"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga", canEnlargeMap=false},		
		}},	
	}},
	{name="The Wastes",  map="19.jpg", region=4, areas={
		{id=48, name="The Wastes", showme=false, rovingThreatData={loc={{c="36.7S, 15.2W", l=""},{c="36.2S, 12.1W", l=""},{c="34.5S, 11.1W", l=""},{c="32.7S, 8.3W", l=""},{c="28.9S, 2.6W", l=""}}}, wads={
			{id=2201, name="Forgotten Caches", target="Ranger Cache", enemyType=3, frame="treasure.tga", size=1, level=105, poi={ { id=1,c="39.2S, 12.1W", l="The Noble's house ruins" }, { id=2, c="39.0S, 10.4W", l="The Inn ruins" }, { id=3, c="36.0S, 9.2W", l="The ruins outside of Haerondir" }, { id=4, c="34.8S, 7.3W", l="The guard tower ruins" }, { id=5, c="33.8S, 10.6W", l="Nuiharn" }, { id=6, c="30.2S, 7.3W", l="Ondoher's Folly (on the northern side)" }, { id=7, c="36.8S, 7.1W", l="North of Dum Boha (north of the first platform, just down)" }, { id=8, c="34.3S, 4.8W", l="North of the western Slag-hill" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 500}, {Rewards.TITLE, "Seeker of the Lost"}}, tag="tag_vault.tga"},	
			{id=2202, name="Relics of the Last Alliance", target="Ancient Weapon", enemyType=3, frame="treasure.tga", size=1, level=105, poi={ { id=1, c="30.7S, 7.6W", l="Ondoher's Folly (west of the altars)" }, { id=2, c="37.0S, 9.2W", l="Ruins southeast of Haerondir" }, { id=3,c="33.7S, 10.9W", l="Rubble west of Nuiharn" }, { id=4, c="31.2S, 5.2W", l="In the middle of Dagorlad" }, { id=5, c="27.6S, 4.3W", l="In the marshes north of Dagorlad" }, { id=6, c="31.1S, 1.6W", l="In Dol Acharn (SE corner)" }, { id=7, c="35.1S, 15.2W", l="In the western marshes" }, { id=8, c="33.7S, 3.7W", l="North of the Slag-hills campfire" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 500}, {Rewards.TITLE, "Relic Seeker of The Wastes"}}, tag="tag_flag.tga"},	
			{id=1041, name="Tumoz the Fume", subname="tumozlenrag", questname="tumozthefume", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Drake", adds={{5, "drakes 112K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, frame="rancevenin.tga", enemyType=2},
			{id=1042, name="Marzgur\195\186d", subname="marzgurd", questname="marzgurd", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Troll", adds={{6, "trolls 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}},  enemyType=2},
			{id=1043, name="Ephalz\195\180r", subname="ephalzr", questname="ephalzr", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Numenoreen", adds={{1, "Numenoreen 139K", Difficulty.ELITE}, {3, "Wardens 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
			{id=1044, name="Dorthan\195\173r", subname="dorthanr", questname="dorthanr", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Parjure", adds={{3, "undeads 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
			{id=1045, name="Gaergarch the Thirsty", subname="gaergarchthethirsty", questname="gaergarchthethirsty", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Spider", adds={{2, "spiders 316K", Difficulty.ELITE}, {4, "spiders 116K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
		}}
	}},
	{name="March of the King", map="17.jpg", region=3, areas={
		{name="North Ithilien", wads={
			{id=5018, name="Scrolls of Empowerment for Host of the West Silver Pieces (Daily)", enemyType=5, size=1, level=100, questname="ScrollsofEmpowermentforHostoftheWestSilverPiecesDaily", subname="ScrollsofEmpowermentforHostoftheWestSilverPiecesDaily", rewards={{Rewards.TRACERIES_RUNES, 1, 101}},quest={pnj="Quartermaster of Host of the West", loc="Camp of the Host (40.9S, 10.3W)"}, how="Trade for 50 [Host of the West Silver Pieces]", repeatable=5, tag="tag_parcho.tga"},
			{id=5019, name="Scrolls of Empowerment for Host of the West Silver Pieces (Weekly)", enemyType=5, size=1, level=100, questname="ScrollsofEmpowermentforHostoftheWestSilverPiecesWeekly", subname="ScrollsofEmpowermentforHostoftheWestSilverPiecesWeekly", rewards={{Rewards.TRACERIES_RUNES, 1, 101}},quest={pnj="Quartermaster of Host of the West", loc="Camp of the Host (40.9S, 10.3W)"}, how="Trade for 50 [Host of the West Silver Pieces]", repeatable=5, tag="tag_parcho.tga"},
			{id=99, name="Keeper Shomushuk, Cat-master of the Khundolar", subname="Shomushk", questname="keepershomushkcatmasterofthekhundolar", loc="42.3S, 12.8W", closedPOI="Torngroth", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="56,393", race="Easterling", adds={{6, "cats 38K", Difficulty.SIGNATURE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="shomushk.tga", addlinked=false},
			{id=100, name="Ognir, Warrior of Minas Morgul", subname="ognir", questname="ognirwarriorofminasmorgul", loc="55.8S, 5.3W", closedPOI="Aelin Veren", size=3, level=105, difficulty=Difficulty.ELITE, moral="237,346", race="Troll", adds={}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="ognir2.tga", addlinked=false},
			{id=123, name="Bittergall, the Weaver", subname="bittergall", questname="bittergaltheweaver", loc="57.7S, 7.8W", closedPOI="Bar Aroth", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="569,631", race="Spider", adds={{6, "spiders 26K", Difficulty.NORMAL}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="morvenin.tga", addlinked=true},
			{id=2010, name="Treasure of North Ithilien", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=100, poi={ { id=1, c="56.4S, 5.0W", l="Along a water-side ledge in Thargelon" }, { id=2, c="53.1S, 7.6W", l="Behind the far wall of Aelin Veren" }, { id=3, c="59.5S, 6.1W", l="On top of the wall in Bar Aroth, jump from 59.6S, 5.9W" }, { id=4, c="56.4S, 8.1W", l="On the northern edge of a stream, next to a waterfall" }, { id=5, c="52.9S, 10.1W", l="	West of Aelin Veren, on the southern edge of a stream, on a cliff overlooking a waterfall" }, { id=6, c="51.3S, 8.2W", l="Northwest of Aelin Veren, in a forest glade, on a possible path to find Lokhu-Achi" }, { id=7, c="44.2S, 9.0W", l="East of Bar Tarnaher, at the base of the lone mountain" }, { id=8, c="46.4S, 10.6W", l="Southeast of Bar Tarnaher, at the base of a rock face" }, { id=9, c="56.7S, 7.3W", l="On the northern edge of a stream, between two waterfalls" }, { id=10, c="45.9S, 15.2W", l="Among reeds in the Anduin river" }, { id=11, c="52.2S, 11.3W", l="West of Aelin Veren, on the east edge of the Anduin river, in a patch of rocks"},{id=12, c="45.0S, 11.7W",l="Southeast of Bar Tarnaher, above and between the waterfalls"}},rewards={{Rewards.TURBINE, 5}, {Rewards.NITHILIEN_TOKEN, 12}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.TITLE, "Treasure Seeker of North Ithilien"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 900}}, tag="tag_vault.tga"},		
			{id=2200, name="Haradrim Remnants", target="Haradrim Supplies", enemyType=3, frame="treasure.tga", size=1, level=100, poi={ { id=1, c="58.3S, 13.1W", l="In the northwest corner of Parth Gladlo (After Battle)" }, { id=2, c="70.9S, 15.3W", l="In a Haradrim camp near the southeast section of the Rammas Echor" }, { id=3, c="63.8S, 8.8W", l="Near the docks, on the east side, near the second dock (Osgiliath (After Battle))" }, { id=4, c="64.4S, 9.9W", l="South of the docks, near the west watchtower on the Anduin (Osgiliath (After Battle))" }, { id=5, c="63.5S, 7.8W", l="Southwest of the Court of Isildur (Osgiliath (After Battle)" }, { id=6, c="61.2S, 10.4W", l="In the Cour de Meneldil, north shore (Osgiliath (After Battle))" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.TITLE, "the Retriever"}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
		}}
	}},
	{name="Minas Tirith",  map="16.jpg", region=3, areas={
		{name="Minas Tirith", showme=false, wads={
			{ id=2100, name="Guests of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ 
				{ id=1, m={x=266, y=104}, c="65.6S, 16.9W - 1st cercle", l="The City Stables", t="City Stables"}, { id=2, m={x=275, y=86}, c="65.2S, 16.7W - 1st cercle", l="The Hall of Errands", t="Hall of Errands"}, { id=3, m={x=265, y=128}, c="66.3S, 17.1W - 1st cercle", l="Old Guesthouse", t="The Old Guesthouse"}, { id=4, m={x=249, y=135}, c="66.5S, 17.3W - 1st cercle", l="The South Guesthouse", t="South Guesthouse"}, { id=5, m={x=256, y=76}, c="64.8S, 17.1W - 1st cercle", l="The North Guesthouse", t="North Guesthouse" }, { id=6, m={x=220, y=147}, c="66.9S, 18.0W - 2nd cercle", l="The Guest Barracks", t="Guest Barracks"}, { id=7, m={x=196, y=147}, c="67.0S, 18.6W - 3rd cercle", l="The House of Rest",t="House of Rest"}, { id=8, m={x=155, y=139}, c="66.6S, 19.3W - 4th cercle", l="The High Guesthouse",t="High Guesthouse"}, { id=9, m={x=178, y=91}, c="65.3S, 18.8W - 6th cercle", l="The High Stables",t="High Stables"}, { id=10, m={x=169, y=111}, c="65.8S, 19.1W - 7th cercle", l="The Southern Great Guesthouse",t="Southern Great Guesthouse"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2101, name="Taverns of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=168, y=24}, c="63.3S, 19.0W - 1st cercle", l="The Wheel and Cask",t="The Wheel and Cask"}, { id=2, m={x=187, y=181}, c="67.8S, 18.6W - 1st cercle", l="The Laughing Halfling",t="The Laughing Halfling"}, { id=3, m={x=171, y=167}, c="67.4S, 18.9W - 2nd cercle", l="The Splintered Shield",t="The Splintered Shield"}, { id=4, m={x=127, y=160}, c="67.3S, 19.9W - 2nd cercle", l="The Mumak and Keep",t="TheMmakandKeep"}, { id=5, m={x=170, y=42}, c="63.7S, 19.0W - 2nd cercle", l="The Wainrider's Head",t="TheWainridersHead"}, { id=6, m={x=181, y=53}, c="64.1S, 18.9W - 3rd cercle", l="The Hammer and Tongs",t="The Hammer and Tongs"}, { id=7, m={x=216, y=140}, c="66.6S, 18.2W - 3rd cercle", l="The Haven",t="The Haven"}, { id=8, m={x=137, y=149}, c="67.1S, 19.8W - 3rd cercle", l="The Merry Swan",t="The Merry Swan"}, { id=9, m={x=151, y=58}, c="64.2S, 19.4W - 3rd cercle", l="The Brick and Mortar",t="The Brick and Mortar"}, { id=10, m={x=189, y=75}, c="64.7S, 18.6W - 4th cercle", l="The Cresting Wave",t="The Cresting Wave"}, { id=11, m={x=183, y=136}, c="66.6S, 18.7W - 4th cercle", l="The Lone Beacon",t="The Lone Beacon"}, { id=12, m={x=148, y=124}, c="66.2S, 19.7W - 5th cercle", l="The Thirsty Seer",t="The Thirsty Seer"}, { id=13, m={x=153, y=81}, c="65.0S, 19.4W - 5th cercle", l="The Eagle and Sickle",t="The Eagle and Sickle"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2102, name="Teachings of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=182, y=80}, c="64.9S, 18.8W - 5th cercle", l="House of the Heavens",t="House of the Heavens"}, { id=2, m={x=199, y=105}, c="65.7S, 18.4W - 5th cercle, under the central tunnel", l="Old Archives",t="Old Archives"}, { id=3, m={x=187, y=121}, c="66.1S, 18.7W - 5th cercle", l="Archives of Vorondil",t="Archives of Vorondil"}, { id=4, m={x=148, y=128}, c="66.4S, 19.5W - 5th cercle", l="Black House",t="Black House"}, { id=5, m={x=156, y=126}, c="66.3S, 19.5W - 5th cercle", l="Houses of Lore",t="Houses of Lore"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
			{ id=2103, name="Vaults of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga",  size=1, level=90, poi={ { id=1, m={x=278, y=110}, c="65.9S, 16.8W - 1st cercle", l="Keep of the Keys",t="Keep of the Keys"}, { id=2, m={x=260, y=85}, c="65.0S, 17.1W - 1st cercle", l="Lower Stores",t="Lower Stores"}, { id=3, m={x=223, y=87}, c="65.2S, 17.8W - 3rd cercle", l="Vaults of Rynd Mirath",t="Vaults of Rynd Mirath"}, { id=4, m={x=165, y=138}, c="67.0S, 19.3W - 3rd cercle", l="Middle Stores",t="Middle Stores"}, { id=5, m={x=189, y=82}, c="65.0S, 18.6W - 5th cercle", l="Upper Stores",t="Upper Stores"}, { id=6, m={x=161, y=111}, c="65.8S, 19.2W - 7th cercle", l="Coffer-House",t="CofferHouse"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
			{ id=2104, name="Workings of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=231, y=72}, c="64.6S, 17.7W - 2nd cercle", l="Hall of Laws",t="Hall of Laws"}, { id=2, m={x=136, y=41}, c="63.8S, 19.8W - 2nd cercle", l="City Gaol",t="City Gaol"}, { id=3, m={x=223, y=89}, c="65.2S, 17.8W - 3rd cercle", l="House of Clamour",t="House of Clamour"}, { id=4, m={x=168, y=89}, c="65.1S, 19.1W - 6th cercle", l="Chambers of the City",t="Chambers of the City"}, { id=5, m={x=182, y=94}, c="65.2S, 18.8W - 6th cercle", l="Dome of the Sun",t="Dome of the Sun"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2105, name="The Line of Kings", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga",  size=1, level=90, poi={ 
				{ id=1, m={x=268, y=103}, c="65.5S, 16.9W - 1st cercle", l="High King Elendil",t="HighKingElendilSonofAmandilSA33203441"}, 
				{ id=2, m={x=268, y=111}, c="65.7S, 16.9W - 1st cercle", l="King Isildur",t="KingIsildurSonofElendilSA3341TA2"}, 
				{ id=3, m={x=268, y=95}, c="65.5S, 16.9W - 1st cercle", l="King Anarion",t="KingAnrionSonofElendilSA33203440"}, 
				{ id=4, m={x=190, y=86}, c="65.1S, 18.6W - 5th cercle", l="King Meneldil Teltarcil",t="KingMeneldilTeltarcilSonofAnrionTA2158"}, 
				{ id=5, m={x=168, y=121}, c="66.1S, 19.0W - 6th cercle", l="King Cemendur",t="KingCemendurSonofMeneldil158238"}, 
				{ id=6, m={x=173, y=116}, c="66.1S, 18.9W - 6th cercle", l="King Earendil",t="KingErendilSonofCemendur238324"}, 
				{ id=7, m={x=150, y=154}, c="67.2S, 19.5W - 3rd cercle", l="King Anardil",t="KingAnardilSonofErendil324411"}, 
				{ id=8, m={x=162, y=108}, c="65.7S, 19.2W - 1st cercle", l="King Ostoher",t="KingOstoherSonofAnardil411492"}, 
				{ id=9, m={x=190, y=96}, c="65.5S, 18.7W - 1st cercle", l="King Romendacil I Tarostar",t="KingRmendacilITarostarSonofOstoher492541"}, 
				{ id=10, m={x=200, y=96}, c="65.5S, 18.5W - 1st cercle", l="King Turambar Onotimo",t="KingTurambarOntimoSonofTarostar541667"}, 
				{ id=11, m={x=168, y=26}, c="63.4S, 18.8W - 1st cercle", l="King Atanatar I",t="KingAtanatarISonofTurambar667748"}, 
				{ id=12, m={x=149, y=183}, c="68.0S, 19.4W - 1st cercle", l="King Siriondil",t="KingSiriondilSonofAtanatar748830"}, 
				{ id=13, m={x=262, y=115}, c="66.0S, 16.9W - 1st cercle", l="King Tarannon Falastur",t="KingTarannonFalasturSonofSiriondil830913"}, 
				{ id=14, m={x=270, y=120}, c="66.0S, 17.0W - 1st cercle", l="King Earnil I Ciryatan",t="KingErnilICiryatanSonofTarciryan913936"}, 
				{ id=15, m={x=151, y=172}, c="67.8S, 19.4W - 1st cercle", l="King Ciryandil Umarth",t="KingCiryandilmarthfilsdErnil9361015"}, 
				{ id=16, m={x=190, y=109}, c="65.7S, 18.7W - 7th cercle", l="King Hyarmendacil I Ciryaher",t="KingHyarmendacilICiryaherSonofCiryandil10151149"}, 
				{ id=17, m={x=138, y=67}, c="64.5S, 19.7W - 4th cercle", l="King Atanatar II Alcanin",t="KingAtanatarIIAlcarinSonofCiryaher11491226"}, 
				{ id=18, m={x=131, y=69}, c="64.5S, 19.7W - 4th cercle", l="King Narmacil 1er",t="KingNarmacilISonofAtanatar12261294"}, 
				{ id=19, m={x=145, y=65}, c="64.5S, 19.7W - 4th cercle", l="King Calmacil",t="KingCalmacilSonofAtanatar12941304"}, 
				{ id=20, m={x=224, y=99}, c="65.5S, 17.9W - 7th cercle", l="King Romendacil II Minalcar",t="KingRmendacilIIMinalcarSonofCalmacil13041366"}, 
				{ id=21, m={x=184, y=27}, c="63.3S, 18.7W - 1st cercle", l="King Valacar Formendur",t="KingValacarFormendurSonofMinalcar13661432"}, 
				{ id=22, m={x=175, y=108}, c="65.6S, 18.7W - 7th cercle", l="King Eldacar Vinitharya",t="KingEldacarVinitharyaSonofValacar1432143714471490"}, 
				{ id=23, m={x=145, y=74}, c="64.6S, 19.6W - 4th cercle", l="King AldFriendr",t="KingAldFriendrSonofEldacar14901540"}, 
				{ id=24, m={x=198, y=110}, c="65.7S, 18.5W - 7th cercle", l="King Hyarmendacil II Vinyarion",t="KingHyarmendacilIIVinyarionSonofAldFriendr15401621"}, 
				{ id=25, m={x=135, y=79}, c="64.6S, 19.7W - 4th cercle", l="King Minardil Umanwa",t="KingMinardilmanwaSonofVinyarion16211634"}, 
				{ id=26, m={x=195, y=27}, c="63.3S, 18.6W - 1st cercle", l="King Telemnar Sintavarda",t="KingTelemnarSintavardaSonofMinardil16341636"}, 
				{ id=27, m={x=175, y=99}, c="65.6S, 18.7W - 7th cercle", l="King Tarondor Andovarda",t="KingTarondorAndovardaSonofMinastan16361798"}, 
				{ id=28, m={x=224, y=109}, c="65.7S, 17.9W - 7th cercle", l="King Telumehtar Umbardacil",t="KingTelumehtarUmbardacilSonofTarondor17981850"}, 
				{ id=29, m={x=167, y=145}, c="66.7S, 19.1W - 4th cercle", l="King Narmacil II Romenturun",t="KingNarmacilIIRomenturnSonofTelumehtar18501856"}, 
				{ id=30, m={x=166, y=137}, c="66.6S, 19.1W - 4th cercle", l="King Calimehtar Minastan",t="KingCalimehtarMinastanSonofNarmacil18561936"}, 
				{ id=31, m={x=137, y=176}, c="67.8S, 19.6W - 1st cercle", l="King Ondoher Manardil",t="KingOndoherManardilSonofCalimehtar19361944"}, 
				{ id=32, m={x=203, y=147}, c="66.9S, 18.4W - 3rd cercle", l="King Earnil II Malehta",t="KingErnilIIMelehtaSonofSiriondil19452043"}, 
				{ id=33, m={x=162, y=100}, c="65.5S, 19.2W - 7th cercle", l="King Earnur Teldil",t="KingErnurTeldilSonofErnil20432050"} 
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2106, name="The Stewards of Gondor", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={
				{id=1, m={x=197, y=128}, c="66.3S, 18.4W - 4th cercle", l="Steward Mardil Voronwe",t="StewardMardilVoronwSonofVorondil20502080"},
				{id=2, m={x=205, y=130}, c="66.4S, 18.4W - 4th cercle", l="Steward Eradan",t="StewardEradanSonofMardil20802116"},
				{id=3, m={x=224, y=44}, c="63.9S, 17.8W - 1st cercle", l="Steward Herion",t="StewardHerionSonofEradan21162148"},
				{id=4, m={x=179, y=127}, c="66.3S, 18.8W - 5th cercle", l="Steward Belegorn",t="StewardBelegornSonofHerion21482204"},
				{id=5, m={x=264, y=93}, c="65.3S, 16.9W - 1st cercle", l="Steward Hurin I",t="StewardHrinISonofBelegorn22042244"},
				{id=6, m={x=276, y=89}, c="65.2S, 16.8W - 1st cercle", l="Steward Turin I",t="StewardTrinISonofHrin22442278"},
				{id=7, m={x=182, y=86}, c="65.1S, 18.7W - 5th cercle", l="Steward Hador Andin",t="StewardHadorSonofTrin22782395"},
				{id=8, m={x=164, y=64}, c="64.4S, 19.2W - 4th cercle", l="Steward Barahir",t="StewardBarahirSonofHador23952412"},
				{id=9, m={x=118, y=69}, c="64.4S, 20.3W - 3rd cercle", l="Steward Dior",t="StewardDiorSonofBarahir24122435"},
				{id=10, m={x=155, y=87}, c="65.1S, 19.4W - 6th cercle", l="Steward Denethor I",t="StewardDenethorISonofDior24352477"},
				{id=11, m={x=192, y=28}, c="63.5S, 18.5W - 1st cercle", l="Steward Boromir Harna",t="StewardBoromirCharnSonofDenethor24772489"},
				{id=12, m={x=156, y=28}, c="63.4S, 19.3W - 1st cercle", l="Steward Cirion Gwaedhir",t="StewardCirionGwaedhirSonofBoromir24892567"},
				{id=13, m={x=141, y=142}, c="66.6S, 19.7W - 4th cercle", l="Steward Hallas",t="StewardHallasSonofCirion25672605"},
				{id=14, m={x=145, y=148}, c="66.6S, 19.7W - 4th cercle", l="Steward Hurin II",t="StewardHrinIISonofHallas26052628"},
				{id=15, m={x=163, y=82}, c="64.9S, 19.2W - 5th cercle", l="Steward Belecthor I",t="StewardBelecthorISonofHrinII26282655"},
				{id=16, m={x=159, y=75}, c="64.8S, 19.4W - 5th cercle", l="Steward Orodreth",t="StewardOrodrethSonofBelecthor26552685"},
				{id=17, m={x=161, y=110}, c="65.7S, 19.2W - 7th cercle", l="Steward Ecthelion I Minastur",t="StewardEcthelionIMinasturSonofOrodreth26852698"},
				{id=18, m={x=116, y=61}, c="64.3S, 20.3W - 3rd cercle", l="Steward Egalmoth",t="StewardEgalmothSonofEgalreth26982743"},
				{id=19, m={x=161, y=98}, c="65.5S, 19.2W - 7th cercle", l="Steward Beren Istardil",t="StewardBerenIthrondilSonofEgalmoth27432763"},
				{id=20, m={x=138, y=166}, c="67.4S, 19.7W - 2nd cercle", l="Steward Beregond Belechest",t="StewardBeregondBelechestSonofBeren27632811"},
				{id=21, m={x=142, y=70}, c="64.6S, 19.6W - 4th cercle", l="Steward Belecthor II Orndil",t="StewardBelecthorIIOrndilSonofBeregond28112882"},
				{id=22, m={x=145, y=80}, c="64.9S, 19.6W - 5th cercle", l="Steward Thorondir",t="StewardThorondirSonofBelecthor28722882"},
				{id=23, m={x=235, y=136}, c="66.6S, 17.6W - 2nd cercle", l="Steward Turin II",t="StewardTrinIISonofThorondir28822914"},
				{id=24, m={x=177, y=95}, c="65.3S, 18.9W - 6th cercle", l="Steward Turgon",t="StewardTurgonSonofTrin29142953"},
				{id=25, m={x=187, y=93}, c="65.2S, 18.8W - 6th cercle", l="Steward Ecthelion II Turyarta",t="StewardEcthelionIIThandirSonofTurgon29532984"}}, 
				rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
		}}
	}},
	{name="Far Anorien",  map="15.jpg", region=3, areas={
		{id=450, name="Master - Lointain Anorien", showme=false, wads={
			{id=2009, name="Treasure of Far Anorien", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="48.6S, 32.0W", l="The Beacon Hills, west side of the river near the waterfall" }, { id=2, c="48.5S, 33.9W", l="The Beacon Hills, atop a ridge by a rock" }, { id=3, c="46.6S, 32.6W", l="The Beacon Hills, behind a building in Erelas southeast of the beacon" }, { id=4, c="45.6S, 35.9W", l="The Beacon Hills, west of the road to Ost Rimmon, go up and through a cleft in the rocks" }, { id=5, c="47.9S, 39.5W", l="The Beacon Hills, base of a cliff on the east side of the river near Rimmon Quarry" }, { id=6, c="40.5S, 39.0W", l="The Beacon Hills, north of the Variag camp at Bar Nadhron next to a large rock" }, { id=7, c="45.4S, 41.6W", l="The Beacon Hills, at the base of a cliff south of Calenhad" }, { id=8, c="43.9S, 42.0W", l="The Beacon Hills, in a small stable near a building on road to Calenhad" }, { id=9, c="43.9S, 47.1W", l="The Beacon Hills, on the east river bank up the steep hillside and at the base of a cliff" }, { id=10, c="46.6S, 47.3W", l="The Beacon Hills, down the cliff southwest from Halifirien" }, { id=11, c="53.7S, 19.5W", l="Taur Druadan, in the Grey Wood on the north side of the river" }, { id=12, c="45.6S, 19.8W", l="Taur Druadan, among some trees north of the bridge to Talath Anor" }, { id=13, c="48.5S, 22.7W", l="Taur Druadan, take the road to Amon Din" }, { id=14, c="48.9S, 24.2W", l="Taur Druadan, go right from Amon Din entrance and follow along the outside wall" }, { id=15, c="48.9S, 30.1W", l="Taur Druadan, leave the road to Nardol at the southern curve and head south down the rocks" }, { id=16, c="44.2S, 29.0W", l="Taur Druadan, next to a rock north of the War-stead of the Rohirrim Stable-master" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Riders of Rohan", 900}, {Rewards.ROHAN_RIDER_REPUTATION_ITEM, 7}, {Rewards.ROHAN_RIDER_REPUTATION_ITEM2, 4}, {Rewards.TITLE, "Treasure Seeker of Far Anorien"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Riders of Rohan", 900}}, tag="tag_vault.tga"},
			{id=94, name="Asl\195\162 Khimash", questname="aslkhimash", loc="46.2S, 19.9W", closedPOI="Amon Din", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="45,135", race="Mounted Haradrim", adds={{3, "Riders 22K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 900}}, frame="aslakhimash.tga", addlinked=false},
			{id=95, name="Kr\195\187ghu", questname="krghu", loc="55.9S, 18.0W", size=3, level=105, difficulty=Difficulty.ELITE, moral="101,468", race="Nameless", adds={{3, "Nameless 449K", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_RIDER_REPUTATION_ITEM, 5}}, frame="krughu.tga", addlinked=true},
			{id=96, name="Nauruk", questname="naurk", loc="43.0S, 36.1W", closedPOI="Min-Rimmon", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="52,797", race="Warg rider", adds={{1, "monted orc", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_RIDER_REPUTATION_ITEM, 4}}, frame="jouteur.tga", addlinked=true},
			{id=97, name="Ganglem\195\179d", questname="ganglemd", loc="50.5S, 24.7W", closedPOI="Luk Khakat", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="52,797", race="Spider", adds={}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 900}}, frame="ganglemod.tga", addlinked=true},
			{id=98, name="Yarl Vrakya", questname="yarlvrakya", loc="41.6S, 42.9W", closedPOI="Calenhad", size=3, level=105, difficulty=Difficulty.ELITE, moral="123,083", race="Brigand", adds={{2, "archers 53K", Difficulty.SIGNATURE},{1, "soldier 53K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 1200}}, frame="vrakya.tga", addlinked=true}		
		}},			
	}},
	{name="Old Anorien", map="14.jpg", region=3, areas={
		{name="Pelennor", wads={
			{id=89, name="Sharsh\195\187g", questname="sharshg", loc="67.7S, 13.4W", closedPOI="Pelennor", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="281,257", race="Troll", adds={{3, "adds 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame="sharshug.tga", addlinked=true},
			{id=90, name="K\195\187r-anchi", questname="kranchi", loc="66.2S, 12.6W", closedPOI="Pelennor", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Oliphant", adds={{3, "haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}},frame="kuranchi.tga", addlinked=true},
			{id=110, name="Okursa", questname="okursa", loc="69.7S, 15.8W", closedPOI="Pelennor", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Haradrim", adds={{2, "half-Trolls 168K", Difficulty.ELITE},{3, "Haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}}, frame="okursa.tga", addlinked=true}
		}},
		{name="Talath Anor", wads={
			{id=91, name="Mauz\195\186r", questname="mauzr", loc="47.5S, 17.8W", closedPOI="Parth Lisc", size=3, level=103, difficulty=Difficulty.ELITE, moral="92,488", race="Warg", adds={{3, "adds 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame=nil, mapPos={x=119, y=21}, addlinked=true},
			{id=92, name="Fen-skulk", questname="fenskulk", loc="60.5S, 12.0W", closedPOI="Jal Varsha", size=3, level=103, difficulty=Difficulty.ELITE, moral="111,676",  race="Rodemarais", adds={}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame=nil, addlinked=false},
			{id=93, name="Tup\195\187rta", questname="tuprta", loc="58.2S, 11.8W", closedPOI="Parth Gladlo", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Warg", adds={{3, "marauders 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}}, frame=nil, addlinked=true}	
		}},
	}},
	{name="Eastern Gondor", map="7.jpg", region=3, areas={
		{name="Upper Lebennin", wads={
			{id=86, name="Kasota",  questname="kasota", loc="82.4S, 28.8W", closedPOI="Glianath", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="198,185", race="Haradrim", adds={{3, "Riders 36K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Rangers of Ithilien", 700}, {Rewards.EGONDOR_TOKEN, 3}}, frame=nil, addlinked=true},		
		}},
		{name="South Ithilien", wads={
			{id=87, name="Gundr\195\161g", questname="gundrg", loc="64.0S, 4.4W", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="266,836", race="Troll", adds={{2, "Trolls 119K", Difficulty.ELITE},{3, "Goblins 39K", Difficulty.SIGNATURE}}, rewards={ {Rewards.REPUTATION, "Rangers of Ithilien", 900}, {Rewards.EGONDOR_TOKEN, 4}}, frame=nil, addlinked=true},
			{id=88, name="Thangol-ya", questname="thangolya", loc="70.4S, 8.5W", closedPOI="Bar Hurin", size=12, level=103, difficulty=Difficulty.GRAND_ELITE, moral="2,531,815", race="Mammoth", adds={{5, "Haradrims 50K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Rangers of Ithilien", 900}, {Rewards.EGONDOR_TOKEN, 5}}, frame=nil, addlinked=true},
		}},
		{name="Master - Est Gondor", showme=false, rovingThreatData={loc={{c="76.7S, 12.3W"},{c="76.3S, 16.6W"},{c="75.9S, 14.4W"},{c="71.9S, 8.1W"},{c="70.0S, 10.2W"},{c="68.9S, 9.8W"},{c="66.3S, 8.8W"},{c="64.8S, 3.9W"},{c="62.6S, 6.4W"},{c="63.0S, 10.8W"},{c="63.0S, 8.8W"}}},wads={		
			{id=1028, name="Morgrish, the Beast from Harad", subname="morgrish", questname="morgrishthebeastfromharad", loc="Randomly among:", size=3, level=104, difficulty=Difficulty.NEMESIS, moral="835,582", power="36,781", race="Half-troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame=nil, enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=1029, name="Shardr\195\161gh, the Morgul Siege-beast", subname="shardrgh", questname="shardrghthemorgulsiegebeast", loc="Randomly among:", size=6, level=104, difficulty=Difficulty.NEMESIS, moral="1,148,926", power="53,802", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="shardragh.tga", enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=1030, name="Kethat-sai the Destroyer", subname="kethatsai", questname="kethatsaithedestroyer", loc="Randomly among:", size=12, level=104, difficulty=Difficulty.NEMESIS, moral="1,263,819", power="36,781", race="Mammoth", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 5}}, frame="kethatsai.tga", enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=2008, name="Treasure of Eastern Gondor", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="78.4S, 32.3W", l="Upper Lebennin, top of the cliff" }, { id=2, c="82.8S, 28.6W", l="Upper Lebennin" }, { id=3, c="81.4S, 25.5W", l="Upper Lebennin" }, { id=4, c="81.2S, 24.3W", l="Lossarnach: at the edge of a peninsula in the Erui Delta" }, { id=5, c="76.0S, 21.0W", l="Lossarnach: outside the southern wall of Ost Norhir" }, { id=6, c="78.5S, 22.3W", l="Lossarnach: down a hillside south of the east exit from Aegollant" }, { id=7, c="75.0S, 25.0W", l="Lossarnach: in the trees north of Minlos" }, { id=8, c="71.8S, 21.3W", l="Lossarnach: at the base of the cliff northwest of Harlond" }, { id=9, c="78.8S, 18.8W", l="South Ithilien: atop the cliff above the boat dock from Lossarnach" }, { id=10, c="75.8S, 10.9W", l="South Ithilien: outside the northeast wall of Harlanc" }, { id=11, c="74.4S, 9.9W", l="South Ithilien: above the falls east of Bar Hurin" }, { id=12, c="73.1S, 14.3W", l="South Ithilien: on a ledge below the north end of the bridge to Bar Hurin, near Langarch" }, { id=13, c="70.7S, 4.1W", l="South Ithilien: Contre la montagne de l'est" }, { id=14, c="65.6S, 8.8W", l="South Ithilien: on a forested hill south of Osgiliath" }, { id=15, c="63.8S, 10.3W", l="Osgiliath: on a ledge south of the Armoury near Morgul Raiders" }, { id=16, c="64.6S, 9.1W", l="Osgiliath: by the river south of a pillar near Haradrim" }, { id=17, c="62.7S, 10.0W", l="Osgiliath, down near the river inside a metal hut" }, { id=18, c="61.1S, 8.7W", l="Osgiliath: atop a high wall" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.EGONDOR_TOKEN, 18}, {Rewards.TITLE, "Treasure Seeker of Eastern Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Rangers of Ithilien", 900}}, tag="tag_vault.tga"},
		}}
	}},
	{name="Central Gondor", map="6.jpg", region=3, areas={
		{name="Ringl\195\179 Vale", rovingThreatData={loc={{c="70.3S, 47.6W"},{c="71.7S, 52.0W"},{c="72.0S, 48.6W"},{c="73.7S, 49.2W"},{c="76.3S, 50.4W"},{c="72.3S, 48.6W"},{c="70.3S, 47.4W"}}}, wads={
			{id=79, name="Skorneval", questname="skorneval", loc="71.4S, 52.4W", closedPOI="Ethring", size=3, level=102, difficulty=Difficulty.GRAND_ELITE, moral="203,493", race="Shade", adds={{3, "wariors 91K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Ringlo Vale", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="skorneval.tga", addlinked=true},		
			{id=1019, name="Scythe-jaw, the Dread Spider", subname="scythejaw", questname="scythejawthedreadspider", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="Spider", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="fauchecroc.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Acquaintance\nNeed completion of the quest: A Ruthless End", pnj="Candur (Ethring)"},
			{id=1020, name="Gundash, the White Mountain Menace", subname="gundash", questname="gundashthewhitemountainmenace", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="Troll", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="gundash.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Friend\nNeed completion of the quest: A Ruthless End", pnj="Laerind (Ethring)"},
			{id=1021, name="Du-kalon, the Pitiless Dead", subname="dukalon", questname="dukalonthepitilessdead", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398", race="Shade", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="dukalon.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Ally\nNeed completion of the quest: A Ruthless End", pnj="Arvaethor (Ethring)"},
		}},
		{name="Dor-en-Ernil", rovingThreatData={loc={{c="77.7S, 50.2W"},{c="78.3S, 49.0W"},{c="79.4S, 48.0W"},{c="81.3S, 47.1W"},{c="81.4S, 48.0W"},{c="83.0S, 50.8W"},{c="83.1S, 49.3W"}}}, wads={
			{id=80, name="Hamarsun", questname="hamarsun", loc="79.1S, 51.5W", size=3, level=102, difficulty=Difficulty.ELITE, moral="109,889", race="Humain", adds={{3, "corsairs 244K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="hamarsun.tga", addlinked=true},
			{id=81, name="Shat\195\186pash",questname="shatpash", loc="82.4S, 51.3W", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="506,363", race="half-troll", adds={{4, "half-trolls 113K", Difficulty.ELITE},{3, "archers 41K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="shatupash.tga", addlinked=true},
			{id=82, name="Hokhir", questname="hokhir", loc="84.4S, 51.7W", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="463,126", race="Homme", adds={{7, "Haradrims 104K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="hokhir.tga", addlinked=true},	
			{id=1022, name="Anb\195\186rz, Wielder of Men", subname="anbrz", questname="anburzwielderofmen", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="half-troll", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="anburz.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Acquaintance\nNeed completion of the quest: Blood for blood", pnj="Erchar (Linhir)"},
			{id=1024, name="Keterang, Master of Spirits", subname="keterang", questname="keterangmasterofspirits", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="668,466", race="Hill-man", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="keterang.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Ally\nNeed completion of the quest: Blood for blood", pnj="Erchar (Linhir)"},				
			{id=1023, name="Ripper, Bane of the Prince's Lands", subname="ripper", questname="ripperbaneoftheprinceslands", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,506,747", race="Drake", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="percegriffe.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Friend\nNeed completion of the quest: Blood for blood", pnj="Herion (Linhir)"},
		}},
		{name="Lebennin", rovingThreatData={loc={{c="84.1S, 41.7W"},{c="79.0S, 33.6W"},{c="78.5S, 35.5W"},{c="85.6S, 44.8W"},{c="84.6S, 43.9W"},{c="80.8S, 40.8W"},{c="83.5S, 44.2W"}}}, wads={
			{id=83, name="Darik", questname="darik", loc="82.9S, 43.4W", closedPOI="Linhir", size=1, level=102, difficulty=Difficulty.ELITE, moral="109,886", race="Man", adds={}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 2}}, frame="darik.tga"},
			{id=84, name="Shataz", questname="shataz", loc="83.0S, 36.0W", closedPOI="Pelargir", size=3, level=102, difficulty=Difficulty.GRAND_ELITE, moral="226,081", race="Half-troll", adds={{4, "half-trolls 102K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="shataz.tga", addlinked=true},	
			{id=85, name="Vilosh", questname="vilosh", loc="83.0S, 36.0W", closedPOI="Pelargir", size=6, level=102, difficulty=Difficulty.GRAND_ELITE, moral="417,971",  race="Mounted human", adds={{4, "Mounted Haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="vilosh.tga", addlinked=true},
			{id=1025, name="Luruyak, Terror of Harad", subname="luruyak", questname="luruyakterrorofharad", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="668,466",  race="Haradrim", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}},frame="luruyak.tga", enemyType=2, note="Reputation needed:\nLebennin - Acquaintance", pnj="Nimithil (Ost Anglebed)"},
			{id=1026, name="Abrakh\195\180r, Chosen of the Scourge", subname="abrakhr", questname="abrakhrchosenofthescourge", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398", race="Angmarin", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}}, frame="abrakhor.tga", enemyType=2, note="Reputation needed:\nLebennin - Friend", pnj="Milonnen (Ost Anglebed)"},
			{id=1027, name="Render, Shadow of the White Mountains", subname="render", questname="rendershadowofthewhitemountains", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398",  race="Drake", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}}, frame="laceradon.tga", enemyType=2, note="Reputation needed:\nLebennin - Ally", pnj="Milonnen (Ost Anglebed)"},
		}},
		--{id=32, name="Pelargir"}, -- TBC
		{id=290, name="Master - Central Gondor", showme=false, wads={
			{id=2007, name="Treasure of Central Gondor", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="71.4S, 53.5W", l="Ringlo Vale" }, { id=2, c="74.1S, 51.4W", l="Ringlo Vale" }, { id=3, c="76.3S, 49.6W", l="Ringlo Vale" }, { id=4, c="71.3S, 47.4W", l="Ringlo Vale" }, { id=5, c="78.9S, 47.3W", l="Dor-en-Ernil" }, { id=6, c="77.8S, 45.9W", l="Dor-en-Ernil" }, { id=7, c="86.7S, 50.1W", l="Dor-en-Ernil" }, { id=8, c="81.3S, 53.0W", l="Dor-en-Ernil" }, { id=9, c="84.4S, 52.2W", l="Dor-en-Ernil" }, { id=10, c="79.7S, 42.7W", l="Lebennin" }, { id=11, c="76.6S, 44.0W", l="Lebennin" }, { id=12, c="75.7S, 41.4W", l="Lebennin" }, { id=13, c="77.5S, 36.4W", l="Lebennin" }, { id=14, c="78.4S, 33.0W", l="Lebennin" }, { id=15, c="85.6S, 43.2W", l="Lebennin" }, { id=16, c="85.7S, 40.1W", l="Lebennin" }, { id=17, c="84.3S, 34.9W", l="Pelargir: on a small platform on the water" }, { id=18, c="83.0S, 33.8W", l="Pelargir: Between two columns" }, { id=19, c="84.5S, 33.8W", l="Pelargir: In the southwest corner of the central island" }, { id=20, m={x=255, y=151}, c="83.7S, 31.1", l="Pelargir: In the abandoned district" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.CGONDOR_TOKEN, 18}, {Rewards.TITLE, "	Treasure Seeker of Central Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Pelargir", 900}}, tag="tag_vault.tga"}
		}},	
	}},
	{name="Western Gondor", map="4.jpg", region=3, areas={
		{name="Blackroot Vale", wads={
			{id=70, name="Hemokh", questname="hemokh", loc="59.1S, 65.7W", closedPOI="Hill of Erech", size=6, level=96, difficulty=Difficulty.ELITE, moral="355,747", race="Shade", adds={{3 , "warriors 80K", Difficulty.ELITE},{2 , "archers 80K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 4}}, frame="hemokh.tga"},
			{id=71, name="Old Br\195\180g", questname="oldbrg", loc="59.6S, 66.7W", closedPOI="Hill of Erech", size=3, level=96, difficulty=Difficulty.ELITE, moral="77,860", race="Bear", adds={{2 , "bears 35K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 3}}, frame="oldbrog.tga"}
		}},
		{name="Lamedon", wads={
			{id=72, name="Corugwen the Cunning", questname="corugwenthecunning", loc="61.8S, 57.7W", closedPOI="Tathrendalf", size=6, level=98, difficulty=Difficulty.GRAND_ELITE, moral="182,815", race="Human", adds={{2 , "bandits 36K", Difficulty.SIGNATURE},{3 , "ruffians 18K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 4}}, frame="corugwen.tga"},	
			{id=73, name="Old Snapper", questname="oldsnapper", loc="64.8S, 55.3W", closedPOI="Calembel", size=3, level=98, difficulty=Difficulty.ELITE, moral="83,089", race="Dread Turtle", adds={}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 3}}, frame="snapper.tga"},
			{id=74, name="The Great Bull", questname="thegreatbull", loc="66.7S, 57.7W", closedPOI="Calembel", size=3, level=98, difficulty=Difficulty.ELITE, moral="80,844", race="Bull", adds={{2 , "bulls 34K", Difficulty.SIGNATURE},{2 , "bulls 8K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 3}}, frame="grandtaureau.tga"}	
		}},
		{name="Havens of Belfalas", wads={
			{id=75, name="Skulkmire", questname="skulkmire", loc="73.5S, 59.9W", closedPOI="Tadrent", size=3, level=98, difficulty=Difficulty.ELITE, moral="99,707", race="Worm", adds={{3 , "worms 18K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 3}},  frame="skulkmire.tga"},
			{id=76, name="Ad\195\174rjan the Brute", questname="adrjanthebrute", loc="77.4S, 72.1W", closedPOI="Dol Amroth", size=1, level=99, difficulty=Difficulty.ELITE, moral="101,437", race="Human", adds={}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 2}}, frame="adirjan.tga"}
		}},
		{name="The Dead Marshes", map="5.jpg", wads={
			{id=77, name="Sorz\195\187r the Lone Hunter", questname="thelonehunter", loc="27.5S, 11.4W", size=1, level=100, difficulty=Difficulty.SIGNATURE, moral="19,104", race="Orc", adds={}, rewards={{Rewards.AMROTH_TOKEN, 2}}, frame="sorzur.tga"},
			{id=78, name="B\195\187rgoth The Taskmaster", questname="thetaskmaster", loc="27.7S, 17.8W", size=3, level=100, difficulty=Difficulty.NORMAL, moral="23,388", race="Orc", adds={{4, "orcs 19K", Difficulty.NORMAL}}, rewards={{Rewards.AMROTH_TOKEN, 3}}, frame="burgoth.tga"},	
		}},		
		{mapid=4, name="Master - Western Gondor", showme=false, pnj="Aelnir (Dol Amroth)", rovingThreatData={pnj="Aelnir (Dol Amroth)", loc={{c="59.9S, 70.8W", l="Blackroot Vale"},{c="60.2S, 64.3W", l="Blackroot Vale"},{c="62.7S, 61.0W", l="Lamedon"},{c="62.2S, 55.8W", l="Lamedon"},{c="65.7S, 53.7W", l="Lamedon"},{c="71.2S, 60.7W", l="Lamedon"},{c="71.2S, 64.6W", l="Havens of Belfalas"},{c="77.0S, 68.7W", l="Havens of Belfalas"},{c="78.7S, 69.0W", l="Havens of Belfalas"},{c="76.9S, 73.1W", l="Havens of Belfalas"}}}, wads={
			{id=1016, name="Haldalona, the Vile Darkwater", subname="haldalona",  questname="haldalonatheviledarkwater", loc="Randomly among:", size=3, level=102, difficulty=Difficulty.NEMESIS, moral="771,877", race="Darkwater", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="haldalona.tga", enemyType=2},
			{id=1018, name="Skorkaz, the Callous Dead", subname="skorkaz", questname="skorkazthecallousdead", loc="Randomly among:", size=3, level=102, difficulty=Difficulty.NEMESIS, moral="771,877", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame=nil, enemyType=2},
			{id=1014, name="Amorchant, the Winged Death", subname="amorchant",  questname="amorchantthewingeddeath", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Drake", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="amorchant.tga", enemyType=2},
			{id=1015, name="Gundlag the Death Troll", subname="gundlag",  questname="gundlagthedeathtroll", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Troll", adds={}, rewards={ {Rewards.MARQUE_DONATEUR, 3}}, frame="gundlag.tga", enemyType=2},
			{id=1017, name="Mota, the Umbarrim Scourge", subname="mota", questname="motatheumbarrimscourge", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Angmarim", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame=nil, enemyType=2},
			{id=2006, name="Gondorian Treasure Cache", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="61.8S, 69.5W", l="Blackroot Vale" }, { id=2, c="59.2S, 68.5W", l="Blackroot Vale" }, { id=3, c="60.6S, 66.1W", l="Blackroot Vale" }, { id=4, c="60.1S, 66.9W", l="Blackroot Vale" }, { id=5, c="60.6S, 64.1W", l="Blackroot Vale" }, { id=6, c="57.2S, 62.5W", l="Blackroot Vale" }, { id=7, c="62.5S, 60.6W", l="Lamedon" }, { id=8, c="65.2S, 61.0W", l="Lamedon" }, { id=9, c="65.6S, 59.4W", l="Lamedon" }, { id=10, c="67.4S, 54.5W", l="Lamedon" }, { id=11, c="72.9S, 57.5W", l="Lamedon" }, { id=12,  c="60.5S, 57.7W", l="Lamedon" }, { id=13, c="75.4S, 59.4W", l="Havens of Belfalas" }, { id=14, c="76.5S, 62.8W", l="Havens of Belfalas" }, { id=15, c="73.6S, 64.8W", l="Havens of Belfalas" }, { id=16, c="77.2S, 69.4W", l="Havens of Belfalas" }, { id=17, c="78.9S, 69.4W", l="Havens of Belfalas" }, { id=18, c="76.5S, 73.6W", l="Havens of Belfalas" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.AMROTH_TOKEN, 18}, {Rewards.TITLE, "Treasure Seeker of West Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Dol Amroth", 900}}, tag="tag_vault.tga"}
		}}
	}},
	{name="West Rohan", map="3.jpg", region=2, areas = {
		{name="Westfold", map="96.jpg",wads={
			{id=50, name="Bethan, Priestess of Isengard", questname="bethanpriestessofisengard", loc="57.1S, 88.6W", size=12, level=95, difficulty=Difficulty.NEMESIS_SUPREME, moral="977,175",race="Human", adds={{4, "mounted orcs 111K", Difficulty.GRAND_ELITE}, {2, "spiders 72K", Difficulty.ELITE}, {3, "spiders 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}},frame="priestessbethan.tga", addlinked=true},
			{id=51, name="Bosnauk", questname="bosnaukandtherovingtrolls", loc="57.5S, 82.3W", size=12, level=95, difficulty=Difficulty.ELITE, moral="73,288", race="Troll", adds={{5, "Trolls 32K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="bosnauk.tga"},
			{id=52, name="Kr\195\187p\195\187 and the Roving Orcs", questname="krpandtherovingorcs", loc="59.1S, 78.2W", size=6, level=95, difficulty=Difficulty.GRAND_ELITE, moral="161,250", race="Orc", adds={{"3", "orcs 32K", Difficulty.SIGNATURE}, {"3", "orcs 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900},{Rewards.WESTMNET_TOKEN, 2}},  frame="krupu.tga"},
			{id=53, name="Patarshan", questname="patarshan", loc="63.0S, 78.5W", size=3, level=95, difficulty=Difficulty.ELITE, moral="73,288", race="Uruk", adds={{5, "slaves 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}},frame="patarshan.tga"},
			{id=54, name="Voraut", questname="voraut", loc="54.3S, 88.0W", size=1, level=95, difficulty=Difficulty.SIGNATURE, moral="32,250", race="Warg", adds={{2, "wargs 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 500}, {Rewards.WESTMNET_TOKEN, 2}}, frame="voraut.tga"}		
		}},
		{name="Stonedeans",map="95.jpg", wads={
			{id=55, name="Inras", questname="inras", loc="56.0S, 78.5W", closedPOI="Madh-Fushaum", size=1, level=92, difficulty=Difficulty.SIGNATURE, moral="29,543", race="Wolf", adds={{3, "wolf 14K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="inras.tga", spawnShared="Rog-Votak"},
			{id=56, name="Geralht", questname="geralht", loc="53.7S, 76.2W", closedPOI="Madh-Fushaum", size=1, level=92, difficulty=Difficulty.ELITE, moral="66,471", race="Human", adds={{4, "archers 7K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="geralht.tga", spawnShared="Macsen"},
			{id=57, name="Macsen", questname="macsen", loc="53.7S, 76.2W", closedPOI="Madh-Fushaum", size=12, level=92, difficulty=Difficulty.NEMESIS_SUPREME, moral="886,275",race="Humain", adds={{3, "archers 292K", Difficulty.NEMESIS}, {4, "wariors 146K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 1200}, {Rewards.WESTMNET_TOKEN, 2}}, frame="macsen.tga", spawnShared="Geralht"},
			{id=58, name="Neivion", questname="neivion", loc="49.7S, 76.8W", closedPOI="Brockbridge", size=6, level=92, difficulty=Difficulty.NEMESIS, moral="295,425", race="Humain", adds={{3, "archers 146", Difficulty.GRAND_ELITE}, {2, "wariors 65K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="neivion.tga", spawnShared="Ognir"},
			{id=59, name="Ognir", questname="ognir", loc="49.7S, 76.8W", closedPOI="Brockbridge", size=1, level=92, difficulty=Difficulty.ELITE, moral="66,471", race="Troll", adds={}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="ognir.tga", spawnShared="Neivion"},
			{id=60, name="Rog-Votak", questname="rogvotak", loc="56.0S, 78.5W", closedPOI="Madh-Fushaum", size=6, level=92, difficulty=Difficulty.NEMESIS, moral="295,425", race="Uruk", adds={{2, "uruks 146K", Difficulty.GRAND_ELITE}, {4, "archers 28K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="rogvotak.tga", spawnShared="Inras"},	
		}},
		{name="Broadacres",map="94.jpg", wads={
			{id=61, name="Cledwun - Dunlending War-leader", questname="cledwundunlendingwarleader", loc="48.1S, 72.3W", closedPOI="Stoke", size=6, level=90, difficulty=Difficulty.GRAND_ELITE, moral="206,419", race="Mounted human", adds={{2 , "Mounted berserkers 26K", Difficulty.SIGNATURE}, {2 , "Mounted warriors 13K", Difficulty.ELITE}, {2 , "Mounted archers 13K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="cledwun.tga"},
		}},
		{name="Kingstead",map="93.jpg", wads={
			{id=62, name="Glendower", questname="glendower", loc="58.7S, 72.2W", size=6, level=87, difficulty=Difficulty.GRAND_ELITE, moral="122,463", race="mounted human", adds={{2 , "mounted warriors 54K", Difficulty.ELITE}, {2 , "mounted archers 54K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="glendower.tga"},
			{id=63, name="Ora", questname="ora", loc="61.5S, 65.2W", size=3, level=87, difficulty=Difficulty.GRAND_ELITE, moral="122,463", race="Troll", adds={{3 , "half-orcs 24K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="ora.tga"},	
			{id=64, name="N\195\187d\195\174t", questname="ndt", loc="54.3S, 66.2W", size=6, level=86, difficulty=Difficulty.GRAND_ELITE, moral="117,413", race="Mounted Uruk", adds={{2 , "mounted bersekers 52K", Difficulty.ELITE}, {2 , "Mounted defiler 24K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="nudit.tga"}
		}},
		{name="Eastfold",map="92.jpg", wads={
			{id=65, name="Darkheart", questname="darkheart", loc="68.7S, 52.6W", size=1, level=88, difficulty=Difficulty.SIGNATURE, moral="25,503", race="Huorn", adds={{2 , "huorns 13K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="coeurnoir.tga"},	
			{id=66, name="B\195\187rzash", questname="brzash", loc="66.0S, 58.3W", closedPOI="Fenmarch", size=6, level=88, difficulty=Difficulty.ELITE, moral="56,813", race="Orc", adds={{3 , "archers 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="burzash.tga"},		
			{id=67, name="Snapfang", questname="snapfang", loc="64.2S, 62.2W", size=1, level=88, difficulty=Difficulty.SIGNATURE, moral="24,998", race="Barghest", adds={{2 , "barghest 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="claquecroc.tga"},		
			{id=68, name="Scion of the Great Boar", questname="scionofthegreatboar", loc="70.4S, 60.3W", size=12, level=88, difficulty=Difficulty.NEMESIS, moral="262,500", race="Boar", adds={{5 , "boars 262K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="rejetondugrandsanglier.tga"},			
			{id=69, name="Felljaw", questname="felljaw", loc="69.6S, 62.5W", closedPOI="Aldburg", size=6, level=88, difficulty=Difficulty.ELITE, moral="56,813", race="Bear", adds={{3 , "bears 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="vilegueule.tga"},	
		}}
	}},	
	{name="Wildermore", map="2.jpg", region=2, areas = {
		{name="Wildermore", showme=false, wads={
			{ id=2299, name="Blooming in the Snow", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=85, poi={{ id=1, c="36.2S, 59.9W", l="Wild Thistle", t="Wild Thistle"}, { id=2, c="30.3S, 64.6W", l="Wild Foxglove", t="Wild Foxglove"}, { id=3, c="38.9S, 65.8W", l="Wild Iris", t="Wild Iris"}, { id=4, c="39.8S, 59.2W", l="Wild Herb", t="Wild Herb"}, { id=5, c="32.8S, 70.2W", l="Wild Red Mushrooms", t="Wild Red Mushrooms" }, { id=6, c="32.2S, 73.1W", l="Wild Wood Lily", t="Wild Wood Lily"}}, tag="tag_flag.tga"}, 
			{id=18, name="Foulwing",  questname="foulwing", loc="36.3S, 58.1W", closedPOI="Scylfig", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,028", race="Hendroval", adds={{4, "Hendroval 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500},  {Rewards.WILDERMORE_TOKEN, 3}}, frame="ailevile.tga"},
			{id=24, name="Balcharan", questname="balcharan", loc="35.0S, 60.9W", closedPOI="Scylfig", size=3, level=85, difficulty=Difficulty.ELITE, moral="50,063", race="Shade", adds={{3, "Daeguls 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="balcharan.tga"},
			{id=27, name="Voz", questname="voz", loc="38.0S, 58.3W", closedPOI="Fushaum-dor\195\161m", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="224,725", race="Mounted Ork", adds={{2, "Mounted archers 50K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 700}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="voz.tga"},	
			{id=20, name="Karkas", questname="karkas", loc="30.9S, 63.0W", closedPOI="Grimnesberg", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="24,720", race="Troll", adds={}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="karkas.tga"},
			{id=22, name="High Knolls Blizzard", questname="highknollsblizzard", loc="34.4S, 67.3W", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="24,475", race="Grim", adds={{3, "Grims 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="blizzard.tga"},
			{id=21, name="Shum", questname="shum", loc="42.9S, 57.4W", closedPOI="Farm of G\195\161rferth", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,250", race="Warg", adds={{2, "wargs 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="shum.tga"},
			{id=23, name="Arataus", questname="arataus", loc="41.8S, 54.5W", closedPOI="Farm of G\195\161rsig", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="123,375", race="Warg rider", adds={{4, "warg-riders 11K", }}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="arataus.tga", spawnShared="Shaguk"},
			{id=28, name="Zovarr", questname="zovarr", loc="43.0S, 61.1W", closedPOI="Farm of G\195\161rnoth", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="224,725", race="Uruk", adds={{5, "archers 11K", Difficulty.NORMAL},{1, "uruk 50K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 700}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="zovarr.tga"},
			{id=30, name="Shaguk", questname="shaguk", loc="41.9S, 56.2W", closedPOI="Farm of G\195\161rsig", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="674,175", race="Mounted Uruk", adds={{4, "riders 111K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="shaguk.tga", spawnShared="Arataus", addlinked=true},	
			{id=19, name="G\195\174mtog", questname="gmtog", loc="37.2S, 63.0W", closedPOI="Eastern edge of the Whitshaws", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,473",race="Wolf", adds={{3, "wolfs 11K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}},frame="gimtog.tga"},
			{id=29, name="Conog", questname="conog", loc="41.0S, 63.7W", closedPOI="Southern edge of the Whitshaws", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="674,175",race="Mounted Orc", adds={{2, "Mounted Orc 12K", Difficulty.NORMAL},{3, "archers 24K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="conog.tga", addlinked=true},
			{id=25, name="Varg", questname="varg", loc="34.3S, 69.8W", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="140,895", race="Uruk", adds={{3, "Archers 18K",Difficulty.SIGNATURE},{2, "protectors 54K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="varg.tga"},
			{id=26, name="Rottenheart",questname="rottenheart", loc="34.7S, 71.6W", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="422,685", race=ToUTF8("Huorn"), adds={{3, "wood-trolls (90K)", Difficulty.GRAND_ELITE},{2, "ancient wood-trolls (52K)", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="coeurmalsain.tga"},
		}}
	}},
	{name="East Rohan", map="1.jpg", region=2, areas = {
		{name="The Wold", map="71.jpg", wads={
			{id=1, name="Cinder", questname="cinder", loc="39.3S, 54.1W", closedPOI="Venomtongue,", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Salamander - Dragon", adds={{2, "salamander 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="cendre.tga"},
			{id=2, name="Hanrun", questname="hanrun", loc="44.1S, 50.3W", closedPOI="South of Feldburg", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Warg", adds={{2, "wargs 4K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="hanrun.tga"},
			{id=3, name="Urush", questname="urush", loc="40.9S, 47.4W", closedPOI="Cracabor", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Mounted Easterling", adds={{2, "Riders 9K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="urush.tga"},
			{id=4, name="Bughrakh", questname="bughrakh", loc="44.1S, 48.2W", closedPOI="The woods east of Floodwend", size=3, level=77, difficulty=Difficulty.GRAND_ELITE, moral="97,792", race="Orc", adds={{4, "Archers 4K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="bughrakh.tga"},
			
		}},
		{name="Norcrofts", map="73.jpg", wads={
			{id=5, name="Dah\195\161mab", questname="dahamab", loc="45.2S, 57.5W", closedPOI="Cliving", size=1, level=79, difficulty=Difficulty.SIGNATURE, moral="20,700", race="Mounted Uruk", adds={{3, "Mounted Uruks 10K",Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="dahamab.tga"},
			{id=6, name="Sk\195\186tog", questname="sktog", loc="50.1S, 55.5W", closedPOI="Domaine printanier", size=1, level=79, difficulty=Difficulty.ELITE, moral="47,041", race="Warg-riders", adds={{4, "Mounted uruks 10K",Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="skutog.tga"},
			{id=7, name="Swertripeur", questname="swertrper", loc="53.6S, 54.2W", closedPOI="South of Elthengels", size=1, level=79, difficulty=Difficulty.ELITE, moral="37,633", race="Lathbear", adds={{2, "Lathbear 10K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="swertriper.tga"},
			{id=8, name="Haglob", questname="haglob", loc="45.9S, 45.3W", closedPOI="Northwest of Elthengels", size=3, level=79, difficulty=Difficulty.GRAND_ELITE, moral="126,684", race="Troll",adds={}, rewards={{Rewards.ROHAN_TOKEN, 3}},  frame="haglob.tga"},	
		}},	
		{name="Entwash Vale", map="76.jpg", wads ={
			{id=9, name="Besengan", questname="besengan", loc="50.2S, 61.7W", closedPOI="Maustarz", size=1, level=80, difficulty=Difficulty.NORMAL, moral="9,216", race="Dragon", adds={{2, "Draks 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="besengan.tga", spawnShared="D\195\162l, Fearrhorn and Urgai"},
			{id=10, name="M\195\162thum", questname="mthum", loc="43.7S, 64.9W", closedPOI="North of Eaworth", size=1, level=80, difficulty=Difficulty.SIGNATURE, moral="13,326", race="Warg-rider", adds={{3, "warg-riders 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="mathum.tga", spawnShared="Mirz"},
			{id=11, name="D\195\162l", questname="dl", loc="50.6S, 61.3W", closedPOI="Maustarz", size=3, level=80, difficulty=Difficulty.GRAND_ELITE, moral="111,581", race="Mounted uruks", adds={{1, "Mounted archers 49K", Difficulty.ELITE},{2, "Mounted uruks 40K", Difficulty.ELITE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="dal.tga", spawnShared="Besengan, Fearrhorn and Urgai"},
			{id=12, name="Fearrhorn", questname="fearrhorn", loc="50.5S, 62.0W", closedPOI="Maustarz", size=3, level=80, difficulty=Difficulty.GRAND_ELITE, moral="129,623", race="Auroch", adds={{4, "Aurochs 10K", Difficulty.NORMAL},{3, "Auroch 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="corneterrible.tga", spawnShared="Besengan, D\195\162l and Urgai"},
			{id=13, name="Mirz", questname="mirz", loc="44.8S, 63.0W", closedPOI="Southeast of Thornhope", size=3, level=81, difficulty=Difficulty.ELITE, moral="51,849", race="Half-orc", adds={{2, "wargs 22K", Difficulty.SIGNATURE},{2, "Archers 11K", Difficulty.NORMAL},{2, "Mounted half-orcs", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="mirz.tga"},
			{id=14, name="Urgai", questname="urgai", loc="50.6S, 62.2W", closedPOI="Maustazg", size=6, level=81, difficulty=Difficulty.NEMESIS, moral="223,161", race="Black Uruk of Mordor", adds={{1, "Mounted uruk 41K", Difficulty.ELITE},{1, "Mounted archers 41K", Difficulty.ELITE}}, addlinked=true, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="urgai.tga", spawnShared="Besengan, D\195\162l and Fearrhorn"},
		}},
		{name="Sutcrofts", map="75.jpg", wads={
			{id=15, name="Gundul", questname="crabanmastergundul", loc="56.6S, 60.6W", closedPOI="Southeast of Garsfeld", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="121,516", race="Half-orc", adds={{8, "Crows 12K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="gundul.tga", },
			{id=16, name="Kramp", questname="kramp", loc="60.3S, 60.1W", closedPOI="Fields of the Sutcrofts", size=6, level=85, difficulty=Difficulty.GRAND_ELITE, moral="124,100", race="Warg-rider", adds={{4, "Warg-riders 25K", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="kramp.tga", },
			{id=17, name="Bugud", questname="warmasterbugud", loc="59.8S, 57.8W", closedPOI="Fields of the Sutcrofts", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="783,383",race="Mounted orc", adds={{3, "Mounted orcs 25K", Difficulty.SIGNATURE},{2, "wargs 31K", Difficulty.ELITE}}, rewards={{Rewards.ROHAN_TOKEN, 3},{Rewards.SILVER_SUTCROFTS_PRESENT, 1}}, frame="bugud.tga", addlinked=true},
		}}
	}},
	{name="Southern Mirkwood", map="11.jpg", region=2, areas={
		{name="Southern Mirkwood", showme=false, rovingThreatData={loc={{c="13.4S, 59.0W"},{c="19.3S, 46.7W"},{c="18.2S, 48.7W"},{c="12.8S, 43.7W"},{c="16.1S, 53.5W"},{c="15.2S, 58.2W"}}, pnj="GellFriendel (Ost Galadh)"},wads={ 
			{id=1032, name="Helchurth, the Eternal Shadow", subname="helchurth", questname="helchurththeeternalshadow", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Wraith", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="helchurth.tga", enemyType=2},
			{id=1033, name="Thorang, the Spirit Armour", subname="thorang", questname="thorangthespiritarmour", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="thorang.tga", enemyType=2},	
			{id=1031, name="Ghamgur, the Giant Dread", subname="ghmgur",questname="ghmgurthegiantdread", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ghamgur.tga", enemyType=2},
			{id=1034, name="Woe-weaver, the Silent Fear", subname="woeweaver", questname="woeweaverthesilentfear", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Spider", adds={{10, "spiders 20K", Difficulty.NORMAL}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="tisseuse.tga", enemyType=2},
			{id=2001, name="Treasure of Southern Mirkwood", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="17.3S, 61.7W", l="At the ruined tower of Tirnhirion" }, { id=2, c="15.9S, 59.3W", l="Amongst The Wind Stones" }, { id=3, c="19.1S, 57.9W", l="Behind carved stones" }, { id=4, c="11.2S, 56.2W", l="In a ditch between the Dourstocks and Dannenglor" }, { id=5, c="12.4S, 54.6W", l="On a balcony in Dannenglor" }, { id=6, c="13.4S, 52.6W", l="Amongst the trees northwest of Ost Galadh" }, { id=7, c="8.7S, 51.8W", l="On a ledge in Gorogrod jutting out over the big hole" }, { id=8, c="12.2S, 45.4W", l="Atop a siege tower in Kufuzg" }, { id=9, c="14.8S, 41.7W", l="Left of the staircase at the entrance to the Dungeons of Dol Guldur" }, { id=10, c="16.4S, 42.5W", l="Behind a rock on the secret path to Dol Guldur" }, { id=11, c="19.3S, 43.6W", l="On a ledge east of the island in the Bleakmere" }, { id=12, c="19.5S, 48.5W", l="South of Sad Morangol" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Southern Mirkwood"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Malledhrim", 900}}, tag="tag_vault.tga"}
		}}
	}},
	{name="Dunland", map="80.jpg", region=1, areas={
		{name="Nan Curunir", map="80.jpg", wads={
			{id=5060, name="Instances of Isengard\n[Instance discovery]", questname="DiscoveryInstancesofIsengard", subname="DiscoveryInstancesofIsengard", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=75, poi={ { id=1, c="79.9S, 0.2E", l="Discovery instances : Dargnakh Unleashed, Pits of Isengard, Fangorn's Edge, The Foundry, The Tower of Orthanc." }}, tag="tag_instance.tga"},
		}}
	}},			
	{name="The Great River", map="68.jpg", region=2, areas={
		{name="The Great River", showme=false, wads={
			{id=2391, name="The Roots of Fangorn\n[Instance discovery]", questname="DiscoveryRootsofFangorn", subname="DiscoveryRootsofFangorn", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=75, poi={ { id=1, c="28.7S, 72.2W", l="Entry of the instance : The Roots of Fangorn." }}, rewards={{Rewards.TURBINE, 10}}, tag="tag_instance.tga"},
			{id=2392, name="Ancient Ruins of the Limlight", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=75, poi={{ id=1, c="28.1S, 68.9W", l="Ancient Ruins", t="Ancient Ruins"}, { id=2, c="27.0S, 69.0W", l="Mysterious Ruins", t="Mysterious Ruins"}, { id=3, c="25.9S, 69.1W", l="Tumbled Ruins", t="Tumbled Ruins"}, { id=4, c="27.4S, 70.4W", l="Hallowed Ruins", t="Hallowed Ruins"}, { id=5, c="27.0S, 71.2W", l="Engraved Ruins", t="Engraved Ruins" }, { id=6, c="25.4S, 70.9W", l="Crumbling Ruins", t="Crumbling Ruins"}}, rewards={{Rewards.TURBINE, 10}, {Rewards.REPUTATION, "Heroes of Limlight Gorge", 500}}, tag="tag_flag.tga"},
			{id=2412, name="The Spirits of the Limlight", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=75, poi={{ id=1, c="28.0S, 68.7W", l="Spirit of Reverence", t="Spirit of Reverence"}, { id=2, c="27.1S, 67.6W", l="Spirit of Remembrance", t="Spirit of Remembrance"}, { id=3, c="26.3S, 68.0W", l="Spirit of Amity", t="Spirit of Amity"}, { id=4, c="26.3S, 69.1W", l="Spirit of Melody", t="Spirit of Melody"}, { id=5, c="26.5S, 70.6W", l="Spirit of Enlightenment", t="Spirit of Enlightenment" }, { id=6, c="27.6S, 71.8W", l="Spirit of Destiny", t="Spirit of Destiny"}}, rewards={{Rewards.TURBINE, 10}, {Rewards.REPUTATION, "Heroes of Limlight Gorge", 1200}}, tag="tag_flag.tga"},
		}}
	}},		
	{name="Enedwaith", map="65.jpg", region=1, areas={
		{name="Enedwaith", showme=false, wads={
			{id=2388, name="Draigoch's Lair\n[Instance discovery]", questname="Draigoch's Lair -- Discovery", subname="Draigoch's Lair -- Discovery", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=75, poi={ { id=1, c="67.3S, 6.6O", l="Entry of the raid : Draigoch's Lair.\nUnlockable at level 75, by the quests line \"There is Gold in the Hills\" (Ariene : 80.5S, 16.4W in Galtrev)" }}, rewards={{Rewards.TURBINE, 5}}, tag="tag_instance.tga"},
			{ id=2367, name="Little Wonders", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=62, poi={{ id=1, c="64.3S, 22.2O", l="Small Arrow", t="Small Arrow"}, { id=2, c="61.3S, 19.2O", l="Small Boots", t="Small Boots"}, { id=3, c="63.3S, 22.2O", l="Small bucket", t="Small Bucket"}, { id=4, c="63.3S, 22.6O", l="Small Skeleton", t="Small Skeleton"}, { id=5, c="64.6S, 20.4O", l="Small Pick/Tool", t="Small Tool" }, { id=6, c="63.7S, 23.0O", l="Small Bow", t="Small Bow"}}, rewards={{Rewards.TURBINE, 10}}, tag="tag_flag.tga"},
			{ id=2368, name="The Long Road of the Hobbits", target="Hobbit-lamp", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=62, multipoi={{map="65.jpg", poi={{ id=1, c="70.8S, 19.4O", l="Hobbit Lamp-post near Unig-pulh"}, { id=2, c="66.5S, 21.2O", l="Hobbit Lamp-post near Echad Daervunn"}, { id=3, c="63.2S, 22.9O", l="Hobbit Lamp-post near Maur Tulhau"}}},{map="61.jpg", poi={{ id=4, c="27.2S, 67.6O", l="Hobbit Lamp-post near the Statue of the Bullroarer in Brockenborings in the Shire"}}}}, rewards={{Rewards.TURBINE, 5},{Rewards.EMOTE, "Grant Golf Chip"},{Rewards.VERTUES, 1000}}, tag="tag_flag.tga"},
			{ id=2369, name="Exiles from the Lonely Mountain", target="Dwarf-marker", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=62, multipoi={{map="65.jpg", poi={{ id=1, c="71.8S, 15.6O", l="Dwarf-marker at Fordh Maru"}, { id=2, c="65.7S, 8.5O", l="Dwarf-marker at Nar's Peak"}, { id=3, c="65.6S, 18.2O", l="Dwarf-marker near the Pool of the King"}, { id=4, c="65.2S, 16.7O", l="Dwarf-marker near Araniant"}, { id=5, c="57.4S, 14.4O", l="Dwarf-marker in Fordirith"}}},{map="62.jpg", poi={{ id=6, c="27.2S, 67.6O", l="Dwarf-marker in Thorin's Hall (Close to the Hunter Trainer and Bowyers)", m={x=49, y=5}}}}}, rewards={{Rewards.TURBINE, 5},{Rewards.EMOTE, "Coup sec au golf"},{Rewards.VERTUES, 1000}}, tag="tag_flag.tga"},
			{id=2386, name="Fisher-king\n[Hidden deed]", questname="Fisher-king", subname="Fisher-king", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=62, poi={ { id=1, c="63.2S, 24.0O", l="When you leave Maur Tulhau, keep right and jump on the rocks at [63.1S, 23.1W]. Keep on westward to [63.1S, 23.6W]. You can reach the cottage running on the left side of the pond." }}, rewards={{Rewards.TURBINE, 5},{Rewards.TITLE, "Fisher-king"}, {Rewards.REPUTATION, "Algraig", 500}}, tag="tag_flag.tga"},
			{id=2387, name="Discoverer of Ost Dunhoth\n[Raid discovery]", questname="Discoverer of Ost Dunhoth", subname="Discoverer of Ost Dunhoth", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=62, poi={ { id=1, c="75.2S, 19.7O", l="Entry of the raid : Ost Dunhoth" }}, rewards={{Rewards.TURBINE, 5}}, tag="tag_flag.tga"},
		}}
	}},	
	{name="Moria", map="9.jpg", region=1, areas={
		{name="Moria", showme=false,wads={ 
			{ id=2413, name="Reflections", target="Moria-mirror", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=50, multipoi={
				{map="81.jpg",poi={{ id=1, c="6.9S, 112.9W", l="Quest: Lighting the Way"}}}, 
				{map="87.jpg",poi={{ id=2, c="11.3S, 112.5W", l="Quest: Reflections of Rails"}}}, 
				{map="90.jpg",poi={{ id=3, c="5.3S, 98.7W", l="Quest: Reflections of Stone Trees"}}}, 
				{map="84.jpg",poi={{ id=4, c="15.1S, 114.8W", l="Quest: Mirror in the Mire"}}}, 
				{map="82.jpg",poi={{ id=5, c="3.6S, 109.0W", l="Quest: A Light in the Garden"}}}, 
				{map="87.jpg",poi={{ id=6, c="12.5S, 103.1W", l="Quest: Reflector of the Redhorn"}}}, 
				{map="86.jpg",poi={{ id=7, c="15.0S, 107.8W", l="Quest: Reflection of Flame"}}}, 
				{map="85.jpg",poi={{ id=8, c="7.7S, 105.3W", l="Quest: Reflecting on the Past"}}}, 
				{map="88.jpg",poi={{ id=9, c="12.0S, 101.6W", l="Quest: A Glimmer of Hope"}}}, 
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Reflector"}}, tag="tag_flag.tga"},
			{ id=2414, name="The Pits of Moria\n[Hidden deed]", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=50, note="You have to jump into the precipices and die.\nA sentence appears when the jump is validated.", multipoi={
				{map="82.jpg",poi={{ id=1, c="2.6S, 105.9W", l="Jump off the cliff facing the Endless Stair."}}}, 
				{map="81.jpg",poi={{ id=2, c="6.8S, 112.0W", l="Jump East from the middle of the bridge."}}},
				{map="83.jpg",poi={{ id=3, c="11.0S, 112.8W", l="Jump South East."}}}, 
				{map="87.jpg",poi={{ id=4, c="10.4S, 104.0W", l="Jump off the ramps near the Gate of Ruin3"}}}, 
				{map="90.jpg",poi={{ id=5, c="10.1S, 100.6W", l="Jump East."}}}, 
				{map="90.jpg",poi={{ id=6, c="5.5S, 99.8W", l="Jump South."}}}
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Blind Leaper"}}, tag="tag_flag.tga"},
			{id=2415, map="88.jpg",name="Askad-mazal, the Chamber of Shadows\n[Instance discovery]", questname="DiscovererofAskdmazal", subname="DiscovererofAskdmazal", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=50, poi={ { id=1, c="14.1S, 94.9O", l="Entry of the instance : Askad-mazal, the Chamber of Shadows." }}, rewards={{Rewards.TURBINE, 10}}, tag="tag_instance.tga"},			
		}}
	}},	
	{name="Angmar", map="9.jpg", region=1, areas={
		{name="Angmar", showme=false, rovingThreatData={loc={{c="0.6N, 36.3W"},{c="4.8N, 34.5W"},{c="2.4N, 32.0W"},{c="0.8N, 28.7W"},{c="0.8N, 27.2W"},{c="0.6N, 20.8W"},{c="3.1N, 24.1W"},{c="5.8N, 23.4W"},{c="7.1N, 20.1W"},{c="8.6N, 28.5W"},{c="11.3N, 27.1W"}}, pnj="Cannakh (Aughaire)"},wads={
			{id=2397, name="The Halls of Night\n[Instance discovery]", questname="DiscovertheHallsofNight", subname="DiscovertheHallsofNight", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=40, poi={ { id=1, c="0.4N, 37.6W", l="Entry of the instance : The Halls of Night." }}, rewards={{Rewards.TURBINE, 10}}, tag="tag_instance.tga"},
			{id=1004, name="Ashthrok, the Fire Seeker", subname="ashthrok", questname="ashthrokthefireseeker", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="ashthrok.tga", enemyType=2},
			{id=1005, name="Khruthakh, the Untiring", subname="khruthakh", questname="khruthakhtheuntiring", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame="khruthakh.tga", enemyType=2},
			{id=1006, name="Shakatrog, the Dreaded", subname="shakatrog", questname="shakatrogthedreaded", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="shakatrog.tga", enemyType=2},	
			{id=1007, name="Ulkharn, the Commander", subname="ulkharn", questname="ulkharnthecommander", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ulkharn.tga", enemyType=2},	
			{id=1008, name="V\195\169lnas, the Seer", subname="vlnas", questname="vlnastheseer", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}},  frame="velnas.tga", enemyType=2},	
			{id=1009, name="Epilogue: Amardam, the Ancient Evil", subname="amardam", questname="epilogueamardamtheancientevil", loc="Middle of lake Duvuinen", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="amardam.tga", enemyType=2, note="You must have completed all 5 previous RT quests in order to do this Epilogue.", rovingThreatData={loc={{c="0.2N, 27.4W"}}}},
			{id=2005, name="Treasure of Angmar", target="TreasureCache", enemyType=3, frame="treasure.tga", questname="", size=1, level=90, poi={ { id=1, c="0.7S, 36.5W", l="At the far end of the Blade Beak canyon" }, { id=2, c="3.9N, 39.8W", l="Right behind Bloodwing in the Drake area" }, { id=3, c="6.3N, 37.9W", l="	At the top of Dun Covad by War-master Ranghash" }, { id=4, c="12.2N, 29.5W", l="Near the iron gate of Carn Dum" }, { id=5, c="12.1N, 27.3W", l="In Himbar, in a little alcove" }, { id=6, c="13.0N, 25.4W", l="In Bogbereth's nest" }, { id=7, c="9.6N, 22.9W", l="On the road to Minas Caul, in a ridge" }, { id=8, c="10.3N, 14.3W", l="After the Nurz Ghashu fault" }, { id=9, c="4.5N, 21.1W", l="In a corner at the end of the road" }, { id=10, c="1.6S, 23.2W", l="On a ridge above Krusle Lannan" }, { id=11, c="4.7N, 29.2W", l="Against a wall by Imlad Balchorth" }, { id=12, c="7.2N, 30.4W", l="On an island of Anglanthir, surrounded by deadly water" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Angmar"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Council of the North", 900}}, tag="tag_vault.tga"},

		}}
	}},
	{name="Misty Mountains",  map="8.jpg", region=1, areas={
		{name="Misty Mountains", showme=false, rovingThreatData={loc={{c="25.4S, 0.1E"},{c="23.1S, 1.2E"},{c="31.1S, 3.3E"},{c="21.9S, 4.4E"},{c="22.1S, 7.6E"},{c="22.5S, 4.1E"},{c="23.6S, 7.2E"},{c="27.8S, 8.2E"}}, pnj="Ostas\195\164nt (S\195\187ri-Kyla)"},wads={ 
			{id=1001, name="Hrimdyr, the Beast King", subname="hrimdyr", questname="hrimdyrthebeastking", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,477", race="Snowbeast", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="hrimdyr.tga", enemyType=2},
			{id=1002, name="Krabakam, the Master Hunter", subname="krabakam", questname="krabakamthemasterhunter", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,477", race="Gauradan", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame=nil, enemyType=2},	
			{id=1000, name="Gr\195\180thurs, the Stone Giant", subname="grthurs", questname="grthursthestonegiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Giant", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="grothurs.tga", enemyType=2},
			{id=1003, name="Sutmoth, the Ice Giant", subname="stmoth", questname="stmoththeicegiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Giant", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="sutmoth.tga", enemyType=2},
			{id=2003, name="Treasure of the Misty Mountains", target="TreasureCache", enemyType=3, frame="treasure.tga", questname="", size=1, level=90, poi={ { id=1, c="23.9S, 7.4E", l="North East of Hrimbarg" }, { id=2, c="21.8S, 8.7E", l="Behind a wall in Domstoll" }, { id=3, c="20.8S, 5.1E", l="Near the Black Crack (requires a jump)" }, { id=4, c="23.0S, 2.6E", l="North of Gurzmat, in a mountain hollow" }, { id=5, c="20.5S, 3.4W", l="On a small hill" }, { id=6, c="23.4S, 4.3W", l="At the source of the frozen river" }, { id=7, c="23.7S, 2.3W", l="In a corner of the mountain" }, { id=8, c="25.1S, 0.6W", l="At the end of the road" }, { id=9, c="31.4S, 0.4E", l="Behind a rock, in the troll area" }, { id=10, c="28.5S, 4.1E", l="Following the path, against a giant's house" }, { id=11, c="28.3S, 6.7E", l="Towards a small alcove" }, { id=12, c="26.1S, 9.6E", l="In the Ruinuan cellar" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of The Misty Mountains"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Thorin's Hall", 900}}, tag="tag_vault.tga"}
		}}
	}},		
	{name="Forochel", map="10.jpg", region=1, areas={
		{name="Forochel", showme=false, rovingThreatData={loc={{c="16.8N, 86.2W", l="Talvi-Muri"},{c="18.8N, 85.4W", l="Talvi-Muri"},{c="12.7N, 80.3W", l="Talvi-Muri"},{c="10.8N, 79.5W", l="Talvi-Muri"},{c="7.9N, 77.1W", l="Lansi-ma"},{c="8.1N, 76.7W", l="Lansi-ma"},{c="5.5N, 74.5W", l="Lansi-ma"},{c="14.2N, 74.4W", l="Talvi-Muri"},{c="10.5N, 73.0W", l="Ita-ma"},{c="20.6N, 69.4W", l="Suri-kyla"},{c="17.6N, 67.2W", l="Ja-rannit"},{c="12.2N, 66.7W", l="Ja-rannit"}}, pnj="Authi (camp de Glo\195\175n)"},wads={ 
			{id=2395, name="S\195\162ri-surma\n[Instance discovery]", questname="DiscovererofSrisurma", subname="DiscovererofSrisurma", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=65, poi={ { id=1, c="20.2N, 78.8O", l="Entry of the instance : S\195\162ri-surma." }}, tag="tag_instance.tga"},
			{id=1010, name="Krevchal, the Brutal Chieftain", subname="krevchal", questname="krevchalthebrutalchieftain", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", power="36,781", race="Gauradan", adds={{1, "wolf 87K", Difficulty.ELITE}, {2, "wolfs 39K", Difficulty.SIGNATURE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="krevchal.tga", enemyType=2},
			{id=1011, name="Mustarka, the Treacherous Wight", subname="mustarka", questname="mustarkathetreacherouswight", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Wight", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="mustarka.tga", enemyType=2},
			{id=1012, name="Gronkerna, The Juggernaut Slave", subname="gronkerna", questname="gronkernathejuggernautslave", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Mammoth", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="gronkerna.tga", enemyType=2},
			{id=1013, name="Ukko Surma, the Undying Giant", subname="ukko", questname="ukkosurmatheundyinggiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Wight", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ukkosurma.tga", enemyType=2},
			{id=2004, name="Treasure of Forochel", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="20.2N, 74.1W", l="On the shore northwest of the boat to Sari-surma" }, { id=2, c="15.7N, 68.1W", l="On an isle in the bay (approach from the east to avoid one-shot areas in the bay)" }, { id=3, c="10.4N, 65.7W", l="Behind large rocks across a snowfield at Ita-ma" }, { id=4, c="12.6N, 69.7W", l="On a bluff near the water north of Pynti-peldot" }, { id=5, c="13.9N, 75.4W", l="Behind the far west ruin in the Lonesome Stones" }, { id=6, c="9.0N, 70.8W", l="Behind a tent in Pynti-leiri" }, { id=7, c="4.9N, 77.3W", l="In a corner near the waterfall" }, { id=8, c="6.2N, 79.6W", l="At the northwestern tip of Kissa-sari" }, { id=9, c="8.0N, 78.9W", l="Under a tent in Norsu-leiri" }, { id=10, c="9.2N, 82.2W", l="In the Winter-worm area northwest of Zigilgund, on the southwestern bank of the channel near the falls" }, { id=11, c="15.6N, 88.2W", l="Along the mountain wall north of Jotunstath" }, { id=12, c="20.1N, 85.2W", l="Atop the west wall at the entrance to Kibilzahar" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Forochel"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Lossoth of Forochel", 900}}, tag="tag_vault.tga"}
		}}
	}},	
	{name="Trollshaws", map="67.jpg", region=1, areas={
		{name="Trollshaws", showme=false, wads={
			{id=2396, name="Lost Temple\n[Instance discovery]", questname="DiscoveryLostTemple", subname="DiscoveryLostTemple", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=65, poi={ { id=1, c="26.6S, 14.1O", l="Entry of the instance : Lost Temple." }}, rewards={{Rewards.TURBINE, 5},{Rewards.TITLE, "Temple Rider"}}, tag="tag_instance.tga"},
		}}
	}},
	{name="Evendim", map="12.jpg", region=1, areas={
		{name="Evendim", showme=false, rovingThreatData={loc={{c="6.1S, 73.9W"},{c="16.1S, 75.2W"},{c="18.6S, 70.2W", l="Annuminas"},{c="5.8S, 61.4W", l="Tyrn Fornech"},{c="15.3S, 64.4W", l="Barandalf"},{c="9.0S, 74.1W", l="Emyn Vial"},{c="16.7S, 64.1W", l="Barandalf"},{c="5.0S, 68.4W", l="Tham Habad"}}, pnj="Brangil (Tinnudir)"},wads={ 
			{id=2393, name="Northcotton Farm\n[Instance discovery]", questname="DiscoveryNorthcottonFarm", subname="DiscoveryNorthcottonFarm", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=65, poi={ { id=1, c="22.9S, 68.0W", l="Entry of the instance : Northcotton Farm." }}, tag="tag_instance.tga"},
			{id=1035, name="Droghus, the Chieftain", subname="droghus", questname="droghusthechieftain", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Gauradan", adds={{1, "Gauradan 85K", Difficulty.ELITE},{2, "wolfs 31K", Difficulty.SIGNATURE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="droghus.tga", enemyType=2},
			{id=1036, name="S\195\187nath, the Treacherous", subname="snath", questname="snaththetreacherous", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Angmarim", adds={{2, "archers 93K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame="sunath.tga", enemyType=2},
			{id=1037, name="T\195\162rlug, the Servant", subname="trlug", questname="trlugtheservant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Troll", adds={{2, "angmarims 112K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 3}},  frame="tarlug.tga", enemyType=2},
			{id=2002, name="Treasure of Evendim", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="13.8S, 73.6W", l="On a small island southwest of Tyl Ruinen" }, { id=2, c="11.9S, 72.3W", l="In the middle of Tyl Ruinen" }, { id=3, c="8.1S, 75.3W", l="	At the top of Amon Moth" }, { id=4, c="7.5S, 68.3W", l="On the shore just east of Rantost" }, { id=5, c="8.7S, 67.0W", l="Outside the west wall of Tham Ornen" }, { id=6, c="4.2S, 65.6W", l="In some bushes at Tum Fuin" }, { id=7, c="7.9S, 61.8W", l="At the top of the mountain at Nan Orngon" }, { id=8, c="9.4S, 63.0W", l="	Behind the totem at Tham Andalath" }, { id=9, c="15.8S, 69.9W", l="To the left around the edge from the Titan of Tyl Annun" }, { id=10, c="20.2S, 60.7W", l="On the eastern shore of Barandalf" }, { id=11, c="19.7S, 64.6W", l="On a hill behind the Whitshards" }, { id=12, c="17.2S, 65.6W", l="In a small camp behind Haudh Tarcil in Men Erain" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Evendim"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The Wardens of Annuminas", 900}}, tag="tag_vault.tga"}
		}}
	}},
	{name="Lone-lands", region=1, areas={
		{name="Lone-lands", map="66.jpg", showme=false, wads={ 
			{id=2389, name="Inn of the Forsaken\n[Instance discovery]", questname="Inn of the Forsaken", subname="Inn of the Forsaken", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=20, poi={ { id=1, c="34.0S, 40.7O", l="The instance takes place at the Forsaken Inn. It is started at Anlaf the Forlorn with the help of the quest Inn of the Forsaken: Stroke of Midnight. Then, find your way down the basement." }}, tag="tag_instance.tga"},
		}}	
	}},	
	{name="The North Downs", map="13.jpg", region=1, areas={
		{name="The North Downs", showme=false, rovingThreatData={loc={{c="7.0S, 53.6W"},{c="13.8S, 53.1W"},{c="9.7S, 56.2W"},{c="9.6S, 52.3W"},{c="11.0S, 47.3W"},{c="11.4S, 58.4W"},{c="12.2S, 57.9W"},{c="8.7S, 36.2W"},{c="8.2S, 37.4W"},{c="8.2S, 33.0W"}}, pnj="Othwen (Esteldin)"},wads={ 
			{id=2394, name="Stoneheight\n[Instance discovery]", questname="DiscoveryStoneheight", subname="DiscoveryStoneheight", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=65, poi={ { id=1, c="9.5S, 50.1W", l="Entry of the instance : Stoneheight." }}, tag="tag_instance.tga"},
			{id=1038, name="D\195\187rlum, the Disturbed", subname="drlum", questname="drlumthedisturbed", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="durlum.tga", enemyType=2},	
			{id=1039, name="Valikas, the Misguided", subname="valikas", questname="valikaslgar", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Ogre", adds={{2, "adds 234K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="valikas.tga", enemyType=2},	
			{id=1040, name="Rotspittle, the Corrupted", subname="rotspittle", questname="rotspittlethecorrupted", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Drake", adds={}, frame=nil, enemyType=2},	
			{id=2000, name="Treasure of The North Downs", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="9.9S, 58.4W"}, { id=2, c="6.7S, 53.3W"}, { id=3, c="16.4S, 53.8W", l="Below the bridge" }, { id=4, c="13.7S, 51.6W", l="On a small island" }, { id=5, c="6.9S, 47.9W", l="At the waterfall" }, { id=6, c="19.1S, 46.3W", l="Behind Drukordh's tent" }, { id=7, c="6.0S, 43.5W", l="On a hill in Kamskut" }, { id=8, c="8.6S, 40.1W", l="On a hill north of Rusfold" }, { id=9,  c="16.6S, 37.5W", l="In Zaukil's tent" }, { id=10, c="16.3S, 41.0W", l="Southeast of Taur Gonwaith" }, { id=11, c="15.4S, 36.2W", l="On top of a hill"},{id=12, c="11.2S, 33.7W",l="In a Kar Lak tent"}},rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of North Downs"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Rangers of Esteldin", 900}}, tag="tag_vault.tga"}
		}}
	}},	
	{name="Cardolan", region=1, map="70.jpg", areas={
		{name="Cardolan", showme=false,wads={ 	
			{id=5064, name="Treasure of Cardolan", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=15, poi={
				{id=1, c="49.0S, 36.1W"},
				{id=2, c="51.1S, 36.7W"},
				{id=3, c="46.2S, 49.8W"},
				{id=4, c="46.0S, 42.1W"},
				{id=5, c="39.7S, 50.5W"},
				{id=6, c="37.3S, 55.5W"},
				{id=7, c="49.4S, 54.5W"},
				{id=8, c="40.6S, 31.0W"},
				{id=9, c="45.0S, 53.0W"},
				{id=10, c="45.9S, 27.4W"},
				{id=11, c="54.7S, 45.7W"},
				{id=12, c="38.3S, 40.1W"},
				{id=13, c="55.7S, 36.8W"}
			}, rewards={{Rewards.VERTUES, 3000}, {Rewards.TITLE, "Treasure-seeker of Cardolan"}, {Rewards.REPUTATION, "Dunedain of Cardolan", 700}}, tag="tag_vault.tga"},
			{id=5066, name="The Ravaging of Cardolan", target="SUB", enemyType=3, frame="treasure.tga", size=1, level=15, poi={
				{id=1, c="56.7S, 37.4O", l="Levee Plaque", t="Levee Plaque"},
				{id=2, c="53.6S, 53.6W", l="Oath Plaque", t="Oath Plaque"},
				{id=3, c="39.6S, 50.6W", l="Stone Seat", t="Stone Seat"},
				{id=4, c="44.3S, 29.2W", l="Deadmount Obelisk", t="Deadmount Obelisk"},
				{id=5, c="44.1S, 51.7W", l="Ashmound", t="Ashmound"},
				{id=6, c="54.3S, 40.2W", l="Scroll of Luilloth\nGiven after a series of quests starting with Rhiangar", t="Scroll of Luilloth"}
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 1000}, {Rewards.TITLE, "Seeker of the Vanished Realm"}, {Rewards.REPUTATION, "Dunedain of Cardolan", 700}}, tag="tag_vault.tga"},
			{id=5067, name="Sarch Vorn, the Grey Fear\n[Instance discovery]", questname="DcouverteSarchVorntheGreyFear", subname="DcouverteSarchVorntheGreyFear", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="37.6S, 52.W", l="Entry of the instance : Sarch Vorn, the Grey Fear." }}, tag="tag_instance.tga"},
			{id=5072, name="Crugaul", questname="Crugaul", size=1, level=28, difficulty=Difficulty.GRAND_ELITE, moral="11,600", race="Lath-bear", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="37.5S, 52.8W"},{c="37.7S, 53.4W"}}}, enemyType=2},
			{id=5074, name="Agerbrath", questname="Agerbrath", size=1, level=27, difficulty=Difficulty.ELITE, moral="5,040", race="Spider", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="41.7S, 54.1W"},{c="42.4S, 54.6W"}}}, enemyType=2},
			{id=5075, name="Penthul", questname="Penthul", size=1, level=26, difficulty=Difficulty.ELITE, moral="4,860", race="Death", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="42.0S, 51.0W"},{c="42.4S, 52.2W"}}}, enemyType=2},
			{id=5070, name="Withergrip", questname="Withergrip", size=1, level=25, difficulty=Difficulty.ELITE, moral="2,100", race="Death", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="41.4S, 49.3W"},{c="42.3S, 49.5W"}}}, enemyType=2},
			{id=5073, name="Borhashat", questname="Borhashat", size=1, level=24, difficulty=Difficulty.ELITE, moral="4,230", race="Orc", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="48.9S, 34.1W"},{c="49.3S, 34.0W"}}}, enemyType=2},
			{id=5068, name="Tarangarn", questname="Tarangarn", size=1, level=23, difficulty=Difficulty.ELITE, moral="9,191", race="Auroch", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="54.2S, 53.0W"},{c="53.7S, 51.7W"}}}, enemyType=2},
			{id=5076, name="Drugodech", questname="Drugodech", size=1, level=22, difficulty=Difficulty.SIGNATURE, moral="1,740", race="Wolf", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="47.4S, 50.0W"},{c="46.6S, 50.2W"}}}, enemyType=2},
			{id=5071, name="Skrizug", questname="Skrizug", size=1, level=21, difficulty=Difficulty.ELITE, moral="1,680", race="Orc", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="41.6S, 33.3W"},{c="42.4S, 34.4W"}}}, enemyType=2},
			{id=5069, name="Turch", questname="Turch", size=1, level=20, difficulty=Difficulty.SIGNATURE, moral="1,600", race="Boar", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="46.3S, 28.1W"},{c="46.2S, 28.8W"}}}, enemyType=2}
		}}
	}},	
	{name="Swanfleet", region=1, map="69.jpg", areas={
		{name="Swanfleet", showme=false,wads={ 	
			{id=5063, name="Treasure of Swanfleet", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=5, poi={
				{id=1, c="64.2S, 26.5W"},
				{id=2, c="51.9S, 25.9W"},
				{id=3, c="56.9S, 28.3W"},
				{id=4, c="61.7S, 33.3W"},
				{id=5, c="54.9S, 35.2W"},
				{id=6, c="53.6S, 19.9O"},
				{id=7, c="57.7S, 25.2O"},
				{id=8, c="60.6S, 22.3O"},
				{id=9, c="46.0S, 21.8O"},
				{id=10, c="41.6S, 17.8O"}
			}, rewards={{Rewards.VERTUES, 100}, {Rewards.TITLE, "Treasure-seeker of Swanfleet"}}, tag="tag_vault.tga"},
			{id=5065, name="Dwellers of Old Swanfleet", target="SUB", enemyType=3, frame="treasure.tga", size=1, level=5, poi={
				{id=1, c="62.5S, 26.2W", l="Well-used fishing rod", t="Well-used fishing rod"},
				{id=2, c="53.1S, 20.8W", l="Old cornerstone", t="Old cornerstone"},
				{id=3, c="55.9S, 19.3W", l="Curious pendant", t="Curious pendant"},
				{id=4, c="59.1S, 21.0W", l="Engraved stone", t="Engraved stone"},
				{id=5, c="51.8S, 26.0W", l="Cache of old notes", t="Cache of old notes"},
				{id=6, c="49.0S, 23.7W", l="Collection of poetry", t="Collection of poetry"},
				{id=7, c="58.7S, 34.5W", l="Rusted Dagger", t="Rusted Dagger"}
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 1000}, {Rewards.TITLE, "Hidden Jewel"}}, tag="tag_vault.tga"},
			{id=5077, name="Drindolf", questname="Drindolf", size=1, level=19, difficulty=Difficulty.GRAND_ELITE, moral="7,171", race="Huorn", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="47.7S, 21.4W"},{c="48.2S, 22.2W"}}}, enemyType=2},
			{id=5078, name="Norl\195\186g", questname="Norlg", size=1, level=18, difficulty=Difficulty.ELITE, moral="3,060", race="Worm", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="50.4S, 25.5W"},{c="49.7S, 25.7W"}}}, enemyType=2},
			{id=5079, name="Stoneback", questname="Stoneback", size=1, level=16, difficulty=Difficulty.ELITE, moral="2,818", race="Turtle", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="52.2S, 26.6W"},{c="51.8S, 25.6W"}}}, enemyType=2},
			{id=5080, name="Thostmoth", questname="Thostmoth", size=1, level=15, difficulty=Difficulty.ELITE, moral="1,148", race="Bog-lurker", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="52.7S, 32.6W"},{c="53.4S, 33.7W"}}}, enemyType=2},
			{id=5081, name="Gristbite", questname="Gristbite", size=1, level=13, difficulty=Difficulty.ELITE, moral="960", race="Neekerbreeker", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="52.5S, 29.1W"}}}, enemyType=2},
			{id=5082, name="Gnaw", questname="Gnaw", size=1, level=12, difficulty=Difficulty.SIGNATURE, moral="900", race="Shrew", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="60.0S, 25.6W"},{c="61.1S, 25.7W"},{c="61.3S, 26.6W"}}}, enemyType=2}
		}}
	}},	
	{name="Bree-Lands", region=1, areas={
		{name="Bree-Lands", map="58.jpg",wads={ 
			{ id=2366, name="The History of the Dunedain", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=24, poi={{ id=1, c="33.4S, 48.8W", l="Dunedain Statue", t="Dnedainstatue"}, { id=2, c="30.2S, 49.1W", l="Ancient Inscription", t="Ancient Inscription"}, { id=3, c="27.1S, 46.6W", l="Ancient Cairn", t="Ancient Cairn"}, { id=4, c="30.7S, 52.6W", l="Ancient Crest", t="Ancient Crest"}, { id=5, c="31.2S, 44.9W", l="Ancient Altar", t="Ancient Altar" }, { id=6, c="29.5S, 45.8W", l="Ancient Obelisk", t="Ancient Obelisk"}}, rewards={{Rewards.TURBINE, 10}, {Rewards.REPUTATION, "Men of Bree", 500}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
		}},
		{name="Wildwood", map="48.jpg",wads={ 
			{ id=2362, name="Flowers of the Wildwood", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=45, poi={{ id=1, c="22.6S, 58.1W", l="Eyebright", t="Eyebright"}, { id=2, c="23.6S, 63.5W", l="Ragged Robin", t="Ragged Robin"}, { id=3, c="21.8S, 60.1W", l="Teasel", t="Teasel"}, { id=4, c="21.4S, 56.2W", l="Speedwell", t="Speedwell"}, { id=5, c="18.7S, 57.6W", l="Shepherd's Purse", t="ShepherdsPurse" }, { id=6, c="17.2S, 55.4W", l="Wood Spurge", t="Wood Spurge"}, { id=7, c="18.0S, 60.1W", l="Yellow-rattle",t="Yellow-rattle"}, { id=8, c="15.9S, 58.7W", l="Knotted Thistle",t="Knotted Thistle"}}, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Smeller of Flowers"}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
			{ id=2363, name="Hidden Threats of the Wildwood", target="SUB", enemyType=3, ico="poiEnnemy.tga", frame="deed.tga", size=1, level=45, poi={{ id=1, c="18.3S, 60.0W", l="Master of the Wildwood", t="MasteroftheWildwood"}, { id=2, c="24.6S, 60.6W", l="Lord of the Stone-den", t="LordoftheStoneden"}, { id=3, c="24.0S, 63.2W", l="Grand Old Wild-tusk", t="GrandOldWildtusk"}, { id=4, c="18.2S, 58.4W", l="Hull the Wolf-hearted", t="HulltheWolfhearted"}, { id=5, c="21.5S, 56.3W", l="Azdag", t="Azdg"}, { id=6, c="17.9S, 59.9W", l="Lagshal Bone-cracker", t="LagshalBonecracker"}, { id=7, c="17.5S, 59.3W", l="Thraumak",t="Thraumak"}, { id=8, m={x=60, y=192}, c="Delf : in the spider area", l="Broghosh",t="Broghosh"},{ id=9, c="16.8S, 58.5W", l="Dulglok",t="Dulglok"},{ id=10, c="23.2S, 62.3W", l="Druhuk",t="Drhuk"}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},			
		}},
		{name="The Old Forest", map="57.jpg",wads={ 
			{ id=2365, name="Flowers of the Old Forest", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=21, poi={{ id=1, c="32.0S, 60.9O", l="Rhosthon", t="RhosthonsFlower"}, { id=2, c="30.6S, 57.3O", l="Neldorla", t="NeldorlassFlower"}, { id=3, c="34.1S, 60.1O", l="Dorollin", t="DorollinsFlower"}, { id=4, c="32.6S, 59.3O", l="Cordofoneth", t="CordofonethsFlower"}, { id=5, c="33.3S, 57.5O", l="Lenhwest", t="LenhwestsFlower" }, { id=6, c="35.1S, 56.9O", l="Silloth", t="SillothsFlower"}, { id=7, c="32.1S, 58.4O", l="Braiglad",t="BraigladsFlower"}, { id=8, c="35.4S, 58.3O", l="Merillif",t="MerillifsFlower"}}, rewards={{Rewards.TURBINE, 10}, {Rewards.REPUTATION, "Men of Bree", 500}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
		}},
	}},	
};

MapsData = {
	--["1.jpg"] = {map="1.jpg", name="East Rohan", c={n=35.3, w=-76.0, s=63.5, e=-44.6}, region=3, lvl={min=75,max=85}},
	["2.jpg"] = {map="2.jpg", name="Wildermore", c={n=28.1, w=-74.5, s=44.9, e=-56.0}, region=3, lvl={min=85,max=85}, faction={"People of Wildermore", "Survivors of Wildermore"}, epic={{"Volume III", {"Book 10: Snows of Wildermore"}}}, craft=8, flags={
		{name="Farms of the Fallows",flags={{l="Edsig's Farm",c="43.3S, 59.3W"},{l="Garnoth's Farm",c="42.4S, 61.1W"},{l="Thrymm's Farm",c="40.3S, 58.5W"},{l="Cuthbald's Farm",c="41.5S, 57.7W"},{l="Garsig's Farm",c="40.6S, 55.9W"},{l="Garferth's Farm",c="42.3S, 58.5W"}}},
		{name="Isolation in the Whitshaws",flags={{l="Hut in the woods",c="36.9S, 67.4W"},{l="Hut in the north",c="36.1S, 64.9W"},{l="Hut on the plains",c="39.0S, 65.8W"}}},
		{name="The Path of Nurzum",flags={{l="Northern Ice-spires",c="37.6S, 63.4W"},{l="Southern Ice-spires",c="40.2S, 64.2W"},{l="Western Ice-spires",c="39.9S, 65.6W"},{l="Ice-spires at Dunfast",c="37.4S, 67.1W"},{l="Nurzum's Wrath",c="32.7S, 70.9W"}}},
		{name="The Wilds of Wildermore",flags={{l="The Elderwood",c="36.4S, 69.1W"},{l="Steaping",c="31.4S, 64.8W"},{l="Enting Hollow",c="32.1S, 69.7W"},{l="Stonecliff",c="30.2S, 70.9W"},{l="Leaflock's Mead",c="32.2S, 73.2W"}}},
		{name="These Hostile Lands",flags={{l="Fiskworth",c="33.8S, 62.4W"},{l="Fushaum-doram",c="39.2S, 56.8W"},{l="Kadar-golnauk",c="33.0S, 61.2W"},{l="the Hungry Paths",c="33.6S, 68.0W"},{l="Dru Vadokan",c="30.9S, 74.6W"}}}
	}},
	-- ["3.jpg"] = {map="3.jpg", name="West Rohan", c={n=42.5, w=-92.7, s=72.7, e=-54.6}, region=3, lvl={min=85,max=95}, faction={"The Eorlingas", "The Helmingas", "The Ents of Fangorn Forest"}, epic={{"Volume III", {"Book 11: The Golden Hall", "Book 12: War in the Westemnet", "Book 13: The Battle of the Hornburg", "Book 14: The Waters of Isengard"}}}, craft=9},
	["4.jpg"] = {map="4.jpg", name="Western Gondor", c={n=54.2, w=-79.2, s=81.9, e=-50.7}, region=3, lvl={min=95,max=100}, faction={"Dol Amroth", "Dol Amroth - City Watch", "Dol Amroth - Armoury", "Dol Amroth - Bank", "Dol Amroth - Docks", "Dol Amroth - Hall", "Dol Amroth - Library", "Dol Amroth - Mason", "Dol Amroth - Swan-knights", "Dol Amroth - Warehouse"}, epic={{"Volume IV", {"Book 1: The Road to Gondor"}}},craft=9},
	["5.jpg"] = {map="5.jpg", name="The Dead Marshes", c={n=25.4, w=-18.7, s=31.9, e=-11.0}, region=3, lvl={min=100,max=100},flags={
		{name="",flags={{l="Artamir's Camp",c="30.2S, 11.4W"},{l="Haudh Air",c="29.0S, 16.5W"},{l="Marshland Outpost",c="30.3S, 13.7W"},{l="The Lake of Dead Faces",c="28.3S, 14.0W"},{l="The Nerbyg Nests",c="30.4S, 18.2W"}}}
	}},
	["6.jpg"] = {map="6.jpg", name="Central Gondor", c={n=69.0, w=-54.4, s=89.6, e=-31.2}, region=3, lvl={min=100,max=100}, faction={"Men of Ringlo Vale","Men of Dor-en-Ernil","Men of Lebennin","Pelargir"}, epic={{"Volume IV", {"Book 2: The Dawnless Day"}}},craft=9},
	["7.jpg"] = {map="7.jpg", name="Eastern Gondor", c={n=60.6, w=-32.7, s=84.7, e=-4.1}, region=3, lvl={min=100,max=100}, faction={"Rangers of Ithilien","Pelargir"}, epic={{"Volume IV", {"Book 3: Voices of the Past"}}},craft=10},
	["8.jpg"] = {map="8.jpg", name="Misty Mountains", c={n=15.6, w=-6.5, s=32.7, e=11.1}, region=1, lvl={min=40,max=45}, epic={{"Volume I", {"Book V - The Last Refuge"}}},craft=5},
	["9.jpg"] = {map="9.jpg", name="Angmar", c={n=-13.5, w=-41.2, s=5.8, e=-15.7}, region=1, lvl={min=40,max=50}, faction={"Council of the North","The Eldgang"}, epic={{"Volume I", {"Book VI - The Fires in the North", "Book VII - The Hidden Hope", "Book VIII - The Scourge of the North", "Book IX - The Shores of Evendim", "Book XII - The Ashen Wastes", "Book XIV - The Ring-forges of Eregion", "Book XV - Daughter of Strife"}}, {"Volume III", {"Book I - Oath of the Rangers"}}},craft={4, 5},flags={
		{name="Bastions of Hope",flags={{l="Lehma-koti",c="3.0S, 39.1W"},{l="Aughaire",c="0.0N, 40.0W"},{l="Tyrn Lhuig",c="1.9S, 33.2W"},{l="Gabilshathur",c="3.6S, 26.4W"},{l="Gath Forthnir",c="10.8N, 24.0W"}}},
		{name="The Circle of Despair",flags={{l="Minas Agar",c="7.2N, 23.2W"},{l="Minas Maur",c="6.6N, 22.9W"},{l="Minas Angos",c="6.4N, 22.4W"},{l="Minas Nir",c="7.8N, 21.8W"},{l="Minas Deloth",c="6.6N, 21.8W"},{l="Minas Gularan",c="7.1N, 21.6W"},{l="Minas Dhem",c="8.0N, 22.4W"}}},
		{name="The Road to War",flags={{l="Skathmur",c="5.00S, 36.60W"},{l="Bail Rova",c="0.08N, 34.25W"},{l="Bail Boglakh",c="3.20N, 30.34W"},{l="Mor Maudhul",c="3.38N, 27.56W"},{l="Bail Dilas",c="10.14N, 28.10W"},{l="Gate of Shadows",c="12.07N, 29.53W"}}}
	}},
	["10.jpg"] = {map="10.jpg", name="Forochel", c={n=-23.3, w=-89.0, s=3.5, e=-57.8}, region=1, lvl={min=44,max=50}, faction={"Lossoth of Forochel"}, epic={{"Volume I", {"Book XIII - Doom of the Last-king", "Book XIV - The Ring-forges of Eregion"}}, {"Volume III", {"Book I - Oath of the Rangers"}}},craft={5},flags={
		{name="The Battle for Forochel",flags={{l="Hylje-leiri",c="18.8N, 81.3W"},{l="Karhu-leiri",c="12.9N, 66.3W"},{l="Pynti-leiri",c="8.8N, 70.5W"},{l="Norsu-leiri",c="8.0N, 78.9W"}}},
		{name="Ancient Stones of Forochel",flags={{l="Kibilzahar",c="20.0N, 85.0W"},{l="The Ironspan",c="17.0N, 59.3W"},{l="Zigilgund",c="9.5N, 81.1W"},{l="The Lonesome Stones",c="13.6N, 74.4W"},{l="Icereave Mines",c="8.9N, 81.9W"}}}
	}},	
	["11.jpg"] = {map="11.jpg", name="Southern Mirkwood", c={n=5.9, w=-62.8, s=21.2, e=-41.3}, region=2, lvl={min=61,max=65}, faction={"Malledhrim"}, epic={{"Volume II", {"Book IX - Fortress of the Nazgul"}},{"The Black Book of Mordor", {"Chapter 5 - Legacy of the Necromancer"}}},craft={6},flags={
		{name="The Wilds of Mirkwood",flags={{l="Pack-howler's Hill",c="15.4S, 56.0W"},{l="Gorogrod",c="8.8S, 51.2W"},{l="Sad Meryrn",c="18.8S, 57.6W"},{l="Pool of Creeping Death",c="16.8S, 57.8W"},{l="the Tree of Suffering",c="12.6S, 47.4W"},{l="the Crawling Water",c="11.1S, 51.4W"},{l="the Wind Stones",c="16.0S, 59.2W"}}},
		{name="Uncovering the Ruins of Mirkwood",flags={{l="Dannenglor",c="11.9S, 54.8W"},{l="Mithechad",c="17.6S, 48.2W"},{l="Tirnhirion",c="17.3S, 61.7W"},{l="Sad Morangol",c="19.1S, 48.7W"},{l="the Wild Ruin",c="15.2S, 51.2W"}}},
		{name="Evil Strongholds of Mirkwood",flags={{l="Garmadh-maudhul",c="16.6S, 46.7W"},{l="Sad Doldur",c="18.6S, 43.9W"},{l="Anghum-maudhul",c="19.8S, 45.8W"},{l="Burzkala",c="11.0S, 46.4W"},{l="Amon Angened",c="16.0S, 60.0W"},{l="Durburz-stazg",c="14.3S, 61.6W"}}}
	}},
	["12.jpg"] = {map="12.jpg", name="Evendim", c={n=2.8, w=-81.7, s=23.8, e=-60.1}, region=1, lvl={min=30,max=40}, faction={"The Wardens of Annuminas"}, epic={{"Volume I", {"Book IX - The Shores of Evendim", "Book X - The City of the Kings", "Book XI - Prisoner of the Free Peoples", "Book XII - The Ashen Wastes", "Book XIV - The Ring-forges of Eregion"}}, {"Volume III", {"Book I - Oath of the Rangers"}}},craft={3,4},flags={
		{name="Ruins of Evendim",flags={{l="Tham Nambarth",c="12.1S, 65.6W"},{l="Tham Varan",c="12.1S, 63.9W"},{l="Ost Heryn",c="11.2S, 61.6W"},{l="Tham Andalath",c="9.5S, 63.1W"},{l="Tham Ornen",c="8.7S, 66.7W"},{l="Barad Rath",c="7.3S, 66.6W"},{l="Rantost",c="7.2S, 69.6W"},{l="Tollobel",c="11.4S, 71.9W"}}},
		{name="Tombs of Evendim",flags={{l="Haudh Earendur",c="15.9S, 66.4W"},{l="Haudh Elendur",c="16.3S, 66.0W"},{l="Haudh Valandur",c="16.4S, 66.5W"},{l="Haudh Elendil",c="16.7S, 67.0W"},{l="Haudh Tarondor",c="16.9S, 66.1W"},{l="Haudh Eldacar",c="17.2S, 66.8W"},{l="Haudh Tarcil",c="17.1S, 66.0W"},{l="Haudh Arantar",c="17.2S, 66.3W"}}},
		{name="Wilds of Evendim",flags={{l="Nan Orngon",c="7.7S, 61.8W"},{l="Tum Fuin",c="4.4S, 65.2W"},{l="The Even-rills",c="3.7S, 69.5W"},{l="The Eavespires",c="6.1S, 72.0W"},{l="The Eave-mere",c="5.8S, 72.8W"},{l="Swiftbrook",c="7.0S, 74.5W"},{l="The Twisted Grove",c="11.5S, 75.1W"},{l="Rushingdale",c="13.7S, 75.8W"}}}
	}},
	["60.jpg"] = {map="60.jpg", name="Annuminas", c={n=15.8, w=-71.8, s=20.3, e=-67.3}, p="Evendim", region=1, lvl={min=38,max=40},flags={
		{name="Markers of the Sunken City",flags={{l="Plaque of Echad Garthadir",c="18.9S, 70.8W"},{l="Plaque of Clorhir",c="19.0S, 68.7W"},{l="Plaque of Ariant",c="17.3S, 69.4W"}}},
		{name="The City of the Kings",flags={{l="Gaerannon",c="18.4S, 71.4W"},{l="Echad Garthadir",c="19.0S, 70.9W"},{l="Menelband",c="19.6S, 70.1W"},{l="Clorhir",c="19.0S, 68.7W"},{l="Tirband",c="18.5S, 68.7W"},{l="Ariant",c="17.4S, 69.4W"},{l="Minathranc",c="17.6S, 68.5W"}}}
	}},
	["13.jpg"] = {map="13.jpg", name="North Downs", c={n=2.4, w=-59.7, s=22.0, e=-32.9}, region=1, lvl={min=20,max=35}, faction={"Rangers of Esteldin"}, epic={{"Volume I", {"Book III - The Council of the North","Book IX - The Shores of Evendim","Book XI - Prisoner of the Free Peoples","Book XV - Daughter of Strife"}},{"Volume III", {"Book I - Oath of the Rangers"}}},craft={2,3},flags={
		{name="Strongholds Exploration",flags={{l="Nan Wathren Western Pass",c="15.0S, 50.1W"},{l="Nan Wathren Eastern Pass",c="16.2S, 45.9W"},{l="Higropor",c="18.6S, 46.3W"},{l="Hisuk",c="16.0S, 36.8W"},{l="Tumat",c="16.6S, 36.1W"}}},
		{name="The Eastern Ruins",flags={{l="Ost Lagoros",c="9.6S, 47.6W"},{l="Ost Galumar",c="7.2S, 47.0W"},{l="Dol Nendr",c="13.5S, 42.6W"},{l="Merenost",c="15.2S, 43.2W"},{l="Ost Crithlanc",c="7.6S, 35.0W"}}},
		{name="The Villages of the Earth-kin",flags={{l="Rusfold",c="9.3S, 39.9W"},{l="Fashat Laug",c="8.8S, 33.6W"},{l="Kar Lak",c="11.0S, 33.5W"},{l="Lehma-koti",c="3.0S, 39.1W"}}},
		{name="The Western Ruins",flags={{l="Find Amon Raith",c="12.6S, 52.8W"},{l="Minas Vrun",c="11.4S, 51.2W"},{l=" Ost Nuaran",c="8.0S, 53.2W"},{l="Falconer's Tower",c="8.7S, 53.4W"},{l="Norbury Gates",c="8.8S, 55.2W"},{l="Glrost",c="9.4S, 59.3W"},{l="Tham Lorn",c="11.2S, 59.2W"}}},
		{name="Discovery: Stoneheight",flags={{l="Entrance to Stoneheight",c="9.5S, 50.1W"}}}
	}},
	["14.jpg"] = {map="14.jpg", name="Old Anorien", c={n=46.1, w=-25.6, s=73.2, e=3.9}, region=3, lvl={min=100,max=100}, faction={"Defenders of Minas Tirith"}, epic={{"Volume IV", {"Book 4: Siege of the White City","Book 6: The Battle of the Pelennor Fields"}}},craft={10},flags={
		{name="Old Anorien Farms",flags={{l="Parth Lisc",c="49.2S, 18.3W"},{l="Parth Duin",c="52.8S, 13.8W"},{l="Parth Gladio",c="58.4S, 12.8W"},{l="Parth Forant",c="56.0S, 14.7W"},{l="Pel Forod",c="61.9S, 14.9W"},{l="Pel Enaid",c="66.3S, 14.0W"},{l="Pel Duven",c="69.4S, 18.3W"},{l="Pel Chardun",c="69.3S, 13.8W"},{l="Pel Tundalaf",c="71.0S, 15.6W"}}}
	}},	
	["15.jpg"] = {map="15.jpg", name="Far Anorien", c={n=33.9, w=-49.4, s=57.3, e=-17.7}, region=3, lvl={min=100,max=100}, faction={"Riders of Rohan"}, epic={{"Volume IV", {"Book 5: The Ride of the Rohirrim"}}},craft={10},flags={
		{name="The Warning Beacons",flags={{l="Calenhad",c="44.6S, 41.8W"},{l="Erelas",c="46.4S, 33.5W"},{l="Halifirien",c="46.2S, 45.5W"},{l="Min-Rimmon",c="46.4S, 37.9W"},{l="Amon Din",c="48.4S, 24.1W"},{l="Eilenach",c="46.8S, 27.1W"},{l="Nardol",c="47.3S, 30.5W"}}},
		{name="The Lost Trail of the Entwash",flags={{l="Lost Trail",c="34.6S, 37.5W"},{l="Lost Trail",c="35.0S, 36.8W"},{l="Lost Trail",c="36.3S, 36.6W"},{l="Lost Trail",c="37.6S, 36.7W"},{l="Lost Trail",c="38.7S, 36.8W"},{l="Lost Trail",c="39.6S, 36.6W"},{l="Lost Trail",c="41.0S, 36.8W"},{l="Lost Trail",c="41.9S, 37.0W"}}}
	}},	
	["16.jpg"] = {map="16.jpg", name="Minas Tirith", c={n=62.5, w=-23.6, s=68.8, e=-16.3}, region=3, lvl={min=100,max=100}, faction={"Defenders of Minas Tirith"}},
	["17.jpg"] = {map="17.jpg", name="March of the King", c={n=41.1, w=-30.0, s=71.3, e=2.4}, region=3, lvl={min=100,max=105}, faction={"Host of the West"}, epic={{"Volume IV", {"Book 7: The March of the King"}}},craft={10},flags={
		{name="A Look into Osgiliath",flags={{l="Dome of Stars",c="61.5S, 9W"},{l="Houses of Healing",c="62S, 7.4W"},{l="Palace of Eldacar",c="61.2S, 11.2W"},{l="Osgiliath Culverts",c="62.7S, 8.8W"}}},
		{name="Ruins of North Ithilien",flags={{l="Bar Aroth",c="59.6S, 5.6W"},{l="Thargelon",c="56.5S, 5.0W"},{l="Aelin Veren",c="52.6S, 6.4W"},{l="Caladuil",c="48.8S, 12.5W"},{l="Bar Tarnaher",c="43.4S, 12.9W"}}}
	}},
	["19.jpg"] = {map="19.jpg", name="The Wastes", c={n=27.1, w=-15.0, s=41.2, e=1.7}, region=4, lvl={min=105,max=105}, faction={"Host of the West"}, epic={{"Volume IV", {"Book 8: The Black Gate","Book 9: The Ring of Power"}}},craft={10},flags={
		{name="Gathering of Evil",flags={{l="Carchost",c="36.1S, 1.4W"},{l="Dol Acharn",c="31.0S, 1.8W"},{l="Dum Boha",c="36.9S, 6.4W"},{l="Fushaum Gund",c="35.6S, 0.9W"},{l="Lang Rhuven",c="33.6S, 0.8E"},{l="Narchost (inside Carchost)",c="36.1S, 1.7W"},{l="Ondoher's Folly",c="30.74S, 7.4W"},{l="Skoironk",c="36.0S, 4.8W"}}},
		{name="Ruins of Gondor",flags={{l="Tham Durlan",c="33.5S, 8.0W"},{l="Nuiharn",c="33.8S, 10.4W"},{l="Guard Tower Ruins",c="34.7S, 7.3W"},{l="Store House Ruins",c="35.0S, 12.1W"},{l="Merchant shop Ruins",c="37.1S, 10.6W"},{l="Farm House Ruins",c="38.3S, 11.5W"},{l="Inn Ruins",c="39.0S, 10.4W"},{l="Nobel's House Ruins",c="39.2S, 12.1W"},{l="Stable Ruins",c="37.5S, 11.8W"}}}
	}},
	["21.jpg"] = {map="21.jpg", name="Ered Mithrin", chat="Dwarf-holds", c={n=-45.4, w=-56.6, s=-28.5, e=-32.6}, region=2, lvl={min=117,max=120}, faction={"Grey Mountains Expedition"}, epic={{"The Black Book of Mordor", {"Chapter 8 - A Land of Dragons","Chapter 9 - Challenging the Zhelruka"}}},craft={12}, flags={
		{name="Ruins of Ered Mithrin", flags={{l="Bizar-atrad",c="35.2N, 40.0O"},{l="Rushgate",c="33.7N, 56.0O"},{l="Thikil-gundu",c="38.2N, 54.3O"},{l="Glimmerdeep",c="39.5N, 47.5O"},{l="Stormwall",c="38.2N, 43.8O"},{l="Oinsbridge",c="30.6N, 44.7O"},{l="Skarhald",c="34.7N, 45.4O"},{l="Stanbalk, the Stone Wall",c="35.7N, 52.9O"},{l="The Grey Wrack",c="36.4N, 53.2O"},{l="Ker Brein",c="30.5N, 50.4O"},{l="Furuk-mekhem",c="31.5N, 35.2O"}}}
	}},
	["23.jpg"] = {map="23.jpg", name="Iron Hills", chat="Dwarf-holds", c={n=-32.7, w=-20.2, s=-18.1, e=-2.4}, region=2, lvl={min=115,max=117}, faction={"Dwarves of Erebor", "Grey Mountains Expedition"}, epic={{"The Black Book of Mordor",{"Chapter 7 - The Tales of Khil"}}},craft={12}},
	["24.jpg"] = {map="24.jpg", name="Vals of Anduin", c={n=-16.7, w=-75.6, s=11.1, e=-44.9}, region=2, lvl={min=120,max=120}, faction={"Wilderfolk"}, epic={{"The Black Book of Mordor",{"Chapter 10 - Aiding the Wilderfolk"}}},craft={12},flags={
		{name="Enemies of the Vales",flags={{l="Brafulug",c="3.4S, 61.0W"},{l="Ylgraf",c="16.8N, 53.5W"},{l="the Goblin-gate",c="12.1N, 63.3W"},{l="Waldfast",c="6.3N, 60.4W"},{l="Fil Sulmog",c="8.2N, 54.2W"},{l="Triubad",c="4.0N, 54.6W"},{l="Cos Braen",c="2.9S, 53.5W"},{l="Sharkey's Slough",c="0.8N, 59.2W"},{l="Lulstrok",c="2.3N, 61.7W"},{l="The Warrens of Tun Melen",c="1.7S, 60.5W"},{l="Shathur-munzu",c="5.6S, 63.6W"}}},
		{name="Protectors of the Vales",flags={{l="Beorninghus",c="13.5N, 53.3W"},{l="Vegbar",c="7.9N, 58.5W"},{l="Ainhard's Homestead",c="4.7N, 59.5W"},{l="Hodver's Homestead",c="6.7N, 58.1W"},{l="Gudule's Homestead",c="5.0N, 58.9W"},{l="Hultvis",c="5.4N, 54.6W"},{l="Blomgard",c="1.6N, 55.6W"},{l="Beorning Watchpost",c="3.5S, 59.9W"},{l="Arhaim",c="5.9S, 61.2W"},{l="Glandir",c="7.9S, 61.7W"}}},
		{name="Sites du Val",flags={{l="The Eyrie",c="14.6N, 61.0W"},{l="High Pass",c="10.2N, 65.6W"},{l="Hadhodiant",c="8.6N, 56.6W"},{l="Avabarg",c="5N, 57W"},{l="Rhosgobel",c="0.7N, 52.7W"},{l="Gladden Falls",c="0.8N, 63.5W"}}}
	}},
	["26.jpg"] = {map="26.jpg", name="Ud\195\187n", c={n=37.4, w=-2.3, s=48.1, e=9.4}, region=4, lvl={min=106,max=108},p="Mordor", faction={"Conquest of Gorgoroth"}, epic={{"The Black Book of Mordor",{"Chapter 1 - Where the Shadows Lie", "Chapter 5 - Legacy of the Necromancer"}}},craft={11},flags={
		{name="The Way Into Mordor",flags={{l="Iron Road",c="40.7S, 0.8W"},{l="West Road to Anglach",c="41.8S, 1.2E"},{l="Parade Grounds",c="42.7S, 2.3E"},{l="Road to Mornaur",c="44.7S, 1.6E"},{l="West Road to Durthang",c="44.6S, 2.5E"},{l="Durthang Tower-top",c="47.0S, 3.2E"},{l="Durthang Lookout",c="45.9S, 1.4E"},{l="Durthang Eastern Stairs",c="45.8S, 3.0E"},{l="path to Rhud Vorn",c="44.6S, 7.7E"},{l="Rhud Vorn watch point",c="41.2S, 8.6E"},{l="Rogkalur overlook",c="41.0S, 7.6E"},{l="Anglach vantage point",c="40.4S, 5.6E"},{l="Overseer's perch",c="41.1S, 3.4E"},{l="Gates of the Isenmouthe",c="46.8S, 8.0E"},{l="Foundry Deck",c="42.4S, 4.8E"}}}
	}},
	["27.jpg"] = {map="27.jpg", name="Lhingris", c={n=46.2, w=-0.1, s=65.4, e=20.9}, region=4, lvl={min=110,max=111},p="Mordor", faction={"Conquest of Gorgoroth"}, epic={{"The Black Book of Mordor",{"Chapter 3 - The Gurzyul"}}},craft={11},flags={
		{name="Strongholds of the Ephel Duath",flags={{l="Kala-murg",c="53.8S, 5.0E"},{l="Lugvarg",c="53.5S, 7.2E"},{l="Nelegroth",c="58.1S, 4.6E"},{l="Iant Angos",c="61.8S, 11.2E"},{l="Cirith Ungol",c="60.2S, 8.5E"},{l="Fennas Gost",c="64.3S, 7.7E"}}},
		{name="Spider-haunts and Web-rifts",flags={{l="The Morgai",c="55.0S, 7.8E"},{l="Rath Cail",c="49.7S, 5.9E"},{l="Ceber Duath",c="56.3S, 5.8E"},{l="Dath Nethryn",c="64.8S, 12.0E"},{l="Kam Lagurz",c="63.7S, 9.3E"},{l="Amon Ruth",c="64.8S, 8.9E"},{l="Torech Ungol",c="61.7S, 6.0E"}}}
	}},
	["28.jpg"] = {map="28.jpg", name="Dor Amarth", c={n=38.0, w=6.5, s=53.3, e=27.9}, region=4, lvl={min=108,max=109},p="Mordor", faction={"Conquest of Gorgoroth"}, epic={{"The Black Book of Mordor",{"Chapter 2 - The Light of Earendil"}}},craft={11},flags={
		{name="Places of Darkness",flags={{l="Ered Lithui",c="43.8S, 20.2E"},{l="Barad-dur",c="47.2S, 26.1E"},{l="Mordath",c="44.7S, 25.7E"},{l="Fushaum Tum",c="51.0S, 11.4E"}}},
		{name="The Last Reserves",flags={{l="Sarronk",c="50.7S, 9.9E"},{l="Blozronk",c="47.8S, 13.7E"},{l="Nauronk",c="45.8S, 18.6E"}}}
	}},
	["29.jpg"] = {map="29.jpg", name="Talath \195\154rui", c={n=48.8, w=10.0, s=65.2, e=28.2}, region=4, lvl={min=112,max=113},p="Mordor", faction={"Conquest of Gorgoroth", "Enmity of Fushaum Bal north", "Enmity of Fushaum Bal south"}, epic={{"The Black Book of Mordor",{"Chapter 4 - Union of Evil", "Chapter 5 - Legacy of the Necromancer", "Chapter 6 - Wood, Lake, Mountain, and Stone"}}},craft={11},flags={
		{name="Outposts Along the Burning Plain",flags={{l="Magh Nul",c="58.8S, 25.3E"},{l="Magh Groth",c="61.1S, 25.0E"},{l="Magh Vadok",c="61.8S, 21.2E"},{l="Magh Hatur",c="58.9S, 16.4E"},{l="Magh Urro",c="58.4S, 13.3E"}}},
		{name="Nargroth Explorer",flags={{l="Ledge of Terror",c="16.4N, 14.5E"},{l="Court of Horror",c="17.1N, 13.6E"},{l="Strand of Fire",c="17.1N, 14.4E"},{l="The Ash Watch",c="16.3N, 13.6E"},{l="Ledge of Dread",c="17.9N, 14.2E"},{l="Ledge of Fear",c="17.6N, 13.9E"}}},
		{name="The Tainted Reserves",flags={{l="Ashronk",c="58.0S, 26.4E"},{l="Krulronk",c="61.6S, 23.5E"},{l="Gakhronk",c="57.3S, 12.5E"},{l="Zagronk",c="54.3S, 10.2E"}}}
	}},
	["30.jpg"] = {map="30.jpg", name="Agarnaith", c={n=42.8, w=21.4, s=57.3, e=37.3}, region=4, lvl={min=114,max=115},p="Mordor", faction={"Conquest of Gorgoroth"}, epic={{"The Black Book of Mordor",{"Chapter 4 - Union of Evil", "Chapter 5 - Legacy of the Necromancer", "Chapter 6 - Wood, Lake, Mountain, and Stone"}}},craft={11},flags={
		{name="Agarnaith Pathfinder",flags={{l="Lair of the Gloom-lord",c="48.9S, 31.3E"},{l="Bhol Rudh",c="54.4S, 32.0E"},{l="Viznak's hideout",c="51.9S, 28.2E"},{l="Faltor Gam",c="50.4S, 29.6E"},{l="Kala-gijak",c="52.9S, 29.4E"},{l="Agarnaith Ranger camp",c="56.5S, 27.0E"},{l="Seregost",c="48.5S, 33.8E"},{l="Mokal Rukh",c="46.8S, 35.6E"}}}
	}},
	["32.jpg"] = {map="32.jpg", name="Eryn Lasgalen and the Dale-lands", chat="Northern Mirkwood", c={n=-35.7, w=-53.3, s=-7.2, e=-19.3}, region=2, lvl={min=115,max=115}, faction={"Dwarves of Erebor", "Elves of Felegoth", "Men of Dale"}, epic={{"The Black Book of Mordor",{"Chapter 6 - Wood, Lake, Mountain, and Stone", "Chapter 7 - The Tales of Khil"}}, {"The Lay of Rust and Rime",{"All quests line"}}},craft={11}, flags={
		{name="Explorer of the Dale-lands", flags={{l="Bones of Smaug",c="14.3N, 28.7O"},{l="Dale",c="24.8N, 25.6O"},{l="Erebor",c="29.2N, 25.6O"},{l="the Secret Door to Erebor",c="31.8N, 27.8O"},{l="Esgaroth-of-old",c="14.3N, 28.6O"},{l="Lake-town",c="17.1N, 27.6O"},{l="Ravenhill",c="26.5N, 29.0O"}}},
		{name="Explorer of Eryn Lasgalen", flags={{l="Caras Tilion",c="14.1N, 37.2O"},{l="Felegoth",c="21.0N, 36.8O"},{l="Tham Aeldes",c="20.7N, 35.3O"},{l="the Forest Gate",c="15.7N, 50.9O"},{l="Loeglond",c="14.3N, 31.3O"},{l="Gwigar",c="19.0N, 38.5O"},{l="Glad Thaw",c="13.5N, 44.1O"},{l="Imnagath",c="18.2N, 36.0O"},{l="Tholkat",c="21.6N, 41.6O"},{l="Torech Emel",c="19.8N, 45.7O"}}},
		{name="Ruins of the North", flags={{l="Tham Aeldir",c="15.5N, 34.8O"},{l="Garthness",c="20.0N, 29.8O"},{l="Bridgethorp",c="21.7N, 26.2O"},{l="Stranding",c="17.0N, 23.3O"},{l="Bendburn",c="23.0N, 27.9O"},{l="Westoft",c="26.2N, 26.3O"},{l="Grytgate",c="26.2N, 25.7O"},{l="Eldby",c="25.5N, 22.4O"},{l="Tay Yoldash",c="21.6N, 24.8O"},{l="Urushoba",c="18.4N, 22.6O"}}}
	}},
	["37.jpg"] = {map="37.jpg", name="Mordor Besieged", c={n=89.6, w=-132.2, s=103.2, e=-113.6}, region=4, lvl={min=120,max=122},p="Imlad Morgul", faction={"The Great Alliance"}, epic={{"The Black Book of Mordor",{"Chapter 11 - A Window on the Past", "Chapter 12 - The Siege of Barad-dur"}}},craft={13},flags={
		{name="Exploring Mordor Besieged",flags={{l="Ram Raedas",c="96.5S, 131.7W"},{l="Dingarth",c="97.5S, 131.4W"},{l="Echad-in-Edhil",c="96.2S, 127.7W"},{l="Adambel",c="98.8S, 126.5W"},{l="Amon Fuin",c="93.5S, 123.8W"},{l="Dol Naeg",c="97.1S, 118.7W"},{l="Halroth",c="92.6S, 116.7W"},{l="Barad-dur",c="96.8S, 114.2W"},{l="Baur Kasak",c="100.9S, 131.0W"},{l="Mokh Shapat",c="101.9S, 129.5W"},{l="Mokh Darga",c="95.6S, 124.0W"},{l="Barthost",c="95.1S, 119.9W"},{l="Urshulagar",c="94.2S, 118.9W"},{l="Matum Graz",c="95.6S, 116.0W"},{l="Angathrai",c="95.4S, 114.2W"}}}
	}},
	["38.jpg"] = {map="38.jpg", name="Cirith Ungol [inside]", c={n=-35.6, w=10.2, s=-30.0, e=16.4}, region=4, lvl={min=125,max=125},p="Imlad Morgul"},
	["39.jpg"] = {map="39.jpg", name="Minas Morgul", c={n=65.5, w=-0.3, s=69.1, e=3.6}, region=4, lvl={min=126,max=130},p="Imlad Morgul", faction={"The White Company"},craft={13},flags={
		{name="Exploration de Minas Morgul",flags={{l="Barad Angarth, the Gate-wardens' Keep",c="65.5S, 0.7E"},{l="Barad Orhant, the Tower of the Treegarth",c="66.1S, 0.5E"},{l="Zhar Dushgoi",c="65.7S, 1.4E"},{l="Burzangh, the Shrouded Forge",c="66.2S, 0.9E"},{l="Zhar Skator",c="67.2S, 0.2E"},{l="Barad Elenath, the Star-gazers' Spire",c="66.7S, 0.6E"},{l="Roz Dagalur, the Fiend-house",c="66.3S, 2.3E"},{l="The Song-house of Lindalir",c="67.2S, 3.1E"},{l="Dr Grazadh, the Hall of Rot",c="68.5S, 0.6E"},{l="Ghashan-kutot, the Hall of Black Lore",c="68.0S, 0.7E"},{l="The Garth of Angth",c="66.8S, 1.5E"},{l="Barad Arthir, the Lofty Watch-fort",c="67.1S, 1.1E"},{l="The Gloomwaters",c="67.2S, 2.4E"},{l="Br Maenath",c="68.1S, 1.1E"},{l="Gath Daeroval",c="67.8S, 2.5E"},{l="The Wracking-hall",c="67.6S, 2.2E"},{l="Uialrond, the Dome of Evening",c="67.4S, 1.6E"},{l="Barad Curon, the Tower of the Crescent Moon",c="67.8S, 1.8E"}}}
	}},
	["40.jpg"] = {map="40.jpg", name="Cirith Ungol", c={n=57.5, w=-2.0, s=67.2, e=8.3}, region=4, lvl={min=125,max=125},p="Imlad Morgul", faction={"The White Company"}, craft={13},flags={
		{name="Scouting Cirith Ungol",flags={{l="The Straight Stair",c="63.2S, 0.7W"},{l="The Winding Stair",c="62.4S, 1.7E"},{l="Echad Taerdim",c="61.9S, 0.4W"},{l="Cadar Skus",c="59.4S, 1.3W"},{l="Torech Ungol",c="61.4S, 4.5E"},{l="The Remmorchant",c="34.6N, 14.1E"},{l="Taurlingol",c="60.5S, 2.8E"},{l="Kaslokroz",c="61.8S, 2.1E"}}}
	}},
	["41.jpg"] = {map="41.jpg", name="Rath Duath", c={n=60.4, w=-2.5, s=70.4, e=8.3}, region=4, lvl={min=123,max=124},p="Imlad Morgul", faction={"The White Company", "Reclamation of Minas Ithil"}, epic={{"The Black Book of Mordor",{"Chapter 13 - Imlad Morgul"}}}, craft={13}},
	["42.jpg"] = {map="42.jpg", name="Thuringwath",c={n=67.6, w=3.7, s=76.8, e=13.5}, region=4, lvl={min=129,max=129},p="Imlad Morgul", faction={"The White Company", "Reclamation of Minas Ithil"}, craft={13}, flags={
		{name="Scouting Thuringwath",flags={{l="Falch Gurth",c="67.7S, 6.2E"},{l="Torgris, the Hidden Cleft",c="68.1S, 6.5E"},{l="Aufaltor, the Fane of the Eye",c="69.9S, 9.9E"},{l="Ufurok, the Dreadfast",c="71.6S, 7.7E"},{l="Laugdursh, the Dire Span",c="72.4S, 7.7E"},{l="Bar Nirnaeth",c="73.4S, 7.7E"}}}
	}},
	["43.jpg"] = {map="43.jpg", name="Wells of Langflood", c={n=-32.7, w=-66.8, s=-17.1, e=-49.9}, region=2, lvl={min=130,max=130}, faction={"Protectors of Wilderland"}, epic={{"The Legacy Of Durin And The Trials Of The Dwarves",{"Chapter 2 - Inspecting the Wells", "Chapter 3 - Closing in on Gundabad"}}},craft={13}, flags={
		{name="Settlements in the Wells of Langflood",flags={{l="Limlok",c="20.7N, 55.8W"},{l="Lyndelby",c="26.9N, 66.5W"},{l="Thokvist",c="26.0N, 58.4W"},{l="Hlithseld",c="30.6N, 59.3W"},{l="Shulgmokh",c="21.3N, 52.3W"},{l="Ujak-fulug",c="19.2N, 52.8W"},{l="Grazadh-gropor ",c="25.6N, 55.2W"}}},
		{name="Ruins in the Wells of Langflood",flags={{l="Sundergrot",c="21.6N, 63.2W"},{l="White Mare",c="22.3N, 56.3W"},{l="Skerabrygg",c="17.9N, 58.5W"},{l="Hengi's Leap",c="23.3N, 59.8W"},{l="Framsburg",c="30.0N, 60.8W"},{l="Lumrog",c="28.6N, 59.4W"},{l="Stramvarth",c="19.3N, 59.2W"},{l="Egvarth",c="20.7N, 60.7W"},{l="Dunabrygg",c="25.1N, 58.5W"}}},
		{name="Natural Formations in the Wells of Langflood",flags={{l="Tithroz",c="17.6N, 54.2W"},{l="Reikfoss of Greylin",c="32.1N, 60.1W"},{l="Twainmantle",c="31.4N, 62.7W"},{l="Veithhol",c="30.5N, 58.3W"},{l="Scraper's Clough",c="19.9N, 62.4W"},{l="Cabed Rhimdath",c="25.9N, 62.5W"}}}
	}},
	["44.jpg"] = {map="44.jpg", name="Elderslade - The gates of Gundabad", c={n=-45.3, w=-71.3, s=-31.9, e=-56.7}, region=2, lvl={min=129,max=130}, faction={"March on Gundabad", "The Gabil'akka"}, epic={{"The Legacy Of Durin And The Trials Of The Dwarves",{"Chapter 3 - Closing in on Gundabad"}}},craft={13},flags={
		{name="Enemy Encampments of Elderslade",flags={{l="Howlers' Notch",c="35.9N, 62.5W"},{l="Malkorlash",c="40.8N, 62.5W"},{l="Hanksar-mokh",c="37.5N, 68.4W"},{l="Bagud-mekhem",c="39.7N, 66.4W"},{l="Dun Traikh",c="36.2N, 68.1W"},{l="Caivad Sar",c="38.5N, 64.7W"},{l="Kulug-mokh",c="38.4N, 68.0W"}}},
		{name="Dwarf-ruins of Elderslade",flags={{l="Harveg Bridge",c="32.6N, 59.7W"},{l="Annak-khurfu",c="32.8N, 61.1W"},{l="Zarkul-sulun",c="32.7N, 63.0W"},{l="Shakal-atrad",c="34.3N, 61.9W"},{l="Zudramdan",c="36.8N, 64.6W"},{l="Gralinvarth",c="35.3N, 58.5W"},{l="Gates of Gundabad",c="38.3N, 67.4W"}}},
	}},
	["22.jpg"] = {map="22.jpg", name="Elderslade - The War of Three Peaks", c={n=88.3, w=-25.8, s=101.7, e=-11.0}, region=2, lvl={min=129,max=130}, faction={"March on Gundabad", "The Gabil'akka"}, epic={{"The Legacy Of Durin And The Trials Of The Dwarves",{"Chapter 4 - A First Confrontation"}}},craft={13},flags={
		{name="Battleground of the War of Three Peaks",flags={{l="Shakal-atrad",c="99.3S, 16.4W"},{l="Zarkul-sulun",c="100.8S, 17.3W"},{l="Howlers' Notch",c="97.7S, 16.8W"},{l="Zudramdan",c="96.7S, 19.1W"},{l="Caivad Sar",c="95.0S, 19.0W"},{l="Drenghul",c="94.9S, 19.8W"},{l="Ifbar-athrakh",c="98.5S, 18.4W"},{l="Ushkutoz",c="96.6S, 19.5W"},{l="Bagud-mekhem",c="93.8S, 20.8W"},{l="Azgh-buzru, the War-fell",c="95.2S, 20.8W"}}},
	}},
	["46.jpg"] = {map="46.jpg", name="Felegoth - The palace of the king of the elves", c={n=-49.8, w=-128.5, s=-46.1, e=-124.2}, region=2, lvl={min=115,max=115}},
	["58.jpg"] = {map="58.jpg", name="Bree-Land", c={n=22.8, w=-59.2, s=37.4, e=-42.1}, region=1, lvl={min=1,max=24},p="Bree-Land", faction={"Men of Bree", "The League of the Axe"}, epic={{"Volume I - The Shadows of Angmar",{"Book I - Stirrings in the Darkness", "Book II - The Red Maid", "Book VII - The Hidden Hope", "Book XIV - The Ring-forges of Eregion"}},{"Volume III - Allies of the King",{"Book I - Oath of the Rangers"}}},craft={1,2,3,4},flags={
		{name="The Ruins of Breeland",flags={{l="Bronwe's Folly",c="26.8S, 48.0W"},{l="Hillshire Ruins",c="27.8S, 58.7W"},{l="The Old Greenway Fort",c="24.0S, 53.1W"},{l="Blackwold's Roost",c="26.7S, 46.4W"},{l="Blackwold Headquarters",c="26.6S, 44.4W"},{l="Woodsedge Ruins",c="29.4S, 45.9W"},{l="Ost Baranor",c="33.3S, 48.4W"},{l="Marshwater Fort",c="30.9S, 44.6W"},{l="Goblinhole Ruins",c="33.1S, 42.9W"},{l="South-guard Ruins",c="35.7S, 51.5W"}}},
		{name="Inns in Bree-Land",flags={{l="The Prancing Pony",c="29.6S, 51.2W"}}}
	}},	
	["48.jpg"] = {map="48.jpg", name="Wildwood", c={n=15.2, w=-64.8, s=25.3, e=-53.8}, region=1, lvl={min=45,max=50}, p="Bree-Land", faction={"The League of the Axe","Woodcutter's Brotherhood"}, craft={5},flags={
		{name="Sites of the Wildwood",flags={{l="Trader's Wharf",c="21.4S, 61.5W"},{l="Writhenset",c="23.9S, 62.1W"},{l="East-delf",c="23.9S, 60.8W"},{l="West-delf",c="23.9S, 61.8W"},{l="Marl's Crossing",c="16.8S, 60.2W"},{l="Hunter's Ledge",c="18.3S, 57.6W"},{l="Helva's Edge",c="21.7S, 58.3W"},{l="Blomley Sward",c="22.5S, 60.8W"},{l="Old Bluff-house",c="23.5S, 59.2W"},{l="Overwine Hall",c="19.7S, 59.5W"},{l="Norwarden",c="18.5S, 55.2W"},{l="Sutwarden",c="23.6S, 56.0W"},{l="Cotfast",c="19.9S, 56.9W"},{l="Gnawbone Pit",c="19.4S, 55.3W"}}}
	}},
	["57.jpg"] = {map="57.jpg", name="Old Forest", c={n=29.8, w=-62.3, s=37.3, e=-54.5}, region=1, lvl={min=16,max=21}, p="Bree-Land",craft={2},flags={
		{name="The Old Forest",flags={{l="Bald Hill",c="31.5S, 59.0W"},{l="The Weaver's Den",c="36.8S, 57.6W"},{l="Tom Bombadil's House",c="32.7S, 57.3W"},{l="Goldberry's Spring",c="31.1S, 59.4W"},{l="Bonfire Glade",c="32.8S, 60.7W"}}}}},
	["49.jpg"] = {map="49.jpg", name="Azanulbizar", c={n=-71.6, w=-140.8, s=-62.6, e=-130.9}, region=2, lvl={min=130,max=130}, faction={"The Haban'akka of Thrain"}, epic={{"The Black Book of Mordor",{"Chapter 11 - A Window on the Past", "Chapter 12 - The Siege of Barad-dur"}}},craft={13},flags={
		{name="Azog's Realm",flags={{l="Kamaz-kala",c="65.0N, 134.0W"},{l="Gadh Ujaf",c="65.2N, 135.6W"},{l="Dursh Hul",c="65.9N, 132.7W"},{l="Tar-kutoz",c="69.8N, 135.0W"},{l="Rung-shakam",c="68.2N, 137.5W"},{l="Zaghuth",c="70.6N, 137.3W"},{l="Muru Azog",c="67.5N, 136.3W"}}},
		{name="Remnants of Khazad-dum",flags={{l="Amdan",c="63.6N, 135.1W"},{l="Gabilthurkhu",c="62.6N, 135.2W"},{l="Labam-gairu",c="64.0N, 136.2W"},{l="Khur Azan",c="64.4N, 133.0W"},{l="Kibil-nala",c="64.8N, 132.7W"},{l="Tharkh Shathur",c="66.1N, 131.2W"},{l="Ashmargathal",c="69.5N, 133.3W"},{l="Atrad-zarakh",c="69.3N, 134.5W"},{l="Tharkh Baraz",c="69.7N, 136.7W"},{l="Anlakh-zeleg",c="69.9N, 136.4W"},{l="Tharkh Zigil",c="66.6N, 137.2W"},{l="Zirakazhar",c="66.2N, 136.7W"},{l="Kheled-zaram",c="67.3N, 134.6W"},{l="Durinul'aban",c="66.5N, 135.0W"},{l="Nud-mekhem",c="67.6N, 137.4W"}}},
		{name="The War-camp of Thrain",flags={{l="House of Thrain",c="63.4N, 135.0W"},{l="Iron-folk",c="63.6N, 135.2W"},{l="Exiles",c="63.7N, 134.9W"},{l="Kambrada",c="63.0N, 134.5W"},{l="Zhlruka",c="63.7N, 136.0W"},{l="Temamir",c="62.5N, 134.6W"},{l="Narfanghoth",c="63.3N, 135.0W"},{l="Landorrim",c="63.2N, 135.3W"},{l="Abnuzhu",c="63.1N, 135.7W"}}}
	}},
	["50.jpg"] = {map="50.jpg", name="Welkin-lofts", c={n=-50.9, w=-79.8, s=-41.4, e=-69.4}, region=2, lvl={min=139,max=140},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Sites of Welkin-lofts",flags={{l="Bazan-medan",c="46.1N, 76.1W"},{l="Fellgat",c="49.5N, 74.5W"},{l="Flogalith",c="49.2N, 75.4W"},{l="Draurakh",c="48.8N, 76.8W"},{l="Mullach Cagar",c="47.9N, 74.6W"},{l="Thyrstath",c="46.3N, 77.1W"},{l="Bagud-dum",c="44.1N, 72.8W"},{l="Bagud-bukhnu",c="42.3N, 71.6W"},{l="Uzdarulzahar",c="42.3N, 73.8W"},{l="Ibdekh-buzru, the Thing-fold",c="45.5N, 73.2W"},{l="Grymmclud",c="46.0N, 75.2W"}}}
	}},
	["51.jpg"] = {map="51.jpg", name="C\195\162r Bronach", c={n=-58.1, w=-75.7, s=-45.6, e=-58.8}, region=2, lvl={min=135,max=135},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Scouting the Sorrowglen",flags={{l="Leitstath",c="47.0N, 64.9W"},{l="Cragan Bris",c="49.5N, 65.5W"},{l="Grumachath",c="50.1N, 68.5W"},{l="Eiglinn",c="49.8N, 70.9W"},{l="Clavanail",c="56.2, 72.1W"},{l="Eirichav",c="56.1N, 71.4W"}}},
		{name="The Last Frontier of Angmar",flags={{l="Rathad Caul, the Narrow Way",c="44.6N, 63.9W"},{l="Hlidborg",c="49.1N, 63.3W"},{l="Skailag",c="50.9N, 65.4W"},{l="Tag Fogarrach",c="51.3N, 71.6W"},{l="Toll Oivas",c="52.1N, 74.1W"},{l="Mur Shatraug, the Witch-gate",c="47.7N, 70.6W"},{l="Agal Dun",c="52.8N, 68.8W"},{l="Tur Fuar, the Drearspire",c="52.8N, 68.8W"},{l="Balach Iaran, the Iron Pass",c="54.4N, 73.1W"}}}
	}},
	["52.jpg"] = {map="52.jpg", name="Clovengap", c={n=32.8, w=-128.8, s=43.4, e=-117.3}, region=2, lvl={min=138,max=138},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Discovering Clovengap",flags={{l="Stokkset",c="42.1S, 121.5W"},{l="Kurdushalak",c="40.0S, 121.1W"},{l="Danakh-khej",c="37.6S, 120.9W"},{l="Tharrkirin",c="36.6S, 121.6W"},{l="Amgaruslun",c="34.1S, 125.1W"},{l="Bazanmanar",c="36.9S, 120.2W"}}},
		{name="The Fall of Forstori",flags={{l="Dashat-zahar",c="39.6S, 122.1W"},{l="Garanashmar",c="38.3S, 122.7W"},{l="Frosthel",c="37.1S, 123.4W"},{l="Anatrad",c="35.0S, 121.6W"},{l="Maranazhar",c="39.6S, 120.3W"},{l="Skarashulg",c="41.0S, 121.6W"},{l="Min Navaid",c="38.0S, 123.9W"}}}
	}},
	["53.jpg"] = {map="53.jpg", name="Gloomingtarn", c={n=43.3, w=-127.0, s=51.4, e=-118.1}, region=2, lvl={min=137,max=137},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Invaders on the Dark Lake",flags={{l="Drukala",c="50.2S, 121.3W"},{l="Ormgren",c="48.7S, 120.2W"},{l="Glittengrof",c="49.6S, 122.4W"},{l="Skelstrand",c="46.7S, 121.7W"},{l="Min Lorg",c="46.3S, 123.9W"},{l="Lochan Duv",c="45.5S, 123.9W"}}},
		{name="The Cradle of Durin",flags={{l="Zaram-mekhem",c="50.4S, 120.5W"},{l="Durthuzaram, the Dark Lake"},{l="Watchers' Roost",c="47.7S, 121.8W"},{l="Lugun-nala",c="45.6S, 122.8W"},{l="Abkan'aban, the Stone of Wakening",c="44.8S, 120.8W"},{l="Burmumekhem",c="42.6S, 121.9W"}}}
	}},
	["54.jpg"] = {map="54.jpg", name="Pit of Stonejaws", c={n=37.3, w=-117.0, s=44.8, e=-108.9}, region=2, lvl={min=134,max=134},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Sites of Stonejaws",flags={{l="Shakhajat",c="40.0S, 113.7W"},{l="Borkordh",c="43.2S, 110.4W"},{l="Stazg Vozag",c="39.8S, 112.6W"},{l="Akhaldarag",c="42.6S, 114.7W"},{l="Adkhat-zahhar, the Houses of Rest",c="38.7S, 115.0W"},{l="Bargstad",c="44.2S, 113.8W"},{l="Mur Shatraug, the Witch-gate",c="37.9S, 111.8W"}}}
	}},
	["55.jpg"] = {map="55.jpg", name="Deepscrave", c={n=47.7, w=-120.0, s=52.3, e=-115.2}, region=2, lvl={min=133,max=133},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Sites of Deepscrave",flags={{l="Aslif",c="50.1, 117.2W"},{l="Buzra-salan",c="47.1S, 117.6W"},{l="Gabil-memag",c="49.8S, 119.4W"},{l="Abad-nuhbu, the Berg-beam",c="50.3S, 117.3W"}}},
		{name="Enemies of Deepscrave",flags={{l="Kordh Gurat",c="51.5S, 118.5W"},{l="Durshulot",c="49.1S, 118.1W"},{l="Gazat-fark",c="51.0S, 115.8W"},{l="Durbangh",c="51.0S, 115.3W"},{l="Dalugronk",c="48.7S, 116.3W"},{l="Vatug-ronk, the Groaning Pit",c="50.7S, 118.7W"},{l="Shataz-kordh",c="48.1S, 117.0W"},{l="Skrizagaf",c="48.2S, 116.6W"}}}
	}},
	["56.jpg"] = {map="56.jpg", name="M\195\161ttugard", c={n=44.5, w=-116.7, s=51.5, e=-109.8}, region=2, lvl={min=130,max=132},p="Gundabad", faction={"Reclaimers of the Mountain-hold"}, craft={14},flags={
		{name="Enemies of Mattugard",flags={{l="Bushatap",c="50.2S, 112.7W"},{l="Khorroz",c="50.7S, 112.6W"},{l="Ronglagam",c="46.7S, 115.2W"},{l="Sadauk-kala",c="45.0S, 113.9W"},{l="Bruvraum ",c="46.9S, 111.5W"},{l="Tholmuzog",c="47.8S, 115.2W"},{l="Var Nuchur",c="48.7S, 113.8W"}}},
		{name="Sites of M\195\161ttugard",flags={{l="Maergrind, The Noble Gate",c="49.3S, 112.0W"},{l="Asbaj-khirfin",c="46.0S, 112.1W"},{l="Imrekh-guthlu",c="48.9S, 115.0W"},{l="Zidir-nesad, The Steepset",c="46.2S, 114.2W"},{l="Shalakibal",c="47.3S, 112.0W"},{l="Vernozal",c="45.3S, 115.0W"}}}
	}},
	["59.jpg"] = {map="59.jpg", name="Angle of Mitheithel", c={n=33.0, w=-24.6, s=44.5, e=-14.3}, region=1, lvl={min=40,max=45},p="Trollshaws", faction={"Defenders of the Angle"},craft={4,5},flags={
		{name="Sites of the Angle",flags={{l="Fernbrake Cot",c="39.4S, 17.4W"},{l="Tham Lumren",c="38.7S, 17.3W"},{l="Gaerond",c="34.7S, 22.2W"},{l="Cuan-luth Refuge",c="41.6S, 23.4W"},{l="Tornhad ",c="42.8S, 23.4W"}}},
		{name="Enemies of the Angle",flags={{l="Eitheldir",c="36.2S, 22.7W"},{l="Glynafon",c="40.0S, 18.3W"},{l="Ost Waeren",c="38.4S, 22.3W"},{l="Thelgarth",c="44.6S, 22.9W"}}}
	}},
	["61.jpg"] = {map="61.jpg", name="The Shire", c={n=24.9, w=-77.2, s=36.3, e=-63.2}, region=1, lvl={min=1,max=13}, faction={"The Mathom Society","The Inn League"}, craft={1,2},flags={
		{name="The Farms of the Shire",flags={{l="Dora Brownlock's Farm",c="31.3S, 72.7W"},{l="Bamfurlong",c="34.3S, 64.4W"},{l="Old Odo's Leaf-Farm",c="33.8S, 68.0W"},{l="South Fields",c="34.4S, 74.4W"},{l="Appledores",c="29.5S, 72.0W"},{l="Puddifoot's Fields",c="31.1S, 64.2W"}}},
		{name="The Sights of the Shire",flags={{l="The Party Tree",c="29.9S, 71.5W"},{l="Methel-stage",c="32.5S, 69.9W"},{l="Stocktower",c="33.0S, 63.6W"},{l="The Quarry",c="27.9S, 65.7W"},{l="Bridgefields Wall",c="30.5S, 64.1W"},{l="The Great Willow",c="33.6S, 70.4W"}}},
		{name="Inns in the Shire",flags={{l="The Bird and Baby Inn",c="33.4S, 75.3W"},{l="The Floating Log Inn",c="31.7S, 68.0W"},{l="The Golden Perch",c="32.0S, 63.8W"},{l="The Green Dragon",c="31.8S, 69.6W"},{l="The Plough and Stars",c="27.6S, 68.1W"}}}
	}},
	["62.jpg"] = {map="62.jpg", name="Ered Luin", c={n=14.4, w=-105.9, s=29.7, e=-87.7}, region=1, lvl={min=1,max=13}, faction={"Thorin's Hall","The Ale Association"}, epic={{"Volume I - The Shadows of Angmar",{"Book VII - The Hidden Hope","Book IX - The Shores of Evendim","Book XIV - The Ring-forges of Eregion"}}},craft={1,2},flags={
		{name="Scouting the Dourhands",flags={{l="Ringdale",c="17.5S, 96.1W"},{l="The Grimwater",c="17.7S, 94.7W"},{l="Spire of Kheledul",c="21.3S, 92.0W"},{l="Kheledul Docks",c="21.8S, 91.5W"}}},
		{name="Places of the Dwarves",flags={{l="Frerin's Court",c="15.0S, 103.2W"},{l="Thorin's Gates",c="13.8S, 103.2W"},{l="Silver Deep mine",c="14.3S, 101.7W"},{l="Noglond",c="19.3S, 100.5W"},{l="Gondamon",c="20.3S, 97.0W"}}},
		{name="Elf-ruins Exploration",flags={{l="Nen Hilith",c="29.2S, 95.0W"},{l="Tham Gelair",c="27.5S, 94.4W"},{l="Limael's Vineyard",c="26.6S, 95.7W"},{l="Dol Ringwest",c="24.9S, 95.0W"},{l="The Wardspire",c="17.8S, 90.1W"}}},
		{name="Rath Teraig Exploration",flags={{l="Northern Barricade",c="22.1S, 96.9W"},{l="Southern Barricade",c="24.6S, 96.7W"},{l="Tum Agor",c="21.6S, 96.2W"},{l="Amon Thanc",c="23.2S, 97.3W"},{l="Crookdell",c="24.3S, 98.4W"}}}
	}},
	["63.jpg"] = {map="63.jpg", name="The Yondershire", c={n=17.4, w=-89.2, s=32.1, e=-72.2}, p="La Comt\195\169", region=1, lvl={min=20,max=23}, faction={"The Yonder-watch"},craft={3},flags={
		{name="Site of Yondershire",flags={{l="Bar Faroth",c="20.0S, 77.1W"},{l="Ost Lagorath",c="21.8S, 82.3W"},{l="Taerhad",c="21.6S, 74.4W"},{l="Tham Amothir",c="27.3S, 86.4W"},{l="Gamwich",c="24.0S, 82.5W"},{l="Long Cleeve",c="22.1S, 78.7W"},{l="Nobottle",c="26.9S, 78.9W"},{l="Tighfield",c="26.6S, 82.4W"},{l="Lhungobel",c="19.1S, 88.7W"}}}
	}},
	["64.jpg"] = {map="64.jpg", name="Eregion", c={n=36.6, w=-20.5, s=57.1, e=1.2}, region=1, lvl={min=48,max=53}, epic={{"Volume II - Mines of Moria",{"Book I - The Walls of Moria"}}},craft={5,6},flags={
		{name="Dens of the Beasts",flags={{l="Torech Braignel",c="44.0S, 8.8W"},{l="Torech Ladnel",c="47.1S, 15.2W"},{l="Torech Bornagol",c="46.4S, 10.4W"},{l="Burnt Tor",c="49.1S, 10.5W"},{l="S\195\162d Umroval",c="48.2S, 12.4W"},{l="Torech Andraug",c="50.7S, 9.6W"},{l="Ulundin",c="56.0S, 14.4W"}}},
		{name="The Ring Goes South",flags={{l="Burnt Tor",c="49.1S, 10.5W"},{l="Caradhras campfire",c="46.6S, 2.7W"},{l="Sirannon Gate",c="50.6S, 7.6W"},{l="High Hollin campsite",c="43.8S, 12.9W"},{l="Tal Caradhras campsite",c="45.8S, 8.7W"}}},
		{name="The Ruins of Eregion",flags={{l="Gwingris",c="40.1S, 16.1W"},{l="Echad Eregion",c="47.0S, 12.4W"},{l="Echad Mirobel",c="52.3S, 16.7W"},{l="Echad Dunann",c="50.5S, 7.8W"},{l="Pembar",c="44.1S, 10.8W"},{l="Barad Morlas",c="48.1S, 13.7W"}}}
	}},
	["65.jpg"] = {map="65.jpg", name="Enedwaith", c={n=58.1, w=-25.6, s=76.5, e=-5.5}, region=1, lvl={min=61,max=65}, faction={"Algraig, Men of Enedwaith", "The Grey Company"}, epic={{"Volume III - Allies of the King",{"Book II - Ride of the Grey Company", "Book III - Echoes of the Dead", "Book IV - Rise of Isengard", "Book VI - Mists of Anduin"}}},craft={6},flags={
		{name="Path of the Grey Company",flags={{l="Echad Dagoras",c="58.5S, 14.6W"},{l="Echad Saeradan",c="63.8S, 17.5W"},{l="Echad Idhrenfair",c="63.5S, 21.5W"},{l="Echad Daervunn",c="66.6S, 21.5W"},{l="Harndirion",c="69.7S, 13.7W"}}},
		{name="The Cartrevs of Enedwaith",flags={{l="Cartrev Duved",c="59.0S, 12.3W"},{l="Cartrev Emlun",c="67.9S, 14.6W"},{l="Cartrev Rurith",c="69.4S, 17.9W"},{l="Cartrev Matho",c="69.7S, 15.3W"},{l="Cartrev Hamon",c="68.0S, 17.0W"}}}
	}},
	["66.jpg"] = {map="66.jpg", name="Lone-lands", c={n=27.3, w=-41.8, s=42.8, e=-22.9}, region=1, lvl={min=22,max=35}, faction={"The Eglain"}, epic={{"Volume I - The Shadows of Angmar",{"Book II - The Red Maid","Book III - The Council of the North","Book IX - The Shores of Evendim","Book XI - Prisoner of the Free Peoples"}}},craft={2,3,4},flags={
		{name="Garth Agarwen Exploration",flags={{l="The Circle of Blood",c="31.2S, 27.2W"},{l="Nan Dhelu",c="30.5S, 25.3W"},{l="The Outer Gates",c="28.0S, 25.2W"},{l="Garth Agarwen Gate\nInside the instance : Garth Agarwen: Fortress",c="28.8S, 23.9W"},{l="Ivar's Crypt\nInside the instance : Garth Agarwen: Barrows",c="28.1S, 23.1W"},{l="Spring of the Red Maid\nInside the instance : Garth Agarwen: Fortress",c="29.7S, 23.2W"}}},
		{name="Weathertop Exploration",flags={{l="Echad Sul",c="29.4S, 37.0W"},{l="Weatherfoot",c="31.9S, 38.6W"},{l="Glumhallow",c="30.1S, 38.6W"},{l="Weathertop",c="31.2S, 36.9W"}}},
		{name="The Grimfens",flags={{l="Ost Haer",c="37.6S, 28.0W"},{l="Nindor",c="37.9S, 29.6W"}}},
		{name="Defences of the Lone-lands",flags={{l="Barad Iachiant",c="35.8S, 38.3W"},{l="Ost Laden",c="34.5S, 37.5W"},{l="The Lornspan",c="34.7S, 35.5W"},{l="Mithrenost",c="34.7S, 34.4W"},{l="Thandobel",c="33.8S, 32.7W"},{l="Ost Cyrn",c="33.6S, 30.9W"},{l="Naerost",c="30.7S, 33.9W"},{l="Amon Ros",c="30.9S, 31.7W"},{l="Ost Guruth",c="31.5S, 29.5W"}}}
	}},
	["67.jpg"] = {map="67.jpg", name="Trollshaws", c={n=24.3, w=-23.4, s=41.5, e=-1.6}, region=1, lvl={min=35,max=39}, faction={"Elves of Rivendell"}, epic={{"Volume I - The Shadows of Angmar",{"Book IV - Chasing Shadows","Book V - The Last Refuge","Book VI - The Fires in the North","Book VII - The Hidden Hope","Book VIII - The Scourge of the North","Book IX - The Shores of Evendim","Book XI - Prisoner of the Free Peoples","Book XII - The Ashen Wastes","Book XIII - Doom of the Last-king","Book XIV - The Ring-forges of Eregion","Book XV - Daughter of Strife"}},{"Volume III - Allies of the King",{"Book I - Oath of the Rangers","Book II - Ride of the Grey Company"}}},craft={4},flags={
		{name="The Road to Rivendell",flags={{l="The Last Bridge",c="33.5S, 23.2W"},{l="Barachen's Camp",c="34.0S, 20.2W"},{l="The Ford of Bruinen",c="33.5S, 11.4W"},{l="The Gates of Imladris",c="32.1S, 6.2W"}}},
		{name="The Wilds of T\195\162l Bruinen",flags={{l="Cirith Ulunn",c="37.6S, 11.2W"},{l="Echad Candelleth",c="36.8S, 14.2W"},{l="Eryn Singor",c="35.4S, 16.6W"},{l="Echad Gauradan",c="38.3S, 16.1W"},{l="Torech Ullug",c="39.7S, 14.6W"},{l="Delossad",c="38.4S, 12.8W"}}},
		{name="Ruins of the Trollshaws",flags={{l="Trapdoor Lair",c="26.1S, 18.6W"},{l="Ost Thondol",c="31.1S, 13.2W"},{l="Minas Ciliant",c="27.0S, 14.7W"},{l="Ost Chall",c="26.9S, 14.0W"},{l="Amon Varadh",c="27.9S, 14.9W"},{l="Ost Brandras",c="28.0S, 13.6W"},{l="Barad Glamgil",c="28.8S, 14.1W"},{l="Ost Durgonn",c="31.8S, 20.2W"}}}
	}},
	["68.jpg"] = {map="68.jpg", name="The Great River", c={n=18.2, w=-72.8, s=36.7, e=-47.6}, region=2, lvl={min=70,max=75}, faction={"The Riders of Stangard","Heroes of Limlight Gorge"}, epic={{"Volume III - Allies of the King",{"Book VI - Mists of Anduin","Book VII - A Fellowship Endangered"}}},craft={7},flags={
		{name="Thinglad Explorer",flags={{l="Foul-maw's Den",c="24.4S, 60.8O"},{l="Haldirith",c="21.5S, 63.4O"},{l="the Old Burrows",c="23.0S, 63.8O"},{l="Ungund",c="19.8S, 63.4O"},{l="His-urdan",c="23.7S, 62.1O"}}},
		{name="Eorlsmead Explorer",flags={{l="Abandoned Farm",c="29.5S, 60.1O"},{l="Fetid Caves",c="28.0S, 61.3O"},{l="Stangarde",c="26.4S, 63.9O"},{l="Eorlsmead Tower",c="28.0S, 59.9O"},{l="the Teeming Nest",c="26.5S, 60.1O"}}},
		{name="Limlight Gorge Explorer",flags={{l="Limlight Gatehouse",c="25.4S,67.0O"},{l="Limlight Falls",c="28.5S, 72.3O"},{l="the Ent-grove",c="29.4S, 72.1O"},{l="the Fallen Watchtower",c="28.1S, 68.6O"},{l="the Pothole",c="27.3S, 71.3O"},{l="the Prospector's Shack",c="27.0S, 69.9O"},{l="Old Sawmill",c="29.0S, 69.7O"}}},
		{name="Wailing Hills Explorer",flags={{l="Cuthstan",c="25.6S, 65.6O"},{l="Frithstan's Camp",c="24.7S, 65.5O"},{l="Nink-hai Camp",c="27.4S, 66.7O"},{l="Mor-hai Settlement",c="23.9S, 68.1O"},{l="Secluded Clearing",c="22.2S, 64.9O"},{l="Venom-bite Cave",c="22.2S, 66.5O"},{l="Aster Hill",c="22.9S, 65.7O"}}},
		{name="Parth Celebrant Explorer",flags={{l="Idmar's Camp",c="28.5S, 56.8O"},{l="Field of Celebrant",c="28.5S, 57.9O"},{l="Hordfierd",c="30.4S, 57.9O"},{l="Ost Celebrant",c="30.3S, 56.0O"},{l="the Murderous Pit",c="26.7S - 57.3O"}}},
		{name="Rushgore Explorer",flags={{l="Aculf's Camp",c="29.1S, 55.2O"},{l="Atburg",c="30.9S, 53.8O"},{l="Wyrmdenn",c="28.0S, 54.6O"},{l="The Creeping Mud",c="28.3S, 51.9O"},{l="Tik Botokh",c="30.0S, 53.2O"},{l="The Clutch-ground",c="29.5S, 52.8O"}}},
		{name="Brown Lands Explorer",flags={{l="Etheburg",c="31.3S, 52.1O"},{l="Helstor",c="28.9S, 50.5O"},{l="Lashkarg",c="33.2S, 51.9O"},{l="Desolation of the Gardens",c="32.8S, 47.9O"},{l="The Stone-hole",c="32.0S, 47.8O"}}}
	}},
	["69.jpg"] = {map="69.jpg", name="Swanfleet", c={n=41.9, w=-41.1, s=65.8, e=-15.0}, region=1, epic={{"Before the Shadow",{"Book 1"}}}, lvl={min=1,max=14},flags={
		{name="The Many Folk of the Glanduin",flags={{l="Mossward",c="60.8S, 34.7W"},{l="Clegur",c="65.1S, 29.1W"},{l="Lhan Garan",c="54.6, 27.0W"},{l="Glyn Helyg",c="62.4S, 25.9W"},{l="Lintrev",c="61.7S, 24.2W"},{l="Echad Terthas",c="52.8S, 22.5W"},{l="Idhobel",c="47.2S, 18.9W"}}},
		{name="Perils of Swanfleet",flags={{l="Howlingstones",c="61.5S, 33.4W"},{l="Radlaw",c="59.6S, 29.6W"},{l="Fangsettle",c="54.4S, 30.2W"},{l="Bloodhollow",c="56.8S, 21.6W"},{l="Cobshallow",c="65.6S, 26.4W"},{l="Sharmokal",c="60.2S, 22.2W"},{l="Caras Gelebren",c="54.2S, 21.6W"},{l="Tham Lasgol",c="48.8S, 24.0W"},{l="Gwal Cruban",c="51.9S, 26.0W"},{l="Tham Celechir",c="45.5S, 19.3W"}}},
	}},
	["70.jpg"] = {map="70.jpg", name="Cardolan", c={n=35.0, w=-57.8, s=58.8, e=-28.6}, region=1, lvl={min=20,max=32}, epic={{"Before the Shadow",{"Book 2","Book 3"}}}, faction={"Dunedain of Cardolan"}, flags={
		{name="Inhabitants of the Vanished Realm",flags={{l="Stonecrop Encampment",c="54.3S, 40.1W"},{l="Gerwyn's Convoy",c="37.7S, 49.8W"},{l="Sirlond",c="44.8S, 39.5W"},{l="Herne",c="49.8S, 45.0W"},{l="Scurlog Farm",c="43.3S, 33.6W"},{l="Sarn Ford",c="47.8S, 56.2W"}}}
	}},
	["71.jpg"] = {map="71.jpg", name="The Wold", c={n=31.6, w=-60.3, s=48.4, e=-43.8}, p="East Rohan", region=3, lvl={min=75,max=77}, faction={"Men of the Wold"}, epic={{"Volume III - Allies of the King",{"Book VIII - Into the Riddermark","Book X - Snows of Wildermore"}}},craft={8},flags={
		{name="Cities of Eastern Rohan",flags={{l="Langhold",c="36.2S, 53.5W"},{l="Harwick",c="39.0S, 52.3W"},{l="Floodwend",c="45.3S, 48.2W"},{l="Feldburg",c="42.4S, 52.1W"}}},
		{name="Enemies of the Rohirrim",flags={{l="Olghakhosh",c="40.2S, 49.2W"},{l="Joshkhin Orda",c="41.8S, 47.7W"},{l="Eastmunt's Lair",c="36.1S, 56.0W"},{l="South Undeep",c="34.9S, 47.9W"},{l="Nin-stazg",c="47.0S, 46.9W"}}},
		{name="Ruins, tombs and Monuments of the Eastemnet",flags={{l="Eorl's Hallow",c="45.6S, 51.2W"},{l="Wodscrafen",c="42.4S, 49.4W"},{l="The seething Mire",c="37.9S, 54.3W"},{l="Dwolung Hole",c="40.7S, 54.5W"}}},
		{name="The defences of Eastern Rohan",flags={{l="Suth-torr",c="41.2S, 47.8W"},{l="North-torr",c="44.0S, 47.6W"},{l="Undeep Watch",c="35.9S, 49.0W"},{l="Wakenflood",c="38.1S, 50.4W"},{l="Twinkenburg",c="44.2S, 49.8W"}}},
		{name="The wilds of the Eastemnet",flags={{l="The Stinging Bog",c="41.7S, 50.5W"},{l="Cracabor",c="42.8S, 49.3W"}}},
		{name="Where Evil Creatures Dwell",flags={{l="The Howling wood",c="44.6S, 46.6W"},{l="Fang Point",c="44.4S, 51.4W"}}},
	}},
	["72.jpg"] = {map="72.jpg", name="The East Wall", c={n=46.7, w=-60.3, s=63.2, e=-42.3}, p="East Rohan", region=3, lvl={min=76,max=77}, epic={{"Volume III - Allies of the King",{"Book VII - A Fellowship Endangered"}}},craft={8},flags={
		{name="East Wall Explorer",flags={{l="Mansig's Encampment",c="52.1S, 51.4W"},{l="Dead Orc Glade",c="56.6S, 49.8W"},{l="Parth Galen",c="58.7S, 47.8W"},{l="The Tindrock",c="59.0S, 46.5W"},{l="Falls of Rauros",c="61.2S, 45.8W"},{l="Amon Hen",c="61.3S, 46.6W"},{l="The Sutcrofts Barricade",c="60.9S, 53.6W"},{l="The North-guard",c="55.0S, 51.1W"},{l="The Hissing Pit",c="58.9S, 50.3W"},{l="The South-guard",c="60.7S, 52.5W"}}},
	}},
	["73.jpg"] = {map="73.jpg", name="Norcrofts", c={n=42.7, w=-62.9, s=57.1, e=-47.1}, p="East Rohan", region=3, lvl={min=78,max=80}, faction={"Men of the Norcrofts"}, epic={{"Volume III - Allies of the King",{"Book VIII - Into the Riddermark"}}},craft={8},flags={
		{name="Cities of Eastern Rohan",flags={{l="Cliving",c="43.4S, 56.5W"},{l="Elthengels",c="48.8S, 52.7W"},{l="Faldham",c="54.8S, 57.2W"}}},
		{name="Enemies of the Rohirrim",flags={{l="Kufuzg",c="51.4S, 52.9W"},{l="The White Hand Ninkh-hai War-camp",c="55.7S, 55.1W"}}},
		{name="Ruins, tombs and Monuments of the Eastemnet",flags={{l="The Red Fields",c="46.5S, 54.8W"},{l="The Ancient Tomb",c="49.9S, 52.6W"},{l="Minas Rant",c="51.3S, 59.1W"}}},
		{name="The defences of Eastern Rohan",flags={{l="Rohirrim Training Grounds",c="42.5S, 53.7W"},{l="Western Cliving Watchtower",c="44.8S, 59.5W"},{l="Trader's Outpost",c="48.6S, 55.3W"},{l="Caddabrand's Camp",c="51.4S, 55.8W"}}},
		{name="Where Evil Creatures Dwell",flags={{l="Ambal's Den",c="51.8S, 57.6W"},{l="Valley of the Lathbear",c="54.4S, 52.7W"}}},
		{name="Farms and Crofts of the Eastemnet",flags={{l="Randgar's Farm",c="44.1S, 53.8W"},{l="Springview Estate",c="49.5S, 56.6W"}}},
	}},
	["74.jpg"] = {map="74.jpg", name="Eaves of Fangorn", c={n=34.9, w=-77.7, s=42.7, e=-69.1}, p="East Rohan", region=3, lvl={min=83,max=84},epic={{"Volume III - Allies of the King",{"Book IX - The Third Marshal"}}},craft={8},flags={
		{name="Eaves of Fangorn Exploration",flags={{l="The Silkenhold",c="36.6S, 71.7W"},{l="The Black Heart",c="37.6S, 75.2W"},{l="The Hale-gap",c="41.5S, 73.4W"},{l="Sweetmead",c="38.0S, 73.2W"},{l="The Fogwater",c="38.4S, 72.2W"}}},
	}},
	["75.jpg"] = {map="75.jpg", name="Sutcrofts", c={n=53.2, w=-65.7, s=66.4, e=-51.2}, p="East Rohan", region=3, lvl={min=84,max=85},faction={"Men of the Sutcrofts"}, epic={{"Volume III - Allies of the King",{"Book IX - The Third Marshal","Book X - Snows of Wildermore"}}},craft={8},flags={
		{name="Cities of Eastern Rohan",flags={{l="Garsfeld",c="54.7S, 61.8W"},{l="Snowbourn",c="60.5S, 61.3W"}}},
		{name="Enemies of the Rohirrim",flags={{l="Krash-Balum",c="54.1S, 59.6W"},{l="Ash Durub",c="62.0S, 56.2W"},{l="Ufum-mau",c="64.7S, 55.5W"}}},
		{name="Ruins, tombs and Monuments of the Eastemnet",flags={{l="Dagred's Grave",c="60.2S, 58.7W"}}},
		{name="The wilds of the Eastemnet",flags={{l="Croft-watch",c="54.3S, 59.0W"}}},
		{name="Farms and Crofts of the Eastemnet",flags={{l="Bradcroft",c="57.1S, 61.5W"},{l="Desolate Crofts",c="63.4S, 56.9W"},{l="Wyrthing",c="59.0S, 61.4W"}}},
	}},
	["76.jpg"] = {map="76.jpg", name="Entwash Vale", c={n=39.8, w=-73.3, s=54.1, e=-57.6}, p="East Rohan", region=3, lvl={min=80,max=82},faction={"Men of the Entwash Vale"}, epic={{"Volume III - Allies of the King",{"Book VIII - Into the Riddermark","Book IX - The Third Marshal"}}},craft={8},flags={
		{name="Cities of Eastern Rohan",flags={{l="Eaworth",c="47.7S, 63.6W"},{l="Thornhope",c="42.5S, 67.5W"}}},
		{name="Enemies of the Rohirrim",flags={{l="Maustazg",c="49.1S, 62.7W"},{l="Thrug-unur",c="40.1S, 68.6W"}}},
		{name="Ruins, tombs and Monuments of the Eastemnet",flags={{l="The City In Ruin",c="41.5S, 67.2W"},{l="Byrgenstow",c="44.7S, 66.5W"}}},
		{name="Wild Horse Herd",flags={{l="The Wodfen",c="45.1S, 65.8W"},{l="Troupeau de chevaux sauvages",c="43.3S, 68.8W"}}},
		{name="Where Evil Creatures Dwell",flags={{l="Wyrmdelf",c="45.0S, 61.7W"}}}
	}},
	["77.jpg"] = {map="77.jpg", name="Lothlorien and the dimrill vale", c={n=6.0, w=-82.0, s=21.1, e=-61.9}, region=2, lvl={min=56,max=60}, faction={"Galadhrim"}, epic={{"Volume II - Mines of Moria",{"Book VII - The Leaves of Lorien","Book VIII - Scourge of Khazad-dum","Book IX - Fortress of the Nazgul"}},{"Volume III - Allies of the King",{"Book VI - Mists of Anduin","Book VII - A Fellowship Endangered"}}},craft={6},flags={
		{name="City of the Lord and Lady",flags={{l="The House of Celeborn",c="15.4S, 67.0W"},{l="Galadriel's Garden",c="15.9S, 66.3W"},{l="Celurlin",c="14.9S, 67.2W"},{l="Ungund",c="19.8S, 63.4O"},{l="The Company's Pavillion",c="15.0S, 66.8W"},{l="Telain Galadhrim",c="15.7S, 67.8W"},{l="Telain Bangad",c="15.0S, 68.0W"},{l="Telain Melthin",c="14.4S, 67.4W"},{l="Telain Glorelloth",c="16.0S, 67.5W"},{l="Telain Neduil",c="14.9S, 66.3W"}}},
		{name="Lorien Lookout",flags={{l="Cerin Amroth",c="11.6S, 67.8W"},{l="Talan Fanuidhol",c="12.1S, 71.1W"},{l="Talan Gwilith",c="11.4S, 70.7W"},{l="Talan Dolinhen",c="15.9S, 72.3W"},{l="Talan Atharchen",c="15.7S, 72.3W"},{l="Talan Tirith",c="15.0S, 72.3W"},{l="Talan Orthelian",c="13.5S, 72.1W"},{l="Talan Mallelas",c="16.4S, 72.2W"},{l="Talan Brethil",c="12.2S, 62.4W"},{l="Talan Revail",c="9.4S, 65.3W"},{l="Talan Haldir",c="16.2S, 73.5W]"}}},
		{name="Wanderer of the Golden Wood",flags={{l="Echad Andestel",c="14.2S, 73.0W"},{l="Lady's Rest",c="16.3S, 70.2W"},{l="Cerin Nauth",c="12.8S, 70.1W"},{l="The Vineyards of Lorien",c="18.5S, 64.0W"},{l="Imlad Lalaith",c="17.3S, 64.0W"},{l="The Garden of Memory",c="13.5S, 66.0W"},{l="Bain Gwaloth",c="12.9S, 67.2W"},{l="Sad Gilthiriad",c="12.6S, 64.5W"},{l="Cerin Brethil",c="10.4S, 63.9W"},{l="The Quiet Garden",c="10.9S, 69.4W"}}}
	}},
	["78.jpg"] = {map="78.jpg", name="Dunland", c={n=72.4, w=-26.4, s=89.2, e=-8.1}, region=1, lvl={min=65,max=71}, faction={"Men of Dunland","Theodred's Riders"}, epic={{"Volume III - Allies of the King",{"Book IV - Rise of Isengard"}}},craft={7},flags={
		{name="Exploring Carreglyn",flags={{l="Lower Barnavon",c="84.9S, 16.8W"},{l="Upper Barnavon",c="84.9S, 17.6W"},{l="Naur-maudhul",c="81.9S, 15.7W"},{l="Barnavon Mine",c="84.7S, 14.4W"},{l="Hen Turrau",c="85.1S, 15.1W"},{l="Lhun Avanc",c="86.0S, 17.4W"},{l="Munfaeril's Shrine",c="83.9S, 16.8W]"}}},
		{name="Exploring Pren Gwydh",flags={{l="The Fanged Lair",c="79.2S, 17.0W"},{l="Bloodtusk's Den",c="80.2S, 18.7W"},{l="Galtrev Lumber-camp",c="78.9S, 15.7W"},{l="The Dragon-clan Settlement",c="79.9S, 19.5W"},{l="The Howling Caverns",c="78.2S, 13.8W"},{l="Rook's Hut",c="79.5S, 19.0W"}}},
		{name="Exploring Starkmoor",flags={{l="Avardin",c="83.4S, 20.7W"},{l="Flam-cadlus",c="81.7S, 18.2W"},{l="Cartrev Andras",c="81.3S, 21.3W"},{l="The Hound's Rest",c="84.4S, 18.9W"},{l="The Culling Pit",c="83.3S, 21.4W"},{l="The Overlook of Wulf's Cleft",c="87.7S, 17.3W"}}},
		{name="Exploring the Bonevales",flags={{l="The Bone Quarry",c="76.8S, 15.0W"},{l="Plas-maru",c="76.1S, 14.3W"},{l="Echad Naeglanc",c="77.3S, 15.8W"},{l="Lhan Bach",c="76.7S, 18.2W"},{l="Lhan Gogledh",c="75.8S, 17.5W"}}},
		{name="Exploring the Dunbog",flags={{l="Lhan Colvarn",c="84.0S, 24.4W"},{l="Lhan Rhos",c="87.2S, 23.2W"},{l="The Withered Stones",c="88.8S, 23.8W"},{l="Durgors",c="88.0S, 25.7W"},{l="The Pristine Glade",c="85.5S, 25.7W"}}},
		{name="Exploring Trum Dreng",flags={{l="Dire Hollow",c="76.9S, 23.0W"},{l="The Herd-lands",c="79.2S, 24.0W"},{l="Lhan Tarren",c="75.3S, 22.7W"},{l="The North Pass",c="74.3S, 22.2W"},{l="The Watch-tower",c="76.2S, 21.4W"},{l="The White Hand Outpost",c="78.3S, 21.2W"}}},
		{name="Exploring the Gravenwood",flags={{l="The Tree of Tribute",c="81.0S, 11.2W"},{l="The Mustering Tree",c="80.1S, 11.6W"},{l="Rohirrim Scout-camp",c="80.9S, 10.6W"},{l="The Slade of Shadows",c="82.8S, 9.8W"},{l="Uvel-cadlus",c="78.1S, 11.4W"},{l="Rhuvel-cadlus",c="80.1S, 13.4W"},{l="Ak-ghru",c="84.2S, 10.5W"}}}
	}},	
	["79.jpg"] = {map="79.jpg", name="Gap of Rohan", c={n=81.3, w=-14.0, s=92.8, e=-1.8}, p="Dunland", region=1, lvl={min=72,max=73}, faction={"Theodred's Riders"}, epic={{"Volume III - Allies of the King",{"Book IV - Rise of Isengard"}}},craft={7},flags={
		{name="Exploring the Heathfells",flags={{l="Grimbold's Camp",c="87.8S, 3.9W"},{l="Dol Baran",c="88.4S, 6.8W"},{l="River-watch",c="89.2S, 3.7W"},{l="Pit of Iron\nInside point :\nSlave Stockades: [51.3N, 91.4W]\nThe Smelters: [50.7N, 92.4W]\nThe Underworkings: [50.8N, 93.0W]",c="86.1S, 3.7W"}}},
		{name="Exploring the Isendale",flags={{l="Forthbrond",c="87.0S, 7.4W"},{l="Cuvnerth",c="88.3S, 11.2W"},{l="Athdar",c="87.4S, 10.2W"},{l="Brontrig",c="89.7S, 7.5W"}}},
	}},		
	["80.jpg"] = {map="80.jpg", name="Nan Curunir", c={n=76.6, w=-7.1, s=86.1, e=2.6}, p="Dunland", region=1, lvl={min=74,max=75},flags={
		{name="Exploring Nan Curunir",flags={{l="Gates of Isengard",c="81.4S, 2.5W"},{l="Piller of the White Hand",c="84.9S, 3.0W"},{l="Fang-rider's Warren",c="81.6S, 4.8W"},{l="Blackmarch Fort",c="84.3S, 1.6W"},{l="Quickbeam's Grove",c="82.0S, 0.7E"},{l="Dagoras' Camp",c="84.9S, 3.4W"},{l="Ox-clan Merchant Camp",c="79.9S, 0.2E"}}},
	}},	
	["81.jpg"] = {map="81.jpg", name="The Great Delving", c={n=5.2, w=-116.7, s=10.0, e=-110.4}, p="Moria", region=2, lvl={min=51,max=51}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book II - Echoes in the Dark"}}},craft={6},flags={
		{name="The Great Delving",flags={{l="The Dolven-view",c="8.2S, 112.3W"},{l="The Dwarf-lords' Gate",c="6.4S, 112.0W"},{l="The Lonely Span",c="7.6S, 109.7W"},{l="The Stone Council",c="9.1S, 112.3W"},{l="Gazatmur",c="7.6S, 111.3W"},{l="Shemeldurj",c="7.3S, 114.8W"},{l="The Palace of Nain",c="6.9S, 113.0W"}}},
		{name="In the Footsteps of the Fellowship",flags={{l="Durin's Threshold",c="8.0S, 115.9W"}}}
	}},	
	["82.jpg"] = {map="82.jpg", name="Durin's Way", c={n=-1.4, w=-113.1, s=9.8, e=-99.1}, p="Moria", region=2, lvl={min=53,max=53}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book II - Echoes in the Dark","Book III - The Lord of Moria","Book IV - Fire and Water","Book V - Drums in the Deep","Book VI - The Shadowy Abyss","Book VIII - Scourge of Khazad-dum"}}},craft={6},flags={
		{name="Eastern Durin's Way",flags={{l="Jazargund",c="3.6S, 106.0W"},{l="Skoiruzg",c="3.6S, 109.2W"},{l="Hadad-dum",c="3.0S, 104.7W"},{l="Fehem-dum",c="4.1S, 104.6W"},{l="Tith-maudhul",c="2.7S, 101.8W"},{l="Gríshurbhrum",c="3.0S, 100.8W"},{l="Khulturg",c="2.7S, 100.1W"},{l="Dar-rukh",c="4.1S, 100.8W"}}},
		{name="Western Durin's Way",flags={{l="The Hall of the High Stair",c="4.7S, 112.0W"},{l="Gloku-ru",c="4.1S, 111.2W"},{l="Ninknakh Faltor ",c="3.6S, 112.9W"},{l="Tharakh Bazan",c="3.6S, 109.2W"},{l="Salab Nurjundul",c="3.6S, 107.5W"},{l="Uflump-mur",c="3.0S, 110.5W"}}},
		{name="In the Footsteps of the Fellowship",flags={{l="The Chamber of the Crossroads",c="5.1S, 112.1W"}}}
	}},
	["83.jpg"] = {map="83.jpg", name="The Silvertine Lodes", c={n=9.1, w=-115.2, s=13.6, e=-110.6}, p="Moria", region=2, lvl={min=52,max=52}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book II - Echoes in the Dark"}}},craft={6},flags={
		{name="The Silvertine Lodes",flags={{l="The Deep Descent",c="9.8S, 112.6W"},{l="Gamil Filik",c="10.4S, 111.2W"},{l="The Old Silvertine City",c="11.7S, 112.1W"}}},
		{name="Bulwarks of the Enemy",flags={{l="Menem-berej",c="11.0S, 112.8W"}}},
	}},	
	["84.jpg"] = {map="84.jpg", name="The Water-works", c={n=12.2, w=-117.6, s=19.3, e=-110.3}, p="Moria", region=2, lvl={min=54,max=54}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book IV - Fire and Water"}}},craft={6},flags={
		{name="The Water-works",flags={{l="The Rotting Cellar",c="15.1S, 112.1W"},{l="The Great Wheel",c="17.3S, 115.6W"},{l="Durin's Beard",c="13.6S, 112.6W"},{l="The Lost Palace",c="15.0S, 114.9W"},{l="The Chamber of the Pool",c="15.5S, 115.3W"},{l="The Chamber of Dark Waters",c="16.9S, 111.9W"},{l="The Lost Treasury",c="17.3S, 111.0W"},{l="Narag-kheleb",c="17.2S, 114.7W"},{l="The Chamber of Memory",c="18.2S, 111.6W"}}},
		{name="Bulwarks of the Enemy",flags={{l="Harazgund",c="17.6S, 116.9W"}}},
	}},		
	["85.jpg"] = {map="85.jpg", name="Zelem-Melek", c={n=4.5, w=-110.8, s=13.2, e=-102.0}, p="Moria", region=2, lvl={min=57,max=59}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book III - The Lord of Moria","Book IV - Fire and Water","Book V - Drums in the Deep"}}},craft={6},flags={
		{name="Zelem-melek",flags={{l="Mudmul-charaf",c="6.4S, 108.5W"},{l="Hall of Flowing Water",c="9.1S, 107.7W"},{l="Gabil-mamach",c="9.0S, 107.2W"},{l="Gabil-hul",c="9.7S, 108.7W"},{l="The Great Hall of Durin",c="7.8S, 106.1W"},{l="Uzbad-bakan",c="10.5S, 107.9W"}}},
		{name="In the Footsteps of the Fellowship",flags={{l="The Twenty-first Hall",c="6.1S, 105.3W"},{l="Chamber of Mazarbul",c="4.7S, 105.3W"}}}
	}},		
	["86.jpg"] = {map="86.jpg", name="Flaming Deeps", c={n=13.1, w=-111.0, s=17.6, e=-105.9}, p="Moria", region=2, lvl={min=57,max=57}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book IV - Fire and Water"}}},craft={6},flags={
		{name="Flaming Deeps",flags={{l="Anazarmekhem",c="13.4S, 108.1W"},{l="The Burning Stair",c="15.8S, 110.6W"},{l="The Crossroads of Ash",c="15.8S, 109.6W"},{l="Gate of the Seven Fathers",c="15.8S, 108.6W"},{l="Hadad-mezer",c="14.7S, 107.6W"},{l="Hurmulkezer",c="17.0S, 107.1W"},{l="Hudnul-meden",c="16.8S, 109.6W"}}},
		{name="Bulwarks of the Enemy",flags={{l="The Forges of Khazad-dum",c="17.0S, 109.8W"},{l="Fil Gashan",c="17.1S, 109.9W"}}},
	}},				
	["87.jpg"] = {map="87.jpg", name="The Redhorn Lodes", c={n=9.8, w=-107.6, s=15.8, e=-101.1}, p="Moria", region=2, lvl={min=56,max=56}, faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book IV - Fire and Water","Book V - Drums in the Deep"}}},craft={6},flags={
		{name="The Redhorn Lodes",flags={{l="The Orc-watch",c="11.3S, 106.7W"},{l="Sigin-tharakh",c="10.1S, 101.1W"},{l="The Tailing Pit",c="10.3S, 105.8W"},{l="Menem-mezel",c="12.0S, 105.7W"},{l="Malmezel",c="12.2S, 106.2W"},{l="Ashpar's Command",c="11.4S, 103.5W"},{l="Budkhul-beken",c="10.8S, 103.2W"}}},
		{name="Bulwarks of the Enemy",flags={{l="The Gate of Ruin",c="10.2S, 103.9W"}}},
	}},				
	["88.jpg"] = {map="88.jpg", name="The Foundations of Stone", c={n=10.9, w=-102.1, s=16.2, e=-95.9}, p="Moria", region=2, lvl={min=59,max=60},faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book VI - The Shadowy Abyss"}}},craft={6},flags={
		{name="The Foundations of Stone",flags={{l="The Shadowed Refuge",c="12.9S, 100.9W"},{l="The Endless Stair",c="15.0S, 99.0W"},{l="The Bridge-shard",c="14.1S, 97.7W"},{l="Zabad-fakak",c="11.9S, 101.4W"},{l="Dalgum-ru",c="14.2S, 101.6W"}}},
		{name="Bulwarks of the Enemy",flags={{l="Skumfil",c="13.2S, 100.4W"},{l="Dark Delvings",c="15.9S, 97.3W"}}},
	}},					
	["89.jpg"] = {map="89.jpg", name="Zirakzigil", c={n=-17.0, w=-112.1, s=-12.0, e=-106.9}, p="Moria", region=2, lvl={min=54,max=54},faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book VII - The Leaves of Lorien"}}},craft={6},flags={
		{name="The Cliffs of Zirakzigil",flags={{l="The Door to the Clouds",c="2.8S, 110.8W"},{l="The Broken Cleft",c="13.4N, 109.1W"},{l="Durin's Bane",c="14.9N, 108.7W"}}},
	}},					
	["90.jpg"] = {map="90.jpg", name="Nud-Melek", c={n=48.0, w=-104.4, s=11.8, e=-95.4}, p="Moria", region=2, lvl={min=54,max=54},faction={"Iron Garrison Miners","Iron Garrison Guards"}, epic={{"Volume II - Mines of Moria",{"Book V - Drums in the Deep"}}},craft={6},flags={
		{name="Nud-Melek",flags={{l="Khadar-zaram",c="8.0S, 103.6W"},{l="The Deep Crossroad",c="6.3S, 101.1W"},{l="Khurjezer",c="7.3S, 100.9W"},{l="Sudulthurkh",c="5.6S, 99.2W"}}},
		{name="In the Footsteps of the Fellowship",flags={{l="First Hall",c="8.0S, 96.3W"},{l="Bridge of Khazad-dum (west arch)",c="8.0S, 99.2W"},{l="Bridge of Khazad-dum (east arch)",c="8.0S, 98.6W"}}},
		{name="Bulwarks of the Enemy",flags={{l="The Sixteenth Hall",c="11.1S, 101.0W"}}},
	}},					
	["91.jpg"] = {map="91.jpg", name="Entwood", c={n=37.8, w=-85.5, s=44.1, e=-77.0}, region=2, lvl={min=95,max=95},faction={"The Ents of Fangorn Forest"}, epic={{"Volume II - Mines of Moria",{"Book XIV - The Waters of Isengard"}}},craft={6},flags={
		{name="Entwood",flags={{l="Wellinghall",c="38.3S, 85.3W"},{l="The Easeful Mead",c="38.4S, 79.2W"},{l="Derndingle",c="42.4S, 79.1W"}}}
	}},
	["92.jpg"] = {map="92.jpg", name="Eastfold", c={n=60.9, w=-66.8, s=76.1, e=-51.1}, p="West Rohan", region=2, lvl={min=87,max=89},faction={"The Eorlingas","The Helmingas"}, epic={{"Volume III - Allies of the King",{"Book XII - War in the Westemnet"}}},craft={9},flags={
		{name="Eastfold Exploration",flags={{l="Aldburg",c="68.7S, 63.9W"},{l="Fenmarch",c="66.5S, 57.8W"},{l="Beaconwatch",c="69.6S, 57.4W"},{l="Folde Farm",c="67.2S, 63.2W"},{l="Gris-shatroful",c="68.0S, 60.0W"},{l="Dorr-shatroful",c="74.1S, 58.7W"}}}
	}},
	["93.jpg"] = {map="93.jpg", name="Kingstead", c={n=52.2, w=-83.7, s=74.5, e=-61.0}, p="West Rohan", region=2, lvl={min=85,max=87},faction={"The Eorlingas","The Helmingas"}, epic={{"Volume III - Allies of the King",{"Book XI - The Golden Hall"}},{"Volume IV - The Strength of Sauron",{"Book I - The Road to Gondor"}}},craft={9},flags={
		{name="Kingstead Exploration",flags={{l="Folcbur's Homestead",c="56.0S, 72.0W"},{l="Edoras",c="60.8S, 74.2W"},{l="Entwade",c="56.0S, 65.8W"},{l="Middlemead",c="53.7S, 72.5W"},{l="Upbourn",c="65.5S, 72.9W"},{l="Dunharrow",c="71.2S, 71.2W"},{l="Underharrow",c="67.3S, 73.7W"},{l="Dimholt",c="72.5S, 69.6W"},{l="The Dark Door",c="73.3S, 69.3W"},{l="Pendlac's Farm",c="61.0S, 67.8W"},{l="Bosa's Farm",c="53.7S, 68.6W"}}}
	}},
	["94.jpg"] = {map="94.jpg", name="Broadacres", c={n=42.2, w=-75.7, s=53.3, e=-62.3}, p="West Rohan", region=2, lvl={min=89,max=91},faction={"The Eorlingas","The Helmingas"}, epic={{"Volume III - Allies of the King",{"Book XII - War in the Westemnet"}}},craft={9},flags={
		{name="Broadacres Exploration",flags={{l="Oserley",c="45.9S, 67.0W"},{l="Snagfen",c="47.3S, 65.9W"},{l="Tordag's Camp",c="45.7S, 72.2W"},{l="Torsbury",c="45.2S, 73.2W"},{l="Bardh-doram",c="48.8S, 73.8W"},{l="East Fangorn",c="43.4S, 72.5W"},{l="Stoke",c="49.2S, 69.6W"}}}
	}},	
	["95.jpg"] = {map="95.jpg", name="Stonedeans", c={n=44.9, w=-85.9, s=58.7, e=-71.8}, p="West Rohan", region=2, lvl={min=91,max=93},faction={"The Eorlingas","The Helmingas"}, epic={{"Volume III - Allies of the King",{"Book XII - War in the Westemnet"}}},craft={9},flags={
		{name="Stonedeans Exploration",flags={{l="Woodhurst",c="47.6S, 79.1W"},{l="Brockbridge",c="50.8S, 77.7W"},{l="Gapholt",c="53.7S, 83.7W"},{l="Roaring Hills",c="48.6S, 76.2W"},{l="Madh-Fushaum",c="54.4S, 78.4W"},{l="Orlag Den",c="47.5S, 80.7W"},{l="Wid Isernore",c="47.9S, 81.2W"},{l="Mate Isernore",c="50.2S, 82.5W"},{l="Flodgeheld",c="53.6S, 80.7W"}}}
	}},		
	["96.jpg"] = {map="96.jpg", name="Westfold", c={n=53.0, w=-92.4, s=68.7, e=-76.1}, p="West Rohan", region=2, lvl={min=93,max=95},faction={"The Eorlingas","The Helmingas"}, epic={{"Volume III - Allies of the King",{"Book XII - War in the Westemnet", "Book XIII - Helm's Deep","Book XIV - The Waters of Isengard"}}},craft={9},flags={
		{name="Westfold Exploration",flags={{l="Marton",c="56.0S, 85.6W"},{l="Marton's Refugees",c="53.8S, 85.5W"},{l="Grimslade",c="62.3S, 82.0W"},{l="Marton Farmlands",c="56.8S, 87.2W"},{l="Shatorthum",c="53.6S, 87.2W"},{l="Fushum Raus",c="63.3S, 80.9W"},{l="The Fords of Isen",c="54.4S, 89.6W"},{l="Lufut-mos",c="53.7S, 88.8W"},{l="Erkenbrand's Refuge",c="56.5S, 90.5W"}}}
	}},
	["97.jpg"] = {map="97.jpg", name="King's Gondor", c={n=53.5, w=-50.5, s=87.2, e=-15.3}, region=3, lvl={min=140,max=140}, faction={"The Renewal of Gondor"}, epic={{"The Song of Waves and Wind", {"Chapter 1 - The Heirs of Castamir"}}},craft=14,flags={
		{name="Stragglers and New Threats in Lossarnach",flags={{l="Ost Norhir",c="75.7S, 21.2W"},{l="Galdir's Dell",c="76.9S, 21.4W"},{l="Aegollant",c="78.6S, 23.1W"},{l="Erui Delta",c="80.8S, 24.0W"},{l="Taustrok",c="70.6S, 21.9W"}}},
		{name="Reclaiming Lossarnach",flags={{l="Arnach",c="76.6S, 24.4W"},{l="Imloth Melui",c="73.2S, 24.3W"},{l="Nan Harlond",c="74.3S, 21.0W"},{l="Rammas Echor",c="71.9S, 19.4W"},{l="The Harlond",c="72.6S, 20.2W"}}},
		{name="Stragglers and New Threats in Upper Lebennin",flags={{l="Grafeleg",c="74.2S, 30.6W"},{l="Lhingar",c="75.5S, 26.4W"},{l="Sadukh's Camp",c="77.4S, 27.8W"},{l="Mushex's Camp",c="80.7S, 25.7W"},{l="Harba's Camp",c="82.4S, 29.6W"},{l="Bukhad's Camp",c="81.4S, 31.8W"}}},
		{name="Reclaiming Upper Lebennin",flags={{l="Minlos",c="76.5S, 26.1W"},{l="Halach",c="81.5S, 26.7W"},{l="Glaniath",c="80.5S, 29.8W"},{l="Tumladen",c="77.0S, 28.9W"},{l="Pelargir",c="82.8S, 31.7W"},{l="Sirthanc",c="79.3S, 32.0W"}}},
		{name="Stragglers and New Threats in Lower Lebennin",flags={{l="Lornost",c="80.0S, 34.4W"},{l="Tham Aklam",c="80.8S, 36.8W"},{l="Hata Kebir",c="84.5S, 37.2W"},{l="Ruins of Ethillorn",c="83.8S, 45.6W"},{l="Orlach's Ghyll",c="75.1S, 36.1W"}}},
		{name="Reclaiming Lower Lebennin",flags={{l="Erynos",c="80.1S, 32.8W"},{l="Ost Anglebed",c="79.0S, 39.1W"},{l="Malbarth",c="80.1S, 42.4W"},{l="Linhir",c="82.0S, 45.4W"},{l="Sarnhad",c="81.6S, 43.9W"},{l="Zarsatrad",c="77.8S, 34.6W"},{l="Furukzahar",c="70.9S, 35.3W"}}},
	}},
};